commit a7bcf2036b34d5043dbc33fee7d98bae5859c4d3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Feb 11 11:31:48 2022 +0100

    release: bump version to 1.18.6

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 3eb3e3d63710087836848de5278496826ab940dc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Feb 11 11:31:14 2022 +0100

    NEWS: update for 1.18.6

 NEWS | 43 +++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 43 insertions(+)

commit be9b04a03382dc78ba927899eab700e8476e8723
Author: Xeonacid <h.dwwwwww@gmail.com>
Date:   Wed Dec 22 12:17:22 2021 +0000

    build,meson: Remove incorrect args for i18n.merge_file

    `i18n.merge_file` has been ignoring positional arguments for a time
    and explicitly rejects with error since meson 0.60.0.

    (cherry picked from commit 922bc2df5f9242c8052abbab08ceddeef9e20de9)

 data/meson.build | 1 -
 1 file changed, 1 deletion(-)

commit 030372d990d103ae12e8fda1562290693ee9138d
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Feb 6 18:49:16 2022 +0100

    quectel: add name to device IDs

    fwupd expects device IDs which are unique for each device and its
    variants. However, Quectel re-uses the same USB VID & PID among
    different variants such as EG25, EC25, EC20, etc. Moreover, each
    variant may have subvariants such as EG25GGB, EG25GGC, EG25AFF,
    EG25AFX, etc.

    Add the name of the modem to the device IDs to build more unique
    device
    IDs such as USB\VID_2C7C&PID_0125&REV_0001&NAME_EC25GGB.

    (cherry picked from commit b70fd64417d8fbed10aa1eb5e5c720fcf1074782)

 plugins/quectel/mm-shared-quectel.c | 87
 +++++++++++++++++++++++++++++++------
 1 file changed, 74 insertions(+), 13 deletions(-)

commit 1a9b7d2ee0a7902715c6db95dd9892647a5c6784
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Feb 6 18:47:24 2022 +0100

    iface-modem-firmware: expose device id builder

    Expose the generic device id method as a public API for plugins.
    Plugins can call this method first and then add their own device
    ids on
    top in case the generic ones aren't specific enough like in the
    case of
    Quectel modems.

    (cherry picked from commit 90397fa1bbae2297aca169f8fbfa981fa0f5d4e6)

 src/mm-iface-modem-firmware.c | 39
 +++++++++++++++++++++------------------
 src/mm-iface-modem-firmware.h |  4 ++++
 2 files changed, 25 insertions(+), 18 deletions(-)

commit 8b901058dd5723d54d2b045ae672e1c6dd24e47e
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Feb 6 18:44:12 2022 +0100

    libmm-glib,firmware-update-settings: setter for method

    Allow to set the firmware update method even after
    initialization of the MMFirmwareUpdateSettings object.

    (cherry picked from commit bdf4d898f6a490ce2c1c9dc41871c4baced1e37b)

 docs/reference/libmm-glib/libmm-glib-sections.txt |  1 +
 libmm-glib/mm-firmware-update-settings.c          | 12 ++++++++++++
 libmm-glib/mm-firmware-update-settings.h          | 10 ++++++----
 3 files changed, 19 insertions(+), 4 deletions(-)

commit 4805251f2d374f54f18c73b3526ee29342a0d03e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jan 31 23:11:11 2022 +0100

    broadband-modem-mbim: minor alignment fix

    (cherry picked from commit 8ae31be1beffec3c7642dfa4bad5fbb447c763b8)

 src/mm-broadband-modem-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3265f184bcd05c5ceb79573a64592a2bd290dbd0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jan 31 22:42:48 2022 +0100

    shared-qmi: filter out modes not currently available

    Do not build the mask of "all" modes based only on the supported radio
    interfaces, also filter out those modes that would not be available
    based on the current capabilities enabled.

    (cherry picked from commit 9c08e54fb9d2f0b9341c2c98291551d8c9917c78)

 src/mm-shared-qmi.c                | 8 ++++++++
 src/tests/test-modem-helpers-qmi.c | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 7d5a8db27339bff91b5f0b0320ae714c890c6344
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jan 31 22:34:56 2022 +0100

    modem-helpers-qmi: multimode devices shouldn't always have 4G/5G
    only modes

    In GSM/UMTS+CDMA/EVDO multimode devices, the 4G and 5G mode switching
    operations are exclusively limited to the capability selection that
    has LTE+5GNR exclusively.

    We cannot allow switching to 4G-only, 5G-only or 4G+5G if the current
    capabilities have GSM/UMTS or CDMA/EVDO.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/503

    (cherry picked from commit c7ff014e07ee5bfcfa4ba7e235c1c234ad77245a)

 src/mm-modem-helpers-qmi.c         | 65
 +++++++++++++++++++-------------------
 src/mm-modem-helpers-qmi.h         |  8 +++++
 src/mm-shared-qmi.c                |  9 ++++++
 src/tests/test-modem-helpers-qmi.c | 51 ++++++++++++++++++++++++++++++
 4 files changed, 101 insertions(+), 32 deletions(-)

commit 0b0362054a004e6313bdbdd4a544b5004275d336
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 23:04:15 2022 +0100

    tests,modem-helpers-qmi: add tests for supported modes loading

    (cherry picked from commit ccf0b7eba2bf2abc2c81e5d68dc5872a15b515c2)

 src/tests/test-modem-helpers-qmi.c | 473
 +++++++++++++++++++++++++++++++++++++
 1 file changed, 473 insertions(+)

commit 53b0095cbfd96131e706365465804eb0bf7b56b0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 21:33:38 2022 +0100

    modem-helpers-qmi: new helper to build array of supported modes

    (cherry picked from commit b323a731370be607f2529b1df976ec64a4f7c2e8)

 src/mm-modem-helpers-qmi.c |  96 +++++++++++++++++++++++++++++++++++++++
 src/mm-modem-helpers-qmi.h |  17 +++++++
 src/mm-shared-qmi.c        | 110
 +++++----------------------------------------
 3 files changed, 125 insertions(+), 98 deletions(-)

commit 8270de785debce715e194cfe41df4e66618cf8be
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 17:48:50 2022 +0100

    tests,modem-helpers-qmi: add additional tests for supported
    capabilities loading

    Including tests for 5G-only and non-multimode 5G+4G and 5G+4G+3G
    devices.

    (cherry picked from commit 6efde107142692996a5b9f44f323710baa8f40bc)

 src/tests/test-modem-helpers-qmi.c | 270
 ++++++++++++++++++++++++++++++++++---
 1 file changed, 250 insertions(+), 20 deletions(-)

commit 888da10d8f0ba5b0d58c4ab4966d1e7be828a1a4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 17:43:34 2022 +0100

    tests,modem-helpers-qmi: add tests for supported capabilities loading

    (cherry picked from commit ff51fe637d8a87b265f9cf4558987d2e698e9e62)

 src/tests/test-modem-helpers-qmi.c | 217
 +++++++++++++++++++++++++++++++++++--
 1 file changed, 207 insertions(+), 10 deletions(-)

commit 680edfa2253c92d46f24455f741ee20fe8b2a931
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 17:11:31 2022 +0100

    modem-helpers-qmi: new helper to build array of supported capabilities

    (cherry picked from commit d0c87c5877b247ee34fb133604904404581e7814)

 src/mm-modem-helpers-qmi.c | 45
 +++++++++++++++++++++++++++++++++++++++++-
 src/mm-modem-helpers-qmi.h | 15 ++++++++++++++
 src/mm-shared-qmi.c        | 49
 +++++++++++-----------------------------------
 3 files changed, 70 insertions(+), 39 deletions(-)

commit dcd0b5826add3f0086ce2cbb9e944cce4ee0a7d4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jan 30 16:51:07 2022 +0100

    modem-helpers-qmi: refer explicitly to current capabilities in
    helper method

    The helper method for which we have unit tests available refers
    exclusively to the current capabilities loading, so rename it to
    clarify that.

    (cherry picked from commit f370c096ec53c35e9b28a4ba966eade42c07f375)

 src/mm-modem-helpers-qmi.c         |   4 +-
 src/mm-modem-helpers-qmi.h         |   6 +-
 src/mm-shared-qmi.c                |  10 +--
 src/tests/test-modem-helpers-qmi.c | 179
 ++++++++++++++++++-------------------
 4 files changed, 98 insertions(+), 101 deletions(-)

commit 5aed9da9858bc6b78170df5d00ecc310801944a8
Author: Prakash Pabba <quic_ppabba@quicinc.com>
Date:   Fri Jan 21 16:45:14 2022 +0530

    test-modem-helpers-qmi: add unit test for generic 5g modem

    (cherry picked from commit 23229888553fd453797da89c12605aa40f3ba378)

 src/tests/test-modem-helpers-qmi.c | 135
 ++++++++++++++++++++++++++++++++++---
 1 file changed, 126 insertions(+), 9 deletions(-)

commit 39a527f9912af7bfa47b2e63d1b2cc4a38295296
Author: Prakash Pabba <quic_ppabba@quicinc.com>
Date:   Thu Dec 16 14:02:01 2021 +0530

    test-modem-helpers-qmi: Fix tests for UML290

    Change due to update in current capabilities loading logic.

    (cherry picked from commit 3a1390f1dda4acf73dc8bec8d2ccf9dcddfcf5c4)

 src/tests/test-modem-helpers-qmi.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 2ca9c262c746bfa83e9086b69045d190c21d637c
Author: Prakash Pabba <quic_ppabba@quicinc.com>
Date:   Tue Dec 14 14:25:45 2021 +0530

    mm-shared-qmi,mm-modem-helpers: Fix supported capabilities and modes
    for multimode device

    We use capability switching logic exclusively for configuring
    GSM/UMTS+CDMA/EVDO devices
    (regardless of whether it has LTE/5GNR or not) to add or remove the
    GSM/UMTS and CDMA/EVDO
    capabilities.

    Based on the same logic, we will allow 4 combinations for
    GSM/UMTS+CDMA/EVDO+LTE+5GNR device:
    "GSM/UMTS+CDMA/EVDO+LTE+5GNR", "GSM/UMTS+LTE+5GNR",
    "CDMA/EVDO+LTE+5GNR" and "LTE+5GNR"

    Similarly, we will allow 4 combinations for GSM/UMTS+CDMA/EVDO+LTE
    device:
    "GSM/UMTS+CDMA/EVDO+LTE", "GSM/UMTS+LTE", "CDMA/EVDO+LTE" and "LTE"

    And, we will allow 3 combinations for GSM/UMTS+CDMA/EVDO device:
    "GSM/UMTS+CDMA/EVDO", "GSM/UMTS" and "CDMA/EVDO"

    Also, supported combination modes should be based on current
    capabilities and not entirely
    upon supported radio interfaces.

    1) If current capability has "gsm-umts" or "cdma-evdo" or both, do not
       support 4G only, 5G only, or 4G+5G combination modes
    2) If current capability neither has "gsm-umts" nor "cdma-evdo",
    only support
       combination modes involving 4G and 5G.

    (cherry picked from commit 38f067c4e44d7f994c3fd75e29d36ee199002ff4)

 src/mm-modem-helpers.c | 10 +-----
 src/mm-shared-qmi.c    | 84
 ++++++++++++++++++++++++--------------------------
 2 files changed, 41 insertions(+), 53 deletions(-)

commit 8d737cc6482a9d6e409d9d80936b448dd1af0b7b
Author: Prakash Pabba <quic_ppabba@quicinc.com>
Date:   Thu Dec 9 16:54:54 2021 +0530

    mm-modem-helpers-qmi: Fix current capabilities for multimode device

    Keep LTE or 5GNR always in current capabilities if supported by
    device.

    Since capability switching logic is exclusively used for configuring
    GSM/UMTS+CDMA/EVDO devices, decide if to have GSM/UMTS or CDMA/EVDO
    or both
    or none when loading current capabilities.

    (cherry picked from commit f05258e757558b93559b4d36087e89ec926c5423)

 src/mm-modem-helpers-qmi.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ec3eb3283541ad73cd0f99c29c451911399a360e
Author: Michal Mazur <mkm@semihalf.com>
Date:   Thu Jan 27 16:07:07 2022 +0100

    iface-modem: make update_unlock_retries method static

    (cherry picked from commit 9843546a490c34bf0f8adb1bcce9503eccbb3115)

 src/mm-iface-modem.c | 8 ++++----
 src/mm-iface-modem.h | 3 ---
 2 files changed, 4 insertions(+), 7 deletions(-)

commit cf7533caa854b1ff12226261f64e2fb27206edfb
Author: Michal Mazur <mkm@semihalf.com>
Date:   Wed Dec 15 16:07:36 2021 +0100

    sim-mbim,broadband-modem-mbim: store number of remaining attempts

    On MBIM modems the type of PIN cannot be specified in MBIM_CID_PIN
    query
    command and the modem responds only remaining attempts for the
    currently
    active lock.
    If PIN1 is unlocked and user tries to disable (or enable) it, MM won't
    get an update of remaining attempts in response to PIN Query. This
    value
    is returned only after the Set command and MM need to store it in
    all (pin/puk)_set_(enter/enable/change)_ready functions.

    Previous solution was to call the mm_iface_modem_update_unlock_retries
    directly from these functions but it caused the notification to
    be send
    too early and invalid number was displayed to user sometimes.
    Instead of this MM will store numbers of remaining attempts and send
    them in a single notification from modem_load_unlock_retries.

    (cherry picked from commit 5d4957935ba17c7c24ae92b82fc3fb90851f3235)

 src/mm-broadband-modem-mbim.c | 67
 +++++++++++++++++--------------------------
 src/mm-broadband-modem-mbim.h |  4 +++
 src/mm-sim-mbim.c             | 11 ++-----
 3 files changed, 33 insertions(+), 49 deletions(-)

commit 5788f52e50fd2325e072717bd63b063f156b19f2
Author: Michal Mazur <mkm@semihalf.com>
Date:   Thu Dec 16 14:11:23 2021 +0100

    Revert "mm-sim-mbim: Remove update of remaining attempts"

    This reverts commit 46c5cd8b7279e6139466664f87d744a0553fa1c3.

    (cherry picked from commit ee87a6853228e0b4b5e6c132f0c90e8d094af441)

 src/mm-sim-mbim.c | 53
 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 53 insertions(+)

commit 08ad95ce9872957a9e4c0956ff2f756d963f4018
Author: Nagi Marupaka <nmarupaka@google.com>
Date:   Tue Jan 25 17:32:48 2022 +0000

    mm-kernel-device-helpers: fix memory leak

    Newly refactored string manipulation function is leaking memory as per
    our tests. This submission fixes that memory leak.

    (cherry picked from commit 73e3da3a1035deb8a748d162c52281f94a537904)

 src/kerneldevice/mm-kernel-device-helpers.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 85becf883be55639c8725d29095269f9cfbd96d4
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Jan 26 16:37:57 2022 +0100

    build,meson: Fix gdbus code generation

    Changes on meson 0.61 makes the build to fail due to empty
    annotations in some gdbus code generation[0].

    Taking advantage of `kwargs` support, it has been changed to avoid
    the issue.

    Fixes #499

    [0]
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/499

    (cherry picked from commit 0ab9fc343fdc21235bc24c80c78a13b1ea078208)

 libmm-glib/generated/meson.build | 24 +++++++++++-------------
 1 file changed, 11 insertions(+), 13 deletions(-)

commit 259f2eedd62a6895f5282b3e1666ca8480a38c7c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jan 22 14:38:22 2022 +0100

    plugin-manager: longer extra probing time when not using udev

    When using udev, we rely on the kernel to timely report port additions
    in the same device.

    When not using udev, e.g. when using hotplug scripts in openwrt, we
    use mmcli --report-kernel-event operations to report the port
    additions, which may end up requiring much more time to process,
    especially during bootup as we would be reporting a lot of port
    addition events one after the other.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/493

    (cherry picked from commit 86496bd326f2ec139101049fb19a10b255ee8ad5)

 src/mm-plugin-manager.c | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit 5d28712d2cc5c17d784f658cdfad73490ff818da
Author: Daniele <dnlplm@gmail.com>
Date:   Fri Jan 21 17:52:38 2022 +0100

    telit: add port hints for Telit LE910C1-EUX

    (cherry picked from commit 9bc084c94a797bf9fd364087cf8d2b838120cd18)

 plugins/telit/77-mm-telit-port-types.rules | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 279d41f7459d4eae51284b090b2728082f8d5a26
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jan 20 13:46:23 2022 +0100

    foxconn: firmware info loading only if MBIM-QMUX enabled in libqmi

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/477

    (cherry picked from commit 6ec97a29ae79636f3bf63e616e0b3904befa1dbd)

 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit c40382dbe238e73452abf78581783e662c71afcf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jan 18 10:29:45 2022 +0100

    quectel: fix reference cycle

    The 'update_settings' object must be referenced before the task
    is completed.

    (cherry picked from commit c9ffa2c9e5bb1168210f9b6b1acdace778ee175a)

 plugins/quectel/mm-shared-quectel.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 2bea70a78c54a616072dd637e42f17dfe1f9b159
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Mon Dec 27 17:59:53 2021 +0100

    plugins/quectel/mm-shared-quectel: use QGMR to set version

    Quectel modems report only their major firmware version through
    AT+GMR, use AT+QGMR instead to report the full firmware version.

    (cherry picked from commit 07d7f596d381ae1bc823c1a3b3b2707d17a0ad61)

 plugins/quectel/mm-shared-quectel.c | 31 +++++++++++++++++++++++++++++--
 1 file changed, 29 insertions(+), 2 deletions(-)

commit 59c46dcc92666e556e71bb62552bbaadd1cc2eb1
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Dec 26 11:35:55 2021 +0100

    plugins/quectel/mm-broadband-modem-qmi-quectel: ignore carrier
    revision

    Quectel EG25-G QMI modem firmware revisions are not matched with
    carrier configs.
    Different VoLTE profiles might be selected by the user causing
    the carrier config revision to change.

    Since fwupd uses this string for firmware updates, it gets confused
    and
    thinks the user has an update available.

    (cherry picked from commit 3f76b3b7d1abe10d2809c80891789cde81de5fa2)

 plugins/quectel/mm-broadband-modem-qmi-quectel.c | 2 ++
 1 file changed, 2 insertions(+)

commit c4a18113027b69ca31ea611105b479c798309653
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jan 7 21:30:57 2022 +0100

    libmm-glib,modem-3gpp: fix leak when processing scan results

    (cherry picked from commit 4515b00020bdf173ca3ae7434a3abc0d287f93d6)

 libmm-glib/mm-modem-3gpp.c | 2 ++
 1 file changed, 2 insertions(+)

commit d177d54d5d579a960abd66c03f64fc17483483a7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jan 7 16:26:27 2022 +0100

    iface-modem-3gpp: fix variant ref handling in scan output

    (cherry picked from commit fb0dfb875172225d3bb82906a49118ceb7f938ba)

 src/mm-iface-modem-3gpp.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 714ce29110a478806cc9ba18ec81a2b67f53d3f6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Nov 3 14:02:33 2021 +0100

    docs,libmm-glib: add missing references to
    object_{peek|get}_modem_ssr()

    (cherry picked from commit 61266a4e848d2ac0acd170b3756aced44a26af1b)

 docs/reference/libmm-glib/libmm-glib-sections.txt | 2 ++
 1 file changed, 2 insertions(+)

commit c143f8eefc3049d5420cf6752d2d4fc9f553ef93
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Dec 17 10:08:07 2021 +0100

    iface-modem: minor coding style changes

    (cherry picked from commit 59c79b07ae602d3664fb5098cc42f998bc644193)

 src/mm-iface-modem.c | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit d872ddc92f9d544b5ffb04dcb1bf431ce3ef7d00
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Dec 17 11:20:57 2021 +0100

    cli: fix 3GPP location mcc/mnc field names

    (cherry picked from commit 791fb38417566b3cbde2450000049bd62c356305)

 cli/mmcli-output.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3a505f802fd314510fc2b5a97844dd879d09e6d4
Author: Jakob Hauser <jahau@rocketmail.com>
Date:   Mon Dec 20 05:10:14 2021 +0100

    broadband-modem-qmi: Introduce udev flag for reduced facility
    lock query

    The udev flag "ID_MM_QMI_FACILITY_LOCK_QUERY_REDUCED" allows to skip
    facility lock state query "get_ck_status" on the DMS path for devices
    where this isn't implemented properly.

    On devices that have enabled "device locks", this flag won't work
    well.
    Skipping the query doesn't disable the locks.

    Fixes #448

    (cherry picked from commit db228b28597c002174145c4a06b94a24f5dbdf9b)

 src/mm-broadband-modem-qmi.c | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit 508495966068b02daec93d8191f6f7469619b7a2
Author: Mingjie Zhang <superzmj@fibocom.com>
Date:   Thu Dec 9 20:48:50 2021 +0800

    fibocom: update FM101 port type hints to final layout

    The port type hints for the FM101 were updated to be in line with
    the final product layout,
    where USB interface #2 is now used as an AT port (not ignored)
    and USB interface #4 is now
    used as debug port. USB interface #6 is removed as it no longer
    exists.

    (cherry picked from commit 2bad8f5a0dc56b82cacc0982a15c2a32016f7975)

 plugins/fibocom/77-mm-fibocom-port-types.rules | 12 +++++-------
 1 file changed, 5 insertions(+), 7 deletions(-)

commit a470b02f12f95679705eec28f2d7d5f0e2224f35
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Wed Nov 10 20:19:47 2021 +0800

    plugins: add fibocom FM101 to fibocom port types rules file

    This patch add fibocom FM101 to 77-mm-fibocom-port-types.rules file.
    which contains two sets of vid and pid pairs, "2cb7:01a2" and
    "2cb7:01a4".

    (cherry picked from commit 3a880fd832a2826f812aef451e40c8f1241dccff)

 plugins/fibocom/77-mm-fibocom-port-types.rules | 24
 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit 3e28b6829d3860f24f3acdc498e3670a47af8076
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Dec 8 14:30:08 2021 +0100

    filter: allow 'option' string in the TTY driver filter list

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/475

    (cherry picked from commit 559df16debd03d0ba00a68633f43cbda32f4aa8a)

 src/mm-filter.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 74f0caaaec000860d7c7ce1e795da67441ee6009
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Dec 1 21:40:00 2021 +0100

    udev: avoid [0-9]* as shell globbing patterns

    The udev rules expect matches based on shell globbing pattern, not
    based on regex. This means that "[0-9]*" doesn't mean "zero or more
    digits", it actually means "one digit and zero or more other
    characters".

    So, avoid the regex like match, even if it worked for us, because it
    didn't mean what we thought it meant, plus, it breaks our custom udev
    rules processing logic, in which we convert the input patterns into
    real regex expressions.

    See https://bbs.archlinux.org/viewtopic.php?pid=1415916#p1415916

    While at it, also make sure that the wildcard matching is done
    exclusively for prefix and suffix matches, never in the middle of
    a string, or our custom rules parser would not match correctly.

    (cherry picked from commit e9f254ba3f923248efffe4fd458dc5e5469e0f73)

 plugins/qcom-soc/77-mm-qcom-soc.rules | 8 ++++----
 src/80-mm-candidate.rules             | 2 +-
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 2a6b6b22bfc351479e4692508924dcee3a9c0a23
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 26 10:43:38 2021 +0100

    build: post-release version bump to 1.18.5

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit ac6d31e463168e894269d2a7c949de4577026eea
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 26 10:17:53 2021 +0100

    release: bump version to 1.18.4

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 941b9c1d185df8753b5950ea593d9b5fa9eac1e7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Nov 26 10:17:26 2021 +0100

    NEWS: update for 1.18.4

 NEWS | 82
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 82 insertions(+)

commit 80d62f2f68bff8b55026fc7e815603394ad729ec
Author: Matthew Via <via@matthewvia.info>
Date:   Sat Oct 23 18:23:32 2021 -0400

    sms-part-cdma: merge WDP multipart CDMA WAP messages.

    CDMA WAPs have multipart message information in a 3 byte header
    in-band
    with the user data, as described in WAP-259-WDP-20010614-a.  Set the
    message concat parameters and use the message-id as the reference.

    (cherry picked from commit 6db9a48c343690c808aea92e29daf13e021d3fc8)

 src/mm-sms-part-cdma.c | 30 ++++++++++++++++++++++++++++++
 src/mm-sms-part.c      |  3 +++
 src/mm-sms-part.h      |  4 ++++
 3 files changed, 37 insertions(+)

commit 7a90b42035d3b11d9da6fee8f3edd2c3749cd617
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 22 14:03:48 2021 +0100

    libmm-glib,modem: fix warning when loading SIM slots

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/465

    (cherry picked from commit d2b620c5fa2b9d389b0d543be1f10860d4404612)

 libmm-glib/mm-modem.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 9900187976bb6b7d32f17c8e336ba26ad2abec1c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 21 15:04:55 2021 +0100

    bearer-mbim: fix error handling in connection status reload

    We should not set the GError as autoptr(), as we're returning it as
    part of the GTask.

    (cherry picked from commit afb213ac05aa72db010e17e0326408bf655f66fd)

 src/mm-bearer-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7d79e3f67dc34a72b321660f02ec535299f972be
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Nov 21 14:50:07 2021 +0100

    bearer-mbim: plug leak when checking if already disconnected fails

    If the modem reports any error during the connection status check,
    we're creating a GError but never disposing it. We don't need that
    GError for anything, so just discard it.

    (cherry picked from commit 647a438b435e9dc21c123602b4be758515c51c57)

 src/mm-bearer-mbim.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 3a1d578c4d0f1be4658b5657999fc40f68931b65
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Oct 26 01:06:10 2021 +0200

    data,fcc-unlock: add example unlock scripts

    Added scripts for Foxconn SDX55, Quectel EM120, and several old Sierra
    Wireless manufactured devices:
     * Installed but not used by default, the user needs to setup manual
       links from ${pkgdatadir}/fcc-unlock.available.d, to
       ${pkgsysconfdir}/fcc-unlock.d in order to enable them.
     * Installed with rights only for the owner, so that the dispatcher in
       ModemManager can validate them.
     * They rely on $PATH to find the qmicli/mbimcli tools.

    In addition to these scripts, per-vid:pid links are created in the
    same ${pkgdatadir}/fcc-unlock.available.d directory, specifying which
    are the specific devices that require the FCC unlock operation.

    This patch also creates the ${pkgsysconfdir}/fcc-unlock.d and
    ${pkglibdir}/fcc-unlock.d directories where ModemManager looks for the
    enabled tools.

    Note that the meson setup doesn't support creating/deleting links
    officially yet, so we use a workaround using meson.add_install_script
    that is not perfect (i.e. doesn't handle the symlink removal during
    uninstall). See https://github.com/mesonbuild/meson/issues/1602

    (cherry picked from commit e7a6bb7504403b60d098ef8dde39b036c8c31f8d)

 configure.ac                |  2 ++
 data/Makefile.am            |  2 +-
 data/fcc-unlock/105b        | 34 ++++++++++++++++++++++++++++++++++
 data/fcc-unlock/1199        | 33 +++++++++++++++++++++++++++++++++
 data/fcc-unlock/1eac        | 34 ++++++++++++++++++++++++++++++++++
 data/fcc-unlock/Makefile.am | 32 ++++++++++++++++++++++++++++++++
 data/fcc-unlock/meson.build | 41
 +++++++++++++++++++++++++++++++++++++++++
 meson.build                 |  1 +
 8 files changed, 178 insertions(+), 1 deletion(-)

commit f47905440dbd2102850bfb30ad059e05310ba526
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Oct 25 21:39:46 2021 +0200

    iface-modem: use external dispatcher to attempt FCC unlock

    We remove the built-in FCC unlock procedures from the ModemManager, we
    will no longer run them automatically, and instead rely on external
    scripts/programs to do that.

    Packages providing the external FCC unlock tools can install them in
    ${pkglibdir}/fcc-unlock.d.

    Users manually enabling external FCC unlock tools can install them in
    ${pkgsysconfdir}/fcc-unlock.d.

    The user-enabled path takes precedence over the package-enabled one.

    (cherry picked from commit 81302efa661f848455a1bfe44b27608b11d6d49b)

 configure.ac                                      |   5 +
 meson.build                                       |   2 +
 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c |  62 -----
 src/Makefile.am                                   |   4 +
 src/meson.build                                   |   3 +
 src/mm-broadband-modem-mbim.c                     |   2 -
 src/mm-broadband-modem-qmi.c                      |   2 -
 src/mm-fcc-unlock-dispatcher.c                    | 319
 ++++++++++++++++++++++
 src/mm-fcc-unlock-dispatcher.h                    |  47 ++++
 src/mm-iface-modem.c                              |  68 ++++-
 src/mm-iface-modem.h                              |   8 -
 src/mm-shared-qmi.c                               |  50 ----
 src/mm-shared-qmi.h                               |   6 -
 13 files changed, 439 insertions(+), 139 deletions(-)

commit 6b1db4b4f99e490adf306bab4ff60319d8e80df2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 16 17:53:22 2021 +0100

    libmm-glib: fix license in sources

    The libmm-glib library is LGPLv2+, not GPLv2+.

    (cherry picked from commit 21c775703c9e3852fdda206a9658cb236613ef85)

 libmm-glib/libmm-glib.h                           |  2 +-
 libmm-glib/mm-3gpp-profile.c                      | 21
 ++++++++++++++-------
 libmm-glib/mm-3gpp-profile.h                      | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-ip-config.c                  | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-ip-config.h                  | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-properties.c                 | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-properties.h                 | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-stats.c                      | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer-stats.h                      | 21
 ++++++++++++++-------
 libmm-glib/mm-bearer.c                            |  2 +-
 libmm-glib/mm-bearer.h                            |  2 +-
 libmm-glib/mm-call-audio-format.c                 | 21
 ++++++++++++++-------
 libmm-glib/mm-call-audio-format.h                 | 21
 ++++++++++++++-------
 libmm-glib/mm-call-properties.c                   | 21
 ++++++++++++++-------
 libmm-glib/mm-call-properties.h                   | 21
 ++++++++++++++-------
 libmm-glib/mm-call.c                              | 21
 +++++++++++++--------
 libmm-glib/mm-call.h                              | 21
 +++++++++++++--------
 libmm-glib/mm-cdma-manual-activation-properties.c | 21
 ++++++++++++++-------
 libmm-glib/mm-cdma-manual-activation-properties.h | 21
 ++++++++++++++-------
 libmm-glib/mm-common-helpers.c                    | 21
 ++++++++++++++-------
 libmm-glib/mm-common-helpers.h                    | 21
 ++++++++++++++-------
 libmm-glib/mm-compat.c                            |  2 +-
 libmm-glib/mm-compat.h                            |  2 +-
 libmm-glib/mm-firmware-properties.c               | 21
 ++++++++++++++-------
 libmm-glib/mm-firmware-properties.h               | 21
 ++++++++++++++-------
 libmm-glib/mm-firmware-update-settings.c          | 21
 ++++++++++++++-------
 libmm-glib/mm-firmware-update-settings.h          | 21
 ++++++++++++++-------
 libmm-glib/mm-helper-types.c                      |  2 +-
 libmm-glib/mm-helper-types.h                      |  2 +-
 libmm-glib/mm-helpers.h                           |  2 +-
 libmm-glib/mm-kernel-event-properties.c           | 21
 ++++++++++++++-------
 libmm-glib/mm-kernel-event-properties.h           | 21
 ++++++++++++++-------
 libmm-glib/mm-location-3gpp.c                     | 21
 ++++++++++++++-------
 libmm-glib/mm-location-3gpp.h                     | 21
 ++++++++++++++-------
 libmm-glib/mm-location-cdma-bs.c                  | 21
 ++++++++++++++-------
 libmm-glib/mm-location-cdma-bs.h                  | 21
 ++++++++++++++-------
 libmm-glib/mm-location-common.h                   | 21
 ++++++++++++++-------
 libmm-glib/mm-location-gps-nmea.c                 | 21
 ++++++++++++++-------
 libmm-glib/mm-location-gps-nmea.h                 | 21
 ++++++++++++++-------
 libmm-glib/mm-location-gps-raw.c                  | 21
 ++++++++++++++-------
 libmm-glib/mm-location-gps-raw.h                  | 21
 ++++++++++++++-------
 libmm-glib/mm-manager.c                           |  2 +-
 libmm-glib/mm-manager.h                           |  2 +-
 libmm-glib/mm-modem-3gpp-profile-manager.c        |  2 +-
 libmm-glib/mm-modem-3gpp-profile-manager.h        |  2 +-
 libmm-glib/mm-modem-3gpp-ussd.c                   |  2 +-
 libmm-glib/mm-modem-3gpp-ussd.h                   |  2 +-
 libmm-glib/mm-modem-3gpp.c                        |  2 +-
 libmm-glib/mm-modem-3gpp.h                        |  2 +-
 libmm-glib/mm-modem-cdma.c                        |  2 +-
 libmm-glib/mm-modem-cdma.h                        |  2 +-
 libmm-glib/mm-modem-firmware.c                    |  2 +-
 libmm-glib/mm-modem-firmware.h                    |  2 +-
 libmm-glib/mm-modem-location.c                    |  2 +-
 libmm-glib/mm-modem-location.h                    |  2 +-
 libmm-glib/mm-modem-messaging.c                   |  2 +-
 libmm-glib/mm-modem-messaging.h                   |  2 +-
 libmm-glib/mm-modem-oma.c                         |  2 +-
 libmm-glib/mm-modem-oma.h                         |  2 +-
 libmm-glib/mm-modem-signal.c                      |  2 +-
 libmm-glib/mm-modem-signal.h                      |  2 +-
 libmm-glib/mm-modem-simple.c                      |  2 +-
 libmm-glib/mm-modem-simple.h                      |  2 +-
 libmm-glib/mm-modem-time.c                        |  2 +-
 libmm-glib/mm-modem-time.h                        |  2 +-
 libmm-glib/mm-modem-voice.c                       |  2 +-
 libmm-glib/mm-modem-voice.h                       |  2 +-
 libmm-glib/mm-modem.c                             |  2 +-
 libmm-glib/mm-modem.h                             |  2 +-
 libmm-glib/mm-network-timezone.c                  | 21
 ++++++++++++++-------
 libmm-glib/mm-network-timezone.h                  | 21
 ++++++++++++++-------
 libmm-glib/mm-object.c                            |  2 +-
 libmm-glib/mm-object.h                            |  2 +-
 libmm-glib/mm-pco.c                               | 21
 ++++++++++++++-------
 libmm-glib/mm-pco.h                               | 21
 ++++++++++++++-------
 libmm-glib/mm-signal.c                            | 21
 ++++++++++++++-------
 libmm-glib/mm-signal.h                            | 21
 ++++++++++++++-------
 libmm-glib/mm-sim-preferred-network.c             | 21
 ++++++++++++++-------
 libmm-glib/mm-sim-preferred-network.h             | 21
 ++++++++++++++-------
 libmm-glib/mm-sim.c                               |  2 +-
 libmm-glib/mm-sim.h                               |  2 +-
 libmm-glib/mm-simple-connect-properties.c         | 21
 ++++++++++++++-------
 libmm-glib/mm-simple-connect-properties.h         | 21
 ++++++++++++++-------
 libmm-glib/mm-simple-status.c                     | 21
 ++++++++++++++-------
 libmm-glib/mm-simple-status.h                     | 21
 ++++++++++++++-------
 libmm-glib/mm-sms-properties.c                    | 21
 ++++++++++++++-------
 libmm-glib/mm-sms-properties.h                    | 21
 ++++++++++++++-------
 libmm-glib/mm-sms.c                               |  2 +-
 libmm-glib/mm-sms.h                               |  2 +-
 libmm-glib/mm-unlock-retries.c                    | 21
 ++++++++++++++-------
 libmm-glib/mm-unlock-retries.h                    | 21
 ++++++++++++++-------
 91 files changed, 726 insertions(+), 387 deletions(-)

commit 2beae71a60a1881bb5513b01143f1b394c51d07a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 9 10:49:20 2021 +0100

    kerneldevice,generic: simplify DEVPATH matching logic

    Use autoptr to avoid the embedded goto.

    (cherry picked from commit 59ad8409a6088b3592b537122b39d4d609ee829a)

 src/kerneldevice/mm-kernel-device-generic.c | 30
 ++++++++---------------------
 1 file changed, 8 insertions(+), 22 deletions(-)

commit 1bd70df8a0c97991c4fa785ba7c0b4a6af7895b0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Nov 9 10:43:58 2021 +0100

    kerneldevice,generic: input pattern to string match is not regex

    The input pattern given to the string_match() method is not a regex
    pattern and we cannot use it as that, because all the special
    characters (e.g. '.') would not be treated correctly.

    Also, the prefix matching with the wildcard at the end of the string
    needs to be converted to a proper regex wildcard, i.e. '.*'.

    This logic also adds support for suffix matching, with a wildcard at
    the beginning of the string, e.g. as the ones used for the wwan kernel
    device name matching rules (i.e. '*MBIM').

    Unit tests are added to cover all cases, most of these tests were
    failing without the fixes implemented here.

    (cherry picked from commit 03fce4775e5a1cf2fa8859a5074ea5bd37e1828a)

 src/kerneldevice/mm-kernel-device-generic.c |  27 -------
 src/kerneldevice/mm-kernel-device-helpers.c |  66 ++++++++++++++--
 src/tests/Makefile.am                       |   1 +
 src/tests/meson.build                       |   1 +
 src/tests/test-kernel-device-helpers.c      | 118
 ++++++++++++++++++++++++++++
 5 files changed, 179 insertions(+), 34 deletions(-)

commit a013ea79caa8abb4daf4d451ea4d6edd62329cc0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Nov 8 23:22:48 2021 +0100

    kerneldevice,generic: move string match method to helpers

    So that we can propertly unit-test it.

    (cherry picked from commit 73b44ea51b84e8c8259e07a64fbb9f22a599b774)

 src/kerneldevice/mm-kernel-device-generic.c | 10 ++++-----
 src/kerneldevice/mm-kernel-device-helpers.c | 32
 +++++++++++++++++++++++++++++
 src/kerneldevice/mm-kernel-device-helpers.h |  7 ++++++-
 3 files changed, 43 insertions(+), 6 deletions(-)

commit 5d26ab9f802602603175ea171c0e327667dd5908
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Fri Nov 5 12:45:56 2021 +0100

    build,meson: Make feature options boolean

    Different options are set as `feature`, also every possible plugin,
    but this may cause confusion.

    All options set as `feature` but plugins have been made `boolean` to
    avoid further confusions.

    `help2man` is also installed in the CI image because is required to
    build different libraries.

    (cherry picked from commit ec2e5403f14892047f391f63982bf5e4b30438c2)

 .gitlab-ci.yml      | 36 ++++++++++++++++++------------------
 cli/meson.build     |  9 +++++----
 meson.build         | 33 ++++++++++++++++++++++-----------
 meson_options.txt   | 10 +++++-----
 plugins/meson.build | 14 +++++++++-----
 src/meson.build     | 20 ++++++++++----------
 test/meson.build    |  2 +-
 7 files changed, 70 insertions(+), 54 deletions(-)

commit ee2dc47de72488b2b3cc746247b6da8665853e6e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Oct 14 13:03:11 2021 +0200

    cli,signal: fix error message without EOL

    (cherry picked from commit a1e6f911dd20eeca91a864e42d3458549c4cc36a)

 cli/mmcli-modem-signal.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 81a0f845acb96b667b38035c56d9af73c947018c
Author: Daniele Palmas <dnlplm@gmail.com>
Date:   Mon Oct 25 10:49:30 2021 +0200

    telit: allow unlock retries loading for unknown error csim reply

    When trying to lock the modem LE910S1 replies:

    'AT+CSIM=1<CR>'
    '<CR><LF>ERROR<CR><LF>'

    but the modem actually supports CSIM unlock retries reporting.

    (cherry picked from commit 2b196d897b5bcfb04072df16c1bf5c025239eba6)

 plugins/telit/mm-broadband-modem-telit.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit f17f5c16ae26b14ba24a4aeb877f7989695f723c
Author: Daniele Palmas <dnlplm@gmail.com>
Date:   Mon Oct 25 09:34:04 2021 +0200

    telit: avoid sim hot swap procedure if #QSS is not supported

    (cherry picked from commit 1058c1c69dba15bd9fc7cf3da2c191cc29aa1ddb)

 plugins/telit/mm-broadband-modem-telit.c | 30
 ++++++++++++++++++++++++++++--
 1 file changed, 28 insertions(+), 2 deletions(-)

commit 55b0bead2c633590f357386d2dfab21595eb185f
Author: Daniele Palmas <dnlplm@gmail.com>
Date:   Mon Oct 25 09:13:43 2021 +0200

    telit: add port type hints for LE910S1 0x7010, 0x7011 compositions

    (cherry picked from commit 3a02c3187bd0842e7d5ff74509d2051894146b56)

 plugins/telit/77-mm-telit-port-types.rules | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 41655f416a61264406991b1dc4cff28832d7a6c1
Author: Frederic Martinsons <frederic.martinsons@sigfox.com>
Date:   Sat Oct 23 10:57:26 2021 +0200

    iface-modem-firmware: Initialize context to null

    Without setting memory to NULL it is possible that ctx->list
    point to an unitialized pointer and trig a segfault when we
    free it (for example when the firmware list is not supported)

    Signed-off-by: Frederic Martinsons <frederic.martinsons@sigfox.com>
    (cherry picked from commit 2ae5f3cc27425a2b53872bb7c783aa032ac6aa6b)

 src/mm-iface-modem-firmware.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d377c10599c4a57150bdf39d033a82e14e50f1d0
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Oct 22 15:37:25 2021 +0200

    libmm-glib: add documentation for disable_facility_lock

    (cherry picked from commit c487ca1b36dd1aa14cb45e4555fbf3235b7ca784)

 libmm-glib/mm-modem-3gpp.c | 51
 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 51 insertions(+)

commit 876bfd229f1a8323d9e333f6b86a15fb2ea08283
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 17 21:29:05 2021 +0200

    modem-helpers: remove unexistent method header

    (cherry picked from commit e1bc4b0999aa268358d2ab2c3182e87119cd255f)

 src/mm-modem-helpers.h | 3 ---
 1 file changed, 3 deletions(-)

commit eb795223a9131e0c633ad9ca8ff800e7133d3bc1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Oct 15 23:35:20 2021 +0200

    introspection,signal: minor doc fix in 5G RSRP

    (cherry picked from commit 5f043e47bfb133da7738202bb5248cc9dcda7f86)

 introspection/org.freedesktop.ModemManager1.Modem.Signal.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 136904fa1c6571eb210472c4171de22d3b26cc34
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Fri Oct 15 11:50:52 2021 +0800

    foxconn: add T99W265 modules, support for QDU.

    (cherry picked from commit f5ab3c4678247e8eade0e8ff0a812d6b1e1c569d)

 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c | 15 ++++++++++++---
 1 file changed, 12 insertions(+), 3 deletions(-)

commit 9bde138095159aa27a917b4e8d9163fd0c13b182
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 13 13:36:24 2021 +0200

    qcom-soc: require udev tag for ports

    Since the 'wwan' subsystem addition to the qcom-soc plugin, the rules
    to say a modem is handled by this plugin are too broad, and the plugin
    attempts to support any kind of device exposed by the WWAN subsystem,
    not just those from Qualcomm SoCs.

    Update the plugin to require a new ID_MM_QCOM_SOC udev tag that is set
    in the plugin udev rules, given that these rules already check for the
    expected SoC drivers (bam-dmux, ipa, qcom-q6v5-mss).

    (cherry picked from commit c06ca6df3f096a53665611b26b4add933317e873)

 plugins/qcom-soc/77-mm-qcom-soc.rules    | 5 ++++-
 plugins/qcom-soc/mm-plugin-qcom-soc.c    | 5 +++++
 src/kerneldevice/mm-kernel-device-qrtr.c | 3 ++-
 3 files changed, 11 insertions(+), 2 deletions(-)

commit fa9157895de2e572f7edf01759afc6b18868d8c5
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Mon Oct 18 09:26:59 2021 +0200

    build,meson: Allow plugins to depend on build options

    At the moment plugins might depend only on shared plugins. However,
    plugins may depend also in different build options. For example,
    `qcom-soc` plugin needs `qmi` option to be enabled.

    Plugins build check has been changed to allow to depend on different
    build options.

    Fixes #447

    (cherry picked from commit 7663a2e6c383bb68f31c91ca51ba2801ee990c6e)

 meson.build | 83
 +++++++++++++++++++++++++++++++------------------------------
 1 file changed, 42 insertions(+), 41 deletions(-)

commit a0cdc8648d5d719f98e6c49448236453e39fb8fe
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Oct 14 10:13:36 2021 +0200

    ci: switch single plugins build to use meson

    (cherry picked from commit a5f2f84f44f2265739bc96d152128a107e9cebed)

 .gitlab-ci.yml | 14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit 94c5e58c055783877ca88555e9dd0ee840288cd0
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 22:30:50 2021 +0200

    build,meson: Add an empty line to split includes and dependencies

    (cherry picked from commit 86fcf2592fa33d034ee02c6dd8dd4a3527126210)

 plugins/meson.build | 1 +
 1 file changed, 1 insertion(+)

commit 8699d0665a66f386aca8bde273fe0401e91c3e2f
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 22:28:58 2021 +0200

    build,meson: Remove unnecessary empty line

    (cherry picked from commit 803ce03d6a657f5d7c96ebfb2c36d4e65dd28e4f)

 src/meson.build | 1 -
 1 file changed, 1 deletion(-)

commit 380c8efe56cf4d12d65c7fe707bb64bfc857d2d9
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 22:20:34 2021 +0200

    build,meson: Make use of _opt suffix for option variables

    To make option names consistent, an `_opt` suffix has been added.

    This was not applied to `polkit` option at the time and this is
    fixed now.

    (cherry picked from commit 7c4f8f6cc50054e1818c1f8e03cb2fa08218aa77)

 meson.build | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 43445df7494523c72e58b3514218ba512955a8e9
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 22:15:39 2021 +0200

    build,meson: Make use of partial_dependency for generated dependency

    The generated objects in `libmm-glib` are include in
    `libmm_glib_dep` one by one to avoid the link to the generated
    library that is included as a whole in `libmm-glib`.

    meson includes a way to include partial objects of a dependency by
    using the `partial_dependency` method, so by taking advantage of it
    almost all objects are included.

    (cherry picked from commit b3b16b3dc2608242a2e88d6b2870c403fb5a5d9c)

 libmm-glib/meson.build | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 82480238a93065e8c6985d1dc2f5b6d353dfee96
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 21:50:58 2021 +0200

    build,meson: Sort files alphabetically

    (cherry picked from commit 3974b8b98f1c402865b06598d1f26f7db5824d50)

 examples/sms-c/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2c5a6dc659d023f832604bd0fd19f18d373e70fb
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 16 10:04:51 2021 +0200

    build,meson: Remove unused option

    (cherry picked from commit c3b6a2876eb5f884e195832cdc195353ba8cf59b)

 meson_options.txt | 2 --
 1 file changed, 2 deletions(-)

commit f6c24a955d4a74cf5b6b39a742b18d8c0d9d5dc2
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Sep 8 14:42:08 2021 +0200

    build,meson: Improve plugins option set

    Improved the way the plugins are set to allow a smaller summary.

    (cherry picked from commit bbc157688d9ff82e548a155be1a54a8220fb0f09)

 meson.build         | 97
 ++++++++++++++++-------------------------------------
 meson_options.txt   | 82 ++++++++++++++++++++++----------------------
 plugins/meson.build | 92
 +++++++++++++++++++++++++-------------------------
 3 files changed, 114 insertions(+), 157 deletions(-)

commit aaadae356ec22c064725ebe9bfee7df77cf49449
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 13 22:13:40 2021 +0200

    ci: use libmbim and libqmi stable branches

    We keep libqrtr-glib git master just because it builds with meson.

 .gitlab-ci.yml | 31 +++++++++++++++++--------------
 1 file changed, 17 insertions(+), 14 deletions(-)

commit 58327cbebcc7f8fae8ae9d4c0b685c103735c518
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 13 22:05:27 2021 +0200

    broadband-modem-qmi: fix non-initialized GError

    (cherry picked from commit 85a99ae028f42d5b35ffb42888a5c2201fd0e91d)

 src/mm-broadband-modem-qmi.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 86b52c27f86ea928197db42524515461bf852b2e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Oct 13 22:04:53 2021 +0200

    quectel: fix non-initialized GError

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/442

    (cherry picked from commit 8852cef8175bb5421cd14986ac3803985d5e6eae)

 plugins/quectel/mm-shared-quectel.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ddee7b840a0441e1d25bba1e4889ed0574eb8625
Author: Amol Lad <amol.lad@4rf.com>
Date:   Mon Oct 4 14:48:05 2021 +0530

    mm-bearer-mbim: unref not needed and it is causing crash

    (cherry picked from commit 11b83e4cb8d310fc88a4e0152e625b7eafefe516)

 src/mm-bearer-mbim.c | 1 -
 1 file changed, 1 deletion(-)

commit a34535e305424da4d9797c029f7c56ab3b5ec2d9
Author: Lubomir Rintel <lkundrak@v3.sk>
Date:   Fri Oct 1 16:13:42 2021 +0200

    iface-modem-3gpp-profile-manager: correct a GError instance ownership

    The call to g_task_return_error() takes ownership of the GError passed
    to it; we must not free it ourselves upon automatic pointer cleanup.

    Otherwise a crash can be triggered in the error handling path:

      ModemManager[259816]: <debug> [1633088468.157848] [modem0/modemu/at]
      <-- '<CR><LF>OK<CR><LF>'
      ModemManager[259816]: <debug> [1633088468.159832] [modem0] stored
      profile with id '1'
      ModemManager[259816]: <debug> [1633088468.160501] [modem0] set
      profile state (7/8): list after
      ModemManager[259816]: <debug> [1633088468.161686] [modem0/modemu/at]
      device open count is 3 (open)
      ModemManager[259816]: <debug> [1633088468.162320] [modem0/modemu/at]
      device open count is 2 (close)
      ModemManager[259816]: <debug> [1633088468.162746] [modem0/modemu/at]
      --> 'AT+CGDCONT?<CR>'
      ModemManager[259816]: <debug> [1633088468.177437] [modem0/modemu/at]
      <-- '<CR><LF>ERROR<CR><LF>'
      ModemManager[259816]: <debug> [1633088468.178011] [modem0/modemu/at]
      operation failure: 100 (Unknown error)
      ModemManager[259816]: <warn>  [1633088468.182420] [modem0/bearer0]
      connection attempt #1 failed: Couldn't validate update of profile
      '1': Unknown error
      ModemManager[259816]: <info>  [1633088468.193156] [modem0/bearer0]
      connection #1 finished: duration 0s, tx: 0 bytes, rx: 0 bytes
      ModemManager[259816]: <debug> [1633088468.194280] [modem0]
      couldn't connect bearer: Couldn't validate update of profile '1':
      Unknown error
      ==259816== Invalid read of size 4
      ==259816==    at 0x4FF66CF: UnknownInlinedFun (gerror.c:535)
      ==259816==    by 0x4FF66CF: g_error_free (gerror.c:832)
      ==259816==    by 0x1A7F49: UnknownInlinedFun
      (glib-autocleanups.h:52)
      ==259816==    by 0x1A7F49: UnknownInlinedFun
      (glib-autocleanups.h:52)
      ==259816==    by 0x1A7F49: profile_manager_get_profile_after_ready
      (mm-iface-modem-3gpp-profile-manager.c:140)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==    by 0x4E344CA: UnknownInlinedFun (gtask.c:1289)
      ==259816==    by 0x4E344CA: g_task_return (gtask.c:1245)
      ==259816==    by 0x1A867C: get_profile_list_ready
      (mm-iface-modem-3gpp-profile-manager.c:680)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==    by 0x4E344CA: UnknownInlinedFun (gtask.c:1289)
      ==259816==    by 0x4E344CA: g_task_return (gtask.c:1245)
      ==259816==    by 0x1A3DB5: internal_list_profiles_ready
      (mm-iface-modem-3gpp-profile-manager.c:774)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==    by 0x4E344CA: UnknownInlinedFun (gtask.c:1289)
      ==259816==    by 0x4E344CA: g_task_return (gtask.c:1245)
      ==259816==    by 0x1D7B8B: profile_manager_cgdcont_query_ready
      (mm-broadband-modem.c:10240)
      ==259816==    by 0x4E1DB61: g_simple_async_result_complete
      (gsimpleasyncresult.c:802)
      ==259816==  Address 0x9286da0 is 0 bytes inside a block of size
      16 free'd
      ==259816==    at 0x48440E4: free (vg_replace_malloc.c:755)
      ==259816==    by 0x500FD1C: g_free (gmem.c:199)
      ==259816==    by 0x502A22F: g_slice_free1 (gslice.c:1180)
      ==259816==    by 0x4FF6780: g_error_free (gerror.c:864)
      ==259816==    by 0x1B22D2: connect_bearer_ready
      (mm-iface-modem-simple.c:286)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==    by 0x4E344CA: UnknownInlinedFun (gtask.c:1289)
      ==259816==    by 0x4E344CA: g_task_return (gtask.c:1245)
      ==259816==    by 0x18031A: connect_ready (mm-base-bearer.c:917)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==    by 0x4E344CA: UnknownInlinedFun (gtask.c:1289)
      ==259816==    by 0x4E344CA: g_task_return (gtask.c:1245)
      ==259816==    by 0x18329B: connect_3gpp_ready
      (mm-broadband-bearer.c:918)
      ==259816==    by 0x4E342C9: g_task_return_now (gtask.c:1219)
      ==259816==  Block was alloc'd at
      ==259816==    at 0x484186F: malloc (vg_replace_malloc.c:380)
      ==259816==    by 0x5013408: g_malloc (gmem.c:106)
      ==259816==    by 0x502ACB4: g_slice_alloc (gslice.c:1069)
      ==259816==    by 0x502B33D: g_slice_alloc0 (gslice.c:1095)
      ==259816==    by 0x4FF64E6: g_error_allocate (gerror.c:702)
      ==259816==    by 0x4FF6F03: UnknownInlinedFun (gerror.c:716)
      ==259816==    by 0x4FF6F03: g_error_copy (gerror.c:886)
      ==259816==    by 0x4E1D0A0: g_simple_async_result_set_from_error
      (gsimpleasyncresult.c:676)
      ==259816==    by 0x236AAB: port_serial_got_response
      (mm-port-serial.c:744)
      ==259816==    by 0x23B0F1: UnknownInlinedFun (mm-port-serial.c:934)
      ==259816==    by 0x23B0F1: common_input_available
      (mm-port-serial.c:1035)
      ==259816==    by 0x500AF9E: UnknownInlinedFun (gmain.c:3337)
      ==259816==    by 0x500AF9E: g_main_context_dispatch (gmain.c:4055)
      ==259816==    by 0x505F607: g_main_context_iterate.constprop.0
      (gmain.c:4131)
      ==259816==    by 0x500A562: g_main_loop_run (gmain.c:4329)

    (cherry picked from commit 90ea3ef5db2bc5846dcb3382a15ec95ce366e04a)

 src/mm-iface-modem-3gpp-profile-manager.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ace5d2db5cba2ce84ff27b0e17ee6d834c09ff0b
Author: Lubomir Rintel <lkundrak@v3.sk>
Date:   Fri Oct 1 16:13:48 2021 +0200

    broadband-modem: ensure mm_broadband_modem_create_device_identifier()
    sets an error on all bad returns

    modem_load_device_identifier_finish() expect it to do so and trips an
    assertion failure in g_propagate_error():

      ModemManager[256038]: <warn>  [1633083601.491190] [modem0] couldn't
      load equipment identifier: Unknown error
      ModemManager[256038]: <debug> [1633083601.491204] [modem0] loading
      device identifier...
      ModemManager[256038]: <debug> [1633083601.491215] [modem0/modemu/at]
      device open count is 3 (open)
      ModemManager[256038]: <debug> [1633083601.491231] [modem0/modemu/at]
      device open count is 2 (close)
      ModemManager[256038]: <debug> [1633083601.491254] [modem0/modemu/at]
      --> 'ATI<CR>'
      ModemManager[256038]: <debug> [1633083601.494616] [modem0/modemu/at]
      <-- '<CR><LF>ERROR<CR><LF>'
      ModemManager[256038]: <debug> [1633083601.494643] [modem0/modemu/at]
      operation failure: 100 (Unknown error)

      (ModemManager:256038): GLib-CRITICAL **: 06:20:01.494:
      g_propagate_error: assertion 'src != NULL' failed

      Thread 1 "ModemManager" received signal SIGTRAP, Trace/breakpoint
      trap.
      g_logv (log_domain=0x7ffff77d1071 "GLib",
      log_level=G_LOG_LEVEL_CRITICAL, format=<optimized out>,
      args=<optimized out>) at ../glib/gmessages.c:1413
      1413            g_private_set (&g_log_depth, GUINT_TO_POINTER
      (depth));
      Missing separate debuginfos, use: dnf debuginfo-install
      libmbim-1.26.0-2.el9.x86_64 libqmi-1.30.2-1.el9.x86_64
      (gdb) bt
      #0  g_logv (log_domain=0x7ffff77d1071 "GLib",
      log_level=G_LOG_LEVEL_CRITICAL, format=<optimized out>,
      args=<optimized out>) at ../glib/gmessages.c:1413
      #1  0x00007ffff77813d3 in g_log (log_domain=<optimized
      out>, log_level=<optimized out>, format=<optimized out>) at
      ../glib/gmessages.c:1451
      #2  0x000055555561122d in modem_load_device_identifier_finish
      (self=0x5555557e62d0, res=<optimized out>, error=0x7fffffffd320)
          at
          /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-broadband-modem.c:1168
      #3  0x00005555555ea69a in load_device_identifier_ready
      (self=0x5555557e62d0, res=0x5555557ea6b0,
      task=task@entry=0x7fffe8011e20 [GTask])
          at
          /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-iface-modem.c:4727
      #4  0x00007ffff7951b62 in g_simple_async_result_complete
      (simple=0x5555557ea6b0 [GSimpleAsyncResult]) at
      ../gio/gsimpleasyncresult.c:802
      #5  0x00005555555d1b0a in at_sequence_parse_response
      (port=<optimized out>, res=<optimized out>,
      ctx=ctx@entry=0x5555557ed7f0)
          at
          /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-base-modem-at.c:250
      #6  0x00007ffff7951b62 in g_simple_async_result_complete
      (simple=0x5555557e5440 [GSimpleAsyncResult]) at
      ../gio/gsimpleasyncresult.c:802
      #7  0x00005555556805dc in serial_command_ready (port=<optimized
      out>, res=<optimized out>, simple=simple@entry=0x5555557e5440
      [GSimpleAsyncResult])
          at
          /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-port-serial-at.c:378
      #8  0x00007ffff7951b62 in g_simple_async_result_complete
      (simple=0x5555557d6730 [GSimpleAsyncResult]) at
      ../gio/gsimpleasyncresult.c:802
      #9  0x000055555567fb35 in command_context_complete_and_free
      (ctx=ctx@entry=0x7fffe800c200, idle=idle@entry=0) at
      /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-port-serial.c:141
      #10 0x0000555555682a96 in port_serial_got_response
      (self=0x5555557dd4e0 [MMPortSerialAt], parsed_response=0x0,
      error=0x5555557d5040)
          at
          /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-port-serial.c:755
      #11 0x00005555556870d2 in parse_response_buffer
      (self=<optimized out>) at
      /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-port-serial.c:934
      #12 common_input_available (self=0x5555557dd4e0
      [MMPortSerialAt], condition=(G_IO_NVAL | unknown: 0xf762a5c0)) at
      /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/mm-port-serial.c:1035
      #13 0x00007ffff7778f9f in g_main_dispatch (context=0x5555557527c0)
      at ../glib/gmain.c:3337
      #14 g_main_context_dispatch (context=0x5555557527c0) at
      ../glib/gmain.c:4055
      #15 0x00007ffff77cd608 in g_main_context_iterate.constprop.0
      (context=0x5555557527c0, block=block@entry=1,
      dispatch=dispatch@entry=1, self=<optimized out>) at
      ../glib/gmain.c:4131
      #16 0x00007ffff7778563 in g_main_loop_run (loop=0x55555576da60)
      at ../glib/gmain.c:4329
      #17 0x00005555555b7b60 in main
      (argc=<optimized out>, argv=<optimized out>) at
      /usr/src/debug/ModemManager-1.18.2-1.el9.x86_64/src/main.c:216

    (cherry picked from commit e3d108de0f3f5d2ac32b3ad09ec0dae8fb5fc2e5)

 src/mm-broadband-modem.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 24639d890d958ff5110e2c9c25fa0375fc5c23f1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Oct 3 14:35:06 2021 +0200

    ci: bump image template to refresh CA certificates

    At the end of September 2021, Let's Encrypt's DST Root CA X3
    certificate expired, and the new ISRG Root X1 took over.
    Update the CI template so that the new certificate is available and we
    can keep on cloning the libmbim/libqmi/libqrtr-glib repos without
    failures.

    (cherry picked from commit 7c30471d9469d54607fba376df772fff3c823a33)

 .gitlab-ci.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9e296220c8d1e4f68b3cc3e46227e29392deb792
Author: Daniele Palmas <dnlplm@gmail.com>
Date:   Wed Sep 29 16:13:45 2021 +0200

    telit: fix g_object_unref failed assertion

    Fix the following g_object_unref failed assertion:

    ModemManager[385967]: <debug> [1632924639.132023] [modem0/ttyUSB2/at]
    --> 'AT+CSIM=1<CR>'
    ModemManager[385967]: <debug> [1632924639.144892] [modem0/ttyUSB2/at]
    <-- '<CR><LF>ERROR<CR><LF>'
    ModemManager[385967]: <debug> [1632924639.145021] [modem0/ttyUSB2/at]
    operation failure: 100 (Unknown error)
    (ModemManager:385967): GLib-GObject-CRITICAL **: 16:10:39.145:
    g_object_unref: assertion 'G_IS_OBJECT (object)' failed

    (cherry picked from commit 9c47c54f067f15afea7ff1e9c89d1ab41fe3e4bb)

 plugins/telit/mm-broadband-modem-telit.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5a68b53a6084a52e36f0d2d0bd34e5a65409dbf4
Author: Benoît Monin <benoit.monin@gmx.fr>
Date:   Thu Sep 23 11:48:35 2021 +0200

    sms: increase send timeout to 5 minutes

    The timeout for sms send operation can exceed the current value, so
    increase it to 5 minutes. Timeouts up to 4 minutes have been observed
    in the following test scenario:
    * Power up the modem and wait for registration.
    * Right when the modem is registered, attenuate the rf signal
      or remove the antenna.
    * Immediately try to send an sms.

    Increasing the timeout cover this corner case.

    (cherry picked from commit 8755e85d13b1170882cd5108cf20a63d94573155)

 src/mm-base-sms.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 864ed4f805f1941fe4fefa170c5b84f9ce209256
Author: Yegor Yefremov <yegorslists@googlemail.com>
Date:   Sat Sep 18 22:32:42 2021 +0200

    Fix -Wmaybe-uninitialized warning

    Initialize the scheme variable to
    QMI_VOICE_USS_DATA_CODING_SCHEME_UNKNOWN
    to avoid the warning.

    (cherry picked from commit 8b80da152b3dd5f6d20a4f08cce1f7eaa2bbf730)

 src/mm-broadband-modem-qmi.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a40807720551824a68e08172abdc8a1b617fd9bb
Author: Yegor Yefremov <yegorslists@googlemail.com>
Date:   Fri Sep 17 11:14:31 2021 +0200

    Tests: fix -Wformat compiler warning

    Use G_GUINT64_FORMAT to properly format a guint64 type.

    (cherry picked from commit 4875817f19d035694e234dd26448d43d92422468)

 test/lsudev.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3f99eb377274dbd5da998769f82652a7d016075a
Author: Shawn Guo <shawn.guo@linaro.org>
Date:   Fri Sep 17 03:59:38 2021 -0400

    build: enable qcom-soc plugin by default

    As people are running distros like Debian, Archlinux, Fedora, etc., on
    laptops powered by Qualcomm Snapdragon SoCs, e.g. Lenovo Yoga C630, it
    makes sense to enable qcom-soc plugin by default, so that MM aarch64
    package can be built by those distros more easily.

    Signed-off-by: Shawn Guo <shawn.guo@linaro.org>
    (cherry picked from commit 57eb2390896ec4b8f310ac77a0a71344caa6596e)

 configure.ac      | 2 +-
 meson_options.txt | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 262847d97dd6e749aee77d5fc0b84b1731926aea
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Sep 16 12:41:05 2021 +0200

    build: post-release version bump to 1.18.3

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 5a2c9229411fa6c5905b61e777122a9b49809134
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Sep 16 12:31:32 2021 +0200

    release: bump version to 1.18.2

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 01ba9040159aedd38eab247e86dca8c484ddcf52
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Sep 16 12:30:46 2021 +0200

    NEWS: update for 1.18.2

 NEWS | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit fffb184b9520bea9b35f8209f5506ca99e2325a6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 13:56:16 2021 +0200

    novatel: avoid returning a NULL timezone without error set

    Reported and fix suggested by:
    Frederic Martinsons <frederic.martinsons@sigfox.com>

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/438

    (cherry picked from commit 20b8d7931894a648114142e48b3a108135520a87)

 plugins/novatel/mm-broadband-modem-novatel.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f7f0d9246e69ca5765511ea16b73b7cb8afbd31b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 14:06:08 2021 +0200

    ci: add meson build test

    The system template is updated to add new packages required at build
    time:

     * libdbus-1-dev is added so that we can autodetect the service
       directory path via the installed pkg-config file.
     * udev is added so that we can autodetect the udev rules directory
       path via the installed pkg-config file.
     * policykit-1 is added so that the i18n operation merging policy
       files is able to use the installed ITS files.
     * bash-completion is added to enable the feature in the meson build.

    The 'dist' step in the test is fully skipped for now, as the meson
    port doesn't fully support running all unit tests successfully.

    (cherry picked from commit 727410048f7993b58973b9b1e0c6d89190440cec)

 .gitlab-ci.yml | 37 ++++++++++++++++++++++++++++++++++++-
 1 file changed, 36 insertions(+), 1 deletion(-)

commit ca4bd30577552935b8478504c866013da0ff0cf2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 22:03:13 2021 +0200

    build,meson: simplify build of daemon enums sources

    (cherry picked from commit aee12967ee263bea514ecf30fed4c331b6454080)

 src/meson.build | 38 +++++++++++++++++++-------------------
 1 file changed, 19 insertions(+), 19 deletions(-)

commit ca22ac4e1c8ea3978732c463bd499bb6b92c3d57
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 14:09:30 2021 +0200

    build,meson: introspection is setup as a feature

    (cherry picked from commit d5a992d30fc7a0b496401c3a89ca98ddf6e9114a)

 meson_options.txt | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2d8b6ca04a9b16d158d25d50104e6baa930d6900
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 13:45:16 2021 +0200

    Revert "build,meson: Improve plugins option set"

    This reverts commit 09a5052a777c858b83baf9444306775ed5c50300.

    This commit breaks the default disabling of the qcom-soc plugin.

    (cherry picked from commit b75d1d50d76ff55959d9ca3cb038faad1d07159a)

 meson.build         | 164
 ++++++++++++++++++++++++++++++++--------------------
 plugins/meson.build |  92 ++++++++++++++---------------
 2 files changed, 147 insertions(+), 109 deletions(-)

commit 6c73daf32aca014a1881a19d2fbeb15f4e10abfe
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 12:46:28 2021 +0200

    meson,build: don't include daemon enum sources in plugins

    We will end up exporting what we shouldn't:

      $ abidiff /tmp/autotools/lib/ModemManager/libmm-shared-icera.so
      /tmp/meson/lib/ModemManager/libmm-shared-icera.so
      Functions changes summary: 0 Removed, 0 Changed (3 filtered out),
      8 Added functions
      Variables changes summary: 0 Removed, 0 Changed, 0 Added variable

      8 Added functions:

        [A] 'function const gchar*
        mm_bearer_connection_status_get_string(MMBearerConnectionStatus)'
        {mm_bearer_connection_status_get_string}
        [A] 'function GType mm_bearer_connection_status_get_type()'
        {mm_bearer_connection_status_get_type}
        [A] 'function const gchar*
        mm_bearer_status_get_string(MMBearerStatus)'
        {mm_bearer_status_get_string}
        [A] 'function GType mm_bearer_status_get_type()'
        {mm_bearer_status_get_type}
        [A] 'function gchar*
        mm_filter_rule_build_string_from_mask(MMFilterRule)'
        {mm_filter_rule_build_string_from_mask}
        [A] 'function GType mm_filter_rule_get_type()'
        {mm_filter_rule_get_type}
        [A] 'function gchar*
        mm_port_probe_flag_build_string_from_mask(MMPortProbeFlag)'
        {mm_port_probe_flag_build_string_from_mask}
        [A] 'function GType mm_port_probe_flag_get_type()'
        {mm_port_probe_flag_get_type}

    (cherry picked from commit 101ed5671145e195010b6ae1dc2ae4a697b57975)

 plugins/meson.build | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit dfc42d5c3c09b00e14ad801a020dbb1ab9cf6ed6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 11:42:47 2021 +0200

    build,meson: fix building shared utils and plugins

    When building shared utils modules or plugins, we should not link with
    the static libraries built under src/, because that would mean we're
    including their symbols as exported by the modules, and it'll break in
    runtime.

    Instead, just define the correct set of 'include_directories' to be
    used in each plugin.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/436

    (cherry picked from commit 8167bc89e9fa3c78d25477adc0b2dc19875e7cef)

 plugins/meson.build | 149
 +++++++++++++++++++++++++++-------------------------
 1 file changed, 78 insertions(+), 71 deletions(-)

commit 353ddb9bdf5dc2a742cba50ab953cc2c7dc68335
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 11:38:57 2021 +0200

    build,meson: rename plugin helpers library variable

    So that we don't confuse the plugin-specific libhelpers with the core
    libhelpers built in src/.

    (cherry picked from commit 81b6c1b33303a7b73da761b30431dbdc260d94a9)

 plugins/meson.build | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit afb473baf169f7f3886bb2cef4d916791d6da833
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Sep 13 13:13:09 2021 +0200

    ci: Use feature values for libqmi, libmbim and libqrtr-glib

    `libmbim`, `libqmi` and `libqrtr-glib` have started using `feature`
    options in their meson builds.

    (cherry picked from commit c753f857f9762e2eaf5fbc4bf5d94e05493b519e)

 .gitlab-ci.yml | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit f65ea4a881987ada2bb9d083f80e1e3c5deb3e2a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 15 05:26:27 2021 +0200

    build,meson: make PLUGINDIR an absolute path

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/433

    (cherry picked from commit 986fbd5093725af782dbeed4ccae6cf82c022c9b)

 src/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 33401f9b43631eb1ee54ff3867e4fbf35dba9e71
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 14:40:58 2021 +0200

    build,meson: Improve plugins helper library building

    To avoid those cases where a plugin does not need a helper library
    an empty array is created.

    However, when a helper library has to be built, it is not necessary
    to include the created static library in an array.

    (cherry picked from commit 80f274b37159777a462d7584fb4fc82876229ac2)

 plugins/meson.build | 12 +++++-------
 1 file changed, 5 insertions(+), 7 deletions(-)

commit 68132e1f492723f0fe6ab28b59814e1199b15626
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 14:30:13 2021 +0200

    build,meson: Fix libmm-test-common name and dependencies

    `libmm-test-common` is created using underscores. It also uses
    `gio-unix-2.0` as a public dependency but actually it should be
    private.

    Both issues have been fixed.

    (cherry picked from commit db2d2c0cebd40c8979cdec46ac70249047f6ba6a)

 plugins/meson.build | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 794b20ffa08b4fa8be82db8230689fc39fa9d836
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 14:16:43 2021 +0200

    build,meson: Fix suspend/resume option

    The suspend/resume option does not build properly if journal option
    is disabled. This is beacause the journal option is check to add
    suspend/resume code.

    It has been fixed by replacing journal option check by the
    suspend/resume option.

    (cherry picked from commit ab805e09148ce41f5004d2552b263e41ae34735f)

 src/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fc67cf5c7523289e0f60f88e9472f59e0f99ea5b
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 10:34:20 2021 +0200

    build,meson: Fix libsystemd check

    At the moment `libsystemd` is check even if `suspend/resume` and
    systemd support are not enabled.

    This has been changed so `libsystemd` is checked only if any or both
    options are enabled.

    (cherry picked from commit 39912daa11491167cca9298a170210980626cd34)

 meson.build | 25 ++++++++++++++-----------
 1 file changed, 14 insertions(+), 11 deletions(-)

commit 58b35c0d835ffd2bce12dc5481a22dc2aff91b1a
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 09:31:54 2021 +0200

    build,meson: Improve libqcdm build

    `libqcdm`'s meson build files have been improved slightly by
    removing unnecessary variables shortening their contents.

    (cherry picked from commit 93a1d7a60de147a61f0e343a6d8069ceb2a30ded)

 libqcdm/src/meson.build   | 6 +-----
 libqcdm/tests/meson.build | 7 +------
 2 files changed, 2 insertions(+), 11 deletions(-)

commit d22c2c90b8d633ecf9fa4ec332f16df4111d5591
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Sep 9 00:04:54 2021 +0200

    build,meson: Make use of feature option for introspection

    (cherry picked from commit fe53de8bdddb9c86e5b341811872a19e16225838)

 meson.build | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 3828db5ab149feb0c5a62a2d96ccf1a65dd17d04
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Sep 8 23:50:20 2021 +0200

    build,meson: Remove unnecessary variables

    (cherry picked from commit 190bf5b3510d055d30c358427bcbcf2ee573442b)

 meson.build | 3 ---
 1 file changed, 3 deletions(-)

commit bff8fd5684d83d5bb2af78af82aa30af9fa677a0
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Sep 8 14:42:08 2021 +0200

    build,meson: Improve plugins option set

    Improved the way the plugins are set to allow a smaller summary.

    (cherry picked from commit 09a5052a777c858b83baf9444306775ed5c50300)

 meson.build         | 164
 ++++++++++++++++++++--------------------------------
 plugins/meson.build |  92 ++++++++++++++---------------
 2 files changed, 109 insertions(+), 147 deletions(-)

commit f13b544e00d5280d45f46ec6f90aa47a9ba38ba0
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Wed Sep 8 13:51:08 2021 +0200

    build,meson: Make use of the summary function

    Since meson 0.53 it has added a new function to summarize the build
    configuration[0].

    We changed the summary to make use of it.

    [0]
    https://mesonbuild.com/Release-notes-for-0-53-0.html#add-a-new-summary-function

    (cherry picked from commit e075512fc1b7b0a0eb75975e0d6f02973f2daed7)

 meson.build | 159
 ++++++++++++++++++++++++++++++++----------------------------
 1 file changed, 84 insertions(+), 75 deletions(-)

commit cb14070d65b5873a3e3b82b0c67819a5cd3500f3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Sep 10 10:36:19 2021 +0200

    core: remove execution bit from file modes in source files

    (cherry picked from commit 15671dc137d9644795e35cb1ea986bfeb2b4f79c)

 src/mm-broadband-modem-mbim.c | 0
 src/mm-sim-mbim.c             | 0
 src/mm-sim-mbim.h             | 0
 3 files changed, 0 insertions(+), 0 deletions(-)

commit 2deeef477b7eb7644644ff89612ce918022bb413
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Sep 9 11:23:20 2021 +0200

    build: post-release version bump to 1.18.1

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 4ccbfcd0167b5e6134eba5da34c33b8b0b5b1619
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 11:56:38 2021 +0200

    release: bump to 1.18.0

 configure.ac | 8 ++++----
 meson.build  | 6 +++---
 2 files changed, 7 insertions(+), 7 deletions(-)

commit ddaa4967a0dfc781044ece179a66aeef89f619e7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 11:54:37 2021 +0200

    NEWS: update for 1.18 with changes since rc1

 NEWS | 25 +++++++++++++++++++++----
 1 file changed, 21 insertions(+), 4 deletions(-)

commit 64f18f036bda8b47f5224e79b7a922de3fcafde9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 11:46:55 2021 +0200

    build: require libqmi 1.30.2

    We need the new "Get All Call Info" request support.

 NEWS         | 2 +-
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 2e44a5921b8b25e1ba6be391de5df2eeb846cd8e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 11:37:46 2021 +0200

    build,meson: add sms-c examples to build

 examples/sms-c/meson.build | 16 ++++++++++++++++
 meson.build                |  2 ++
 2 files changed, 18 insertions(+)

commit 86421f06bd28fb9613f3995984d798827174fb25
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 30 15:42:51 2021 +0200

    examples: new SMS sending example in C using the async API

 .gitignore                   |   3 +-
 examples/sms-c/Makefile.am   |  26 +++++-
 examples/sms-c/sms-c-async.c | 197
 +++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 224 insertions(+), 2 deletions(-)

commit ccc7989324aec454cc0267cd133638569d28061b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 30 14:56:58 2021 +0200

    examples: new SMS sending example in C using the sync API

 .gitignore                  |   4 +-
 configure.ac                |   1 +
 examples/Makefile.am        |   8 ++-
 examples/sms-c/Makefile.am  |  25 ++++++++
 examples/sms-c/sms-c-sync.c | 143
 ++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 179 insertions(+), 2 deletions(-)

commit 34e671f41cf9bb964b92ca555c71bcaa15c90893
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 10:26:04 2021 +0200

    broadband-modem-qmi: don't error out on empty call list

    Only error out if the required TLVs are missing.

 src/mm-broadband-modem-qmi.c | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

commit f2901446e0ef1f82c8ae27edc69d681a2a542957
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 10:14:26 2021 +0200

    iface-modem-voice: avoid warning with -Wincompatible-pointer-types

      ../src/mm-iface-modem-voice.c: In function
      ‘mm_iface_modem_voice_reload_all_calls’:
      ../src/mm-iface-modem-voice.c:2549:64: warning:
      passing argument 2 of ‘((MMIfaceModemVoice
      *)g_type_interface_peek((void *)((GTypeInstance *)self)->g_class,
      mm_iface_modem_voice_get_type()))->load_call_list’ from
      incompatible pointer type [-Wincompatible-pointer-types]
       2549 |
       reload_all_calls_ready,
            |
            ^~~~~~~~~~~~~~~~~~~~~~
            |
            |
            |
            void (*)(MMIfaceModemVoice *, GAsyncResult *, GTask *) {aka
            void (*)(struct _MMIfaceModemVoice *, struct _GAsyncResult *,
            struct _GTask *)}
      ../src/mm-iface-modem-voice.c:2549:64: note: expected
      ‘GAsyncReadyCallback’ {aka ‘void (*)(struct _GObject *,
      struct _GAsyncResult *, void *)’} but argument is of type ‘void
      (*)(MMIfaceModemVoice *, GAsyncResult *, GTask *)’ {aka ‘void
      (*)(struct _MMIfaceModemVoice *, struct _GAsyncResult *, struct
      _GTask *)’}

 src/mm-iface-modem-voice.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 03b75c85d0a4abe8c1595d9b23d3ae4cb320e2d8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Sep 8 10:12:20 2021 +0200

    broadband-modem-qmi: refactor process_get_all_call_info() to avoid
    handling the GTask

    The process_get_all_call_info() was not completing the input GTask on
    every possible code path (e.g. when remote party number or call info
    wasn't available).

    The method is now updated to avoid processing the GTask itself,
    instead it will attempt to build the call list and return a GError on
    any kind of failure.

 src/mm-broadband-modem-qmi.c | 27 ++++++++++++++++-----------
 1 file changed, 16 insertions(+), 11 deletions(-)

commit 15d66197b369384c72675b71ce83758289a87dc4
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Aug 15 16:53:18 2021 +0200

    mm-broadband-modem-qmi: add AT URCs fall back for calls

    Enable AT URCs for calls on top of QMI Voice indications
    for AT+QMI devices only. Some AT+QMI devices send unreliable
    QMI indications when the host is resuming. In such cases,
    AT URCs can be used as a fall back to make calls reliable.

    While AT+QMI devices relied before on AT commands to load
    call list information and handle AT URCs for async updates,
    this is now handled through QMI by forcefully reloading the
    call list instead of processing the AT URCs.
    This approach is disabled by default through the
    MM_IFACE_MODEM_VOICE_INDICATION_CALL_LIST_RELOAD_ENABLED property.
    This property is set to true in case of QMI modems.

 src/mm-broadband-modem-qmi.c | 233
 ++++++++++++++++++++++++++++++++++++++++++-
 src/mm-broadband-modem.c     |  57 +++++++++++
 src/mm-iface-modem-voice.c   |  56 +++++++++++
 src/mm-iface-modem-voice.h   |  15 ++-
 4 files changed, 356 insertions(+), 5 deletions(-)

commit 92ad38432c2a14d1ac310b58fde7d9336a45aff9
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Tue Aug 31 17:01:45 2021 +0200

    mm-modem-helpers: only parse calls in voice mode

    Calls in a CLCC response in data-only or fax-only mode
    do not count as actuall calls.

 src/mm-modem-helpers.c         | 23 +++++++++++++++++++++++
 src/tests/test-modem-helpers.c | 26 ++++++++++++++++++++++++++
 2 files changed, 49 insertions(+)

commit 97d15c49a3c74ff5b006f1f59dfae9d76a955d20
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:36:05 2021 +0200

    build,meson: add missing Call object support in introspection

 libmm-glib/generated/meson.build | 18 ++++++------------
 libmm-glib/meson.build           |  4 +---
 2 files changed, 7 insertions(+), 15 deletions(-)

commit b72069395ba53c8a3f45b357c257a7416e6e2179
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:29:26 2021 +0200

    build,autotools: add missing Call object support in introspection

 libmm-glib/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 145bbb40102f5d44db2877b7379f08a0993c7b57
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:24:16 2021 +0200

    test,lsudev: add attribute format to println()

      ../test/lsudev.c: In function ‘println’:
      ../test/lsudev.c:68:5: warning: function ‘println’
      might be a candidate for ‘gnu_printf’ format attribute
      [-Wsuggest-attribute=format]
         68 |     g_string_append_vprintf (output, fmt, args);
            |     ^~~~~~~~~~~~~~~~~~~~~~~

 test/lsudev.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit ba5ad78ed981c873592ac529978f4c77a7e6ee1a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:17:57 2021 +0200

    libmm-glib,location-3gpp: remove unused variable

      ../libmm-glib/mm-location-3gpp.c: In function
      ‘mm_location_3gpp_new_from_string_variant’:
      ../libmm-glib/mm-location-3gpp.c:400:16: warning: unused variable
      ‘operator_code’ [-Wunused-variable]
        400 |         gchar *operator_code;
            |                ^~~~~~~~~~~~~

 libmm-glib/mm-location-3gpp.c | 1 -
 1 file changed, 1 deletion(-)

commit f8bf6673dbff37156447c0f6d072da784031b11c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:16:29 2021 +0200

    libmm-glib,3gpp-profile: fix profile comparison logic

    Conveniently warned by the compiler...

      ../libmm-glib/mm-3gpp-profile.c: In function
      ‘mm_3gpp_profile_cmp’:
      ../libmm-glib/mm-3gpp-profile.c:98:1: warning: control reaches
      end of non-void function [-Wreturn-type]
         98 | }
            | ^

 libmm-glib/mm-3gpp-profile.c | 2 ++
 1 file changed, 2 insertions(+)

commit 12ada441567a48f0aacf4c0d3d42e46fbf956917
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:14:32 2021 +0200

    libmm-glib,simple-status: avoid shadowing 'properties' variable

      ../libmm-glib/mm-simple-status.c: In function
      ‘mm_simple_status_new_from_dictionary’:
      ../libmm-glib/mm-simple-status.c:426:21: warning: declaration of
      ‘properties’ shadows a global declaration [-Wshadow]
        426 |     MMSimpleStatus *properties;
            |                     ^~~~~~~~~~
      ../libmm-glib/mm-simple-status.c:55:20: note: shadowed declaration
      is here
         55 | static GParamSpec *properties[PROP_LAST];
            |                    ^~~~~~~~~~

 libmm-glib/mm-simple-status.c | 30 ++++++++++++++----------------
 1 file changed, 14 insertions(+), 16 deletions(-)

commit 93a0476b4d401117b879ee78236eb06ccb8b5813
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:11:01 2021 +0200

    libmm-glib,manager: fix warning with -Wdiscarded-qualifiers

      In file included from /usr/include/glib-2.0/glib.h:50,
                       from ../libmm-glib/mm-common-helpers.h:18,
                       from ../libmm-glib/mm-manager.c:27:
      /usr/include/glib-2.0/glib/ghash.h:68:61: note: expected
      ‘gpointer’ {aka ‘void *’} but argument is of type ‘const
      char *’
         68 |                                             gpointer
         key,
            |
            ~~~~~~~~~~~~~~~~^~~
      ../libmm-glib/mm-manager.c:81:43: warning: passing argument 2
      of ‘g_hash_table_insert’ discards ‘const’ qualifier from
      pointer target type [-Wdiscarded-qualifiers]
         81 |         g_hash_table_insert (lookup_hash,
         "org.freedesktop.ModemManager1.Modem.Simple",
         GSIZE_TO_POINTER (MM_TYPE_MODEM_SIMPLE));
            |
            ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      In file included from /usr/include/glib-2.0/glib.h:50,
                       from ../libmm-glib/mm-common-helpers.h:18,
                       from ../libmm-glib/mm-manager.c:27:

 libmm-glib/mm-manager.c | 27 +++++++++++++--------------
 1 file changed, 13 insertions(+), 14 deletions(-)

commit 5fc5c8ba18e620a251888f19f797e8a7380a809f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 11:04:30 2021 +0200

    build,meson: fix wrong install of simtech port types on thuraya plugin

 plugins/meson.build | 2 --
 1 file changed, 2 deletions(-)

commit 7060962c0a75c8abb7f525f06d71b780f98f4b28
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 10:57:10 2021 +0200

    build,meson: ignore warnings for missing field initializers

    We would usually explicitly skip initializing fields that are going to
    be zero-ed anyway.

 meson.build | 2 ++
 1 file changed, 2 insertions(+)

commit 2c8cab3670b6dfe4591ac0a4dbb3c9e30ed33356
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Sep 7 10:46:08 2021 +0200

    build,meson: disable float comparison warnings

    We have several symbols defined as floating point numbers that
    identify "unknown" values, e.g. MM_LOCATION_LONGITUDE_UNKNOWN. We want
    to be able to compare with those values directly, even if they're
    floats.

 meson.build | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 2bb699fc96e80bc2f98d88369718d2b768a53c8f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Aug 31 14:38:20 2021 +0200

    meson: introspection support enabled by default

 meson.build       | 5 ++++-
 meson_options.txt | 2 +-
 2 files changed, 5 insertions(+), 2 deletions(-)

commit 77d1c243614d385027ca11f75aa5d688b01c2969
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Jul 29 23:27:11 2021 +0200

    build: Port to meson

    meson is a build system focused on speed an ease of use, which
    helps speeding up the software development. This patch adds meson
    support along autotools.

 build-aux/mm-daemon-enums-types.c.template |   1 +
 build-aux/mm-daemon-enums-types.h.template |   1 +
 build-aux/mm-helper-enums-types.c.template |   1 +
 build-aux/mm-helper-enums-types.h.template |   1 +
 build-aux/mm-huawei-enums-types.c.template |   1 +
 build-aux/mm-huawei-enums-types.h.template |   1 +
 build-aux/mm-port-enums-types.c.template   |   1 +
 build-aux/mm-port-enums-types.h.template   |   1 +
 build-aux/mm-telit-enums-types.c.template  |   1 +
 build-aux/mm-telit-enums-types.h.template  |   1 +
 build-aux/mm-ublox-enums-types.c.template  |   1 +
 build-aux/mm-ublox-enums-types.h.template  |   1 +
 cli/meson.build                            |  47 ++
 data/meson.build                           |  74 +++
 docs/man/meson.build                       |   9 +
 docs/reference/api/meson.build             |  57 ++
 docs/reference/libmm-glib/meson.build      |  52 ++
 include/meson.build                        |  41 ++
 introspection/meson.build                  |  35 +
 libmm-glib/generated/meson.build           | 135 ++++
 libmm-glib/generated/tests/meson.build     |  26 +
 libmm-glib/meson.build                     | 179 ++++++
 libmm-glib/tests/meson.build               |  21 +
 libqcdm/src/meson.build                    |  33 +
 libqcdm/tests/meson.build                  |  42 ++
 meson.build                                | 445 +++++++++++++
 meson_options.txt                          |  99 +++
 plugins/meson.build                        | 989
 +++++++++++++++++++++++++++++
 plugins/symbol.map                         |   8 +
 po/meson.build                             |   4 +
 src/meson.build                            | 319 ++++++++++
 src/tests/meson.build                      |  38 ++
 test/meson.build                           |  22 +
 tools/tests/meson.build                    |  30 +
 tools/tests/services/meson.build           |   8 +
 35 files changed, 2725 insertions(+)

commit fa19b2b9b1412d3eeb515afe41c55ac414acc982
Author: Teemu Ikonen <tpikonen@mailbox.org>
Date:   Thu Aug 26 17:02:10 2021 +0300

    cli, location: Fix multi-sentence NMEA message output

    Multi-sentence NMEA messages were printed as is, that is with
    linebreaks, which made mmcli --location-get output look broken.

    Split NMEA sentences with linebreaks to separate output list items, so
    that they line up correctly.

 cli/mmcli-modem-location.c |  2 +-
 cli/mmcli-output.c         | 36 ++++++++++++++++++++++++++++++++++++
 cli/mmcli-output.h         |  2 ++
 3 files changed, 39 insertions(+), 1 deletion(-)

commit 7177eeea990f92dacebb967a5d418f3a372e5951
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Aug 31 15:30:59 2021 +0200

    build: use WITH_QRTR exclusively to check for QRTR support

    The user may request to disable QRTR support using `--without-qrtr`
    even if libqmi has QRTR support.

 src/mm-base-modem.c | 2 +-
 src/mm-port-qmi.h   | 4 +++-
 2 files changed, 4 insertions(+), 2 deletions(-)

commit d6dafe5cb4096cb2d664d3b6dcfcd7bd2269d79e
Author: Teemu Ikonen <tpikonen@mailbox.org>
Date:   Tue Aug 24 18:33:51 2021 +0300

    location-gps-nmea: Fix handling of multi-sentence NMEA messages

    Fixes the regexp in check_append_or_replace() to accept

     1. more multi-sentence NMEA messages (ALM, GSV, RTE, SFI)
     2. multi-sentence NMEA messages from all talkers, not just GPS
        (i.e. GPGSV, GLGSV, GAGSV etc.)

 libmm-glib/mm-location-gps-nmea.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5af93dbfeeb7336934f9713243ebf0ec28c2fd32
Author: Andrew Lassalle <andrewlassalle@chromium.org>
Date:   Fri Aug 27 09:42:15 2021 -0700

    broadband-modem-mbim: Fix password on initial EPS bearer settings

    Currently, we are sending the username twice instead of username and
    password. Fix the password value.

 src/mm-broadband-modem-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a20f2c052329a0d32ea3fee08e13d92b951f84fc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Aug 10 00:01:01 2021 +0200

    AUTHORS: update for 1.18.0

 AUTHORS | 62
 +++++++++++++++++++++++++++++++++++++++++++++++++++-----------
 1 file changed, 51 insertions(+), 11 deletions(-)

commit a41d6f6b15e7d8ac3702f84a816d6af22e243f1e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 23:52:36 2021 +0200

    NEWS: fix required libmbim version in 1.18

 NEWS | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c04b43a67e0d4260ba62d45dd41578aae86b4106
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 23:04:05 2021 +0200

    build: bump version to 1.17.900 (1.18-rc1)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a59ba7b1a95e03c2c3ad70110c550069e4e6e7e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 22:46:34 2021 +0200

    NEWS: update for 1.18.0

 NEWS | 200
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 200 insertions(+)

commit 686e37ff84daca6096fe18781ad9ba6f29cd4063
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 23:02:13 2021 +0200

    api: remove Modem.Sar interface

    There is no real implementation for it yet, so let's recover these
    changes once 1.18 has been released.

 docs/reference/api/Makefile.am                     |   1 -
 docs/reference/api/ModemManager-dbus-reference.xml |   1 -
 docs/reference/libmm-glib/libmm-glib-docs.xml      |   4 -
 docs/reference/libmm-glib/libmm-glib-sections.txt  |  74 ---------------
 introspection/Makefile.am                          |   1 -
 introspection/all.xml                              |   1 -
 .../org.freedesktop.ModemManager1.Modem.Sar.xml    | 102
 ---------------------
 libmm-glib/generated/Makefile.am                   |   3 -
 8 files changed, 187 deletions(-)

commit 30e94927e797e0fd2f51b913f7e17cce10d102e6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 22:47:11 2021 +0200

    build: require libqmi 1.30.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 55fd225be8896619cb450af72ab48e451e38e3e5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Aug 9 22:47:02 2021 +0200

    build: require libmbim 1.26.0

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 965c43fec7b5ca25483b1d73f0bdec339636f996
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jul 31 23:45:26 2021 +0200

    port-qmi: limit MTU to max RMNET packet size

    The maximum MTU that the master interface can support should be less
    or equal than RMNET_MAX_PACKET_SIZE, as defined in the
    `rmnet_private.h` file in the linux sources (not a public header).

    Only applicable to RMNET link management (i.e. not to qmi_wwan
    add_mux/del_mux).

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/libqmi/-/issues/71

 src/mm-port-qmi.c | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 5adc469701abc6b08432cb0f59294cb52755354b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Aug 6 09:20:53 2021 +0200

    port-qmi: only consider port setup not needed if data modes match

    When not requesting multiplexing support, only assume we don't need
    any additional setup if multiplexing is disabled AND if the data modes
    match between kernel and device.

    This fixes the connection setup in MSM8916 (rpmsg+bam/dmux).

 src/mm-port-qmi.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 185e492c0a0e633ed92f8ffdb1c426d0e4300ae1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 29 00:07:27 2021 +0200

    core: new '--test-multiplex-requested' option

    The new option will change the default setting in MBIM and QMI bearers
    to "request" when no explicit "multiplex" configuration is given by
    the user.

    This option will help test the multiplexing support in the modems
    before it's made a default in a future release.

 src/mm-bearer-mbim.c |  9 +++++++--
 src/mm-bearer-qmi.c  |  5 ++++-
 src/mm-context.c     | 13 +++++++++++++
 src/mm-context.h     |  3 ++-
 4 files changed, 26 insertions(+), 4 deletions(-)

commit c49f3f5f46e6f1a27108e9826c32af776ec111f9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 28 23:55:04 2021 +0200

    bearer-qmi: don't enable multiplexing by default unless in IPA

    The next 1.18 release will have multiplexing support, but not enabled
    by default, to avoid breaking setups that don't expect the new virtual
    net interfaces for the multiplexed sessions.

    The exception is Qualcomm SoCs using the IPA driver, where
    multiplexing is fully required.

 src/mm-bearer-qmi.c | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

commit 062851423945126bb3b419571bbcf8996b086cde
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 28 23:47:41 2021 +0200

    bearer-mbim: don't enable multiplexing by default

    The next 1.18 release will have multiplexing support, but not enabled
    by default, to avoid breaking setups that don't expect the new virtual
    net interfaces for the multiplexed sessions.

 src/mm-bearer-mbim.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 168ec6ba096809ceae8d7b58e875aeba88eb5d1e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 28 23:46:33 2021 +0200

    broadband-bearer: default to 'none' if no multiplexing config provided

 src/mm-broadband-bearer.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 8d019a399ca8dd29f959477e2be36b252497a90b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 28 23:42:56 2021 +0200

    base-bearer: remove default multiplex support symbol

    Using "requested" as a common default for every possible
    implementation works, because it can handle setups without
    multiplexing capabilities (e.g. plain AT+PPP modems) and also setups
    without non-multiplexing capabilities (e.g. IPA based SoCs).

    But if we don't want "requested" as default, then there will be
    failing cases; e.g. we cannot use "none" as default for all as it
    would break IPA, and we cannot use "required" as default for all as it
    would break AT+PPP setups.

    So, remove the common default, it's not flexible enough.

 src/mm-base-bearer.h      | 5 -----
 src/mm-bearer-mbim.c      | 4 ++--
 src/mm-bearer-qmi.c       | 4 ++--
 src/mm-broadband-bearer.c | 4 ++--
 4 files changed, 6 insertions(+), 11 deletions(-)

commit 4a07ab39f14d3879c9168e5d7da3b8a0a32bfb61
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 13:18:57 2021 +0200

    broadband-modem-qmi: fix max bearers computation in IPA based setups

    In IPA based setups, there are only multiplexed bearers supported,
    there is no way to not enable multiplexing.

    We change the logic that computes the maximum number of multiplexed
    and non-multiplexed bearers, so that we check which are the current
    kernel data modes before computing them.

 src/mm-broadband-modem-qmi.c | 37 ++++++++++++++++++++++++-------------
 1 file changed, 24 insertions(+), 13 deletions(-)

commit 04dba846c9659f7066d44acd6ecddbe76b2fc880
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 13:18:29 2021 +0200

    bearer-list: if non-multiplexing not supported, 0 max non-multiplexed
    bearers

 src/mm-bearer-list.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9d2782cc5a7f63f88e8909abc7246e0cc853f059
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 13:03:40 2021 +0200

    bearer-list: if multiplexing not supported, 0 max multiplexed bearers

    Fixes warnings on AT+PPP based devices:

       ModemManager[602870]: <debug> [1626948725.168355] [modem0]
       allowed up to 1 active bearers

       (ModemManager:602870): GLib-GObject-WARNING **: 12:12:05.185:
       value "0" of type 'guint' is invalid or out of range for property
       'max-active-multiplexed-bearers' of type 'guint'

 src/mm-bearer-list.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f72046701659073fbfa97516e155865647acb154
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Mon Aug 9 15:45:59 2021 +0800

    foxconn: add T99W175 carrier mapping table

 plugins/Makefile.am                                |   8 +-
 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c  |  12 +-
 .../mm-foxconn-t99w175-carrier-mapping.conf        | 344
 +++++++++++++++++++++
 plugins/tests/test-keyfiles.c                      |   7 +
 4 files changed, 368 insertions(+), 3 deletions(-)

commit 10521ce248bf29cd37c3db4a41b865bd1e6de7ae
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Mon Aug 9 15:40:03 2021 +0800

    foxconn: update T77W968 carrier mapping table

 .../foxconn/mm-foxconn-t77w968-carrier-mapping.conf    | 18
 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 33e2b023ef01bea9da37ae2beb192f7d92bce47a
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Wed Aug 4 15:45:49 2021 +0800

    foxconn: Rename carrier-mapping to t77w968-carrier-mapping

 plugins/Makefile.am                                                 |
 4 ++--
 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c                   |
 2 +-
 ...carrier-mapping.conf => mm-foxconn-t77w968-carrier-mapping.conf} | 0
 plugins/tests/test-keyfiles.c                                       |
 6 +++---
 4 files changed, 6 insertions(+), 6 deletions(-)

commit 180bd633810d7107b9041441dc768bda72c83c72
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Aug 6 10:18:46 2021 +0200

    ci: switch to build libqrtr-glib from git using meson

 .gitlab-ci.yml | 21 +++++++++------------
 1 file changed, 9 insertions(+), 12 deletions(-)

commit 7eb6495c485e107b5867840c8e89ac6504cbb7c1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Aug 6 10:15:01 2021 +0200

    ci: switch to build libqmi from git using meson

 .gitlab-ci.yml | 35 +++++++++++++++--------------------
 1 file changed, 15 insertions(+), 20 deletions(-)

commit b77c15f8b54c061b3429b762a5e8aaafe274e8b2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Aug 4 11:17:54 2021 +0200

    broadband-modem-mbim: minor rework in SIM event related comments

 src/mm-broadband-modem-mbim.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit bcf5f2bc8b1e5ed2f2ef5fed083f80ea6f05a996
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Aug 4 11:12:59 2021 +0200

    broadband-modem-mbim: also report as available not fully ready SIMs

    If a SIM card is not fully ready or in a failed state in the
    non-active slot, we should still report them as available.

 src/mm-broadband-modem-mbim.c | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit 3004e99fcb0ea396b25c31aacaac0b377996f689
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Mon Jul 26 20:10:45 2021 +0800

    broadband-modem-mbim: deal with the slot info status notification
    event for DSSA

 src/mm-broadband-modem-mbim.c | 93
 +++++++++++++++++++++++++++++++++++++++----
 1 file changed, 85 insertions(+), 8 deletions(-)

commit 9e5e699227f43e3dd64933dc96508b88b1a76bba
Author: Loic Poulain <loic.poulain@linaro.org>
Date:   Tue Aug 3 18:05:18 2021 +0200

    kernel-device-generic: Fix ptr_array_add_sysfs_attribute_link_basename

    A pointer can not be used anymore after its ownership has been
    transfered
    using the g_steal_pointer function (pointer is nullified).

    In this function, g_steal_pointer() is used when inserting 'value'
    inside
    the array but can also be subsequently used when dumping 'value' to
    'out_value' via g_strdup().

    Fix that with simple reordering.

    Signed-off-by: Loic Poulain <loic.poulain@linaro.org>

 src/kerneldevice/mm-kernel-device-generic.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit b91bf1e3a648080b00d6a2fde2b5798a658027eb
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Sun Jul 18 10:13:25 2021 +0530

    modem-qmi: implement multiparty functionalities

    The following functionalities are implemented:
    1. Hold all and accept
    2. Hangup all and accept
    3. Hangup all
    4. Join multiparty
    5. Leave multiparty
    6. Call transfer

 src/mm-broadband-modem-qmi.c | 246
 +++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 246 insertions(+)

commit 691cb9b694a109fd917754f99bc94d4e86a9a157
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Sun Jul 18 09:33:46 2021 +0530

    modem-qmi: implement call waiting setup and query

 src/mm-broadband-modem-qmi.c | 168
 +++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 168 insertions(+)

commit 1894dd77679b2a24abce08c72f3da54d1332ba2d
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Sun Jul 18 03:12:12 2021 +0530

    modem-qmi: implement setup in call unsolicited events

    Handle supplementary service notification indication.
    Useful to know when existing call is on hold, unheld and waiting.

 src/mm-broadband-modem-qmi.c | 124
 ++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 123 insertions(+), 1 deletion(-)

commit 82054410e2f1668e9418616c24f35a5b3c6826fe
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Sun Jul 18 02:07:04 2021 +0530

    call-list: allow getting call object by index

 src/mm-call-list.c | 20 ++++++++++++++++++++
 src/mm-call-list.h |  3 +++
 2 files changed, 23 insertions(+)

commit 99ba7ee266965c1986b63a1083deaac23b220c33
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Mon Jul 26 15:10:34 2021 +0530

    build: bump libqmi requirement to support voice supplementary services

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0610267fa812d3a8c2c4777a06f0f5c7f4345ac6
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Mon Aug 2 12:42:13 2021 +0300

    test,modem-helpers: add test case of AT+CPOL? response parsing

 src/tests/test-modem-helpers.c | 78
 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 78 insertions(+)

commit 948099bff0b2add3b788da48e89dbb0bb406db93
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Mon Aug 2 12:39:38 2021 +0300

    modem-helpers: allow unquoted operator code in AT+CPOL? response

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/409

 src/mm-modem-helpers.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f9d2168c523716a306da5f8a13e13732a6fae6ca
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Aug 1 14:37:17 2021 +0200

    telit: disable +CPOL based features in the LN930

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/414

 plugins/telit/77-mm-telit-port-types.rules | 18 +++++++++++++-----
 1 file changed, 13 insertions(+), 5 deletions(-)

commit 999df00d58df4ea088e19ea9f9dd73a8bb077fb5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 30 16:43:08 2021 +0200

    fibocom: fix QMI device allowance

    E.g. for a FM150:

       [1627656003.230873] [cdc-wdm0] port contents loaded:
       [1627656003.231069] [cdc-wdm0]   bus: usb
       [1627656003.231179] [cdc-wdm0]   interface:
       /sys/devices/pci0000:00/0000:00:14.0/usb1/1-11/1-11.4/1-11.4.4/1-11.4.4:1.4
       [1627656003.231272] [cdc-wdm0]   device:
       /sys/devices/pci0000:00/0000:00:14.0/usb1/1-11/1-11.4/1-11.4.4
       [1627656003.231364] [cdc-wdm0]   driver: qmi_wwan
       [1627656003.231450] [cdc-wdm0]   vendor: 2cb7
       [1627656003.231536] [cdc-wdm0]   product: 0104
       [1627656003.231626] [cdc-wdm0]   revision: 0414
       [1627656003.231722] [base-manager]
       adding port cdc-wdm0 at sysfs path:
       /sys/devices/pci0000:00/0000:00:14.0/usb1/1-11/1-11.4/1-11.4.4/1-11.4.4:1.4/usbmisc/cdc-wdm0
       ...
       [1627656004.333874] [plugin/fibocom] port cdc-wdm0 filtered by
       implicit QMI driver

 plugins/fibocom/mm-plugin-fibocom.c | 1 +
 1 file changed, 1 insertion(+)

commit c4130dcf8307fb13b4f6e87fd468bde9c89f37bb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 29 16:59:52 2021 +0200

    huawei: disable CPOL based features in the R215

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/411

 plugins/huawei/77-mm-huawei-net-port-types.rules | 3 +++
 1 file changed, 3 insertions(+)

commit 13d82c1de205e9eaafc21c17858ff6ed03543b03
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 29 16:57:30 2021 +0200

    huawei: ignore ^LWURC URCs

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/412

 plugins/huawei/mm-broadband-modem-huawei.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit b0248e471ced05dfd5fa1cebe732722d10738add
Author: Loic Poulain <loic.poulain@linaro.org>
Date:   Fri Jul 30 15:34:17 2021 +0200

    kernel-device: generic: Support ATTR condition

    Only the plural ATTRS form was checked but we also need to support
    the single ATTR for matching device's attribute only.

    Signed-off-by: Loic Poulain <loic.poulain@linaro.org>

 src/kerneldevice/mm-kernel-device-generic.c | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 7c4db66eb34eebecc6b17fe86375e081b49bff00
Author: Iñigo Martínez <inigomartinez@gmail.com>
Date:   Thu Jul 29 23:45:52 2021 +0200

    build: Rename template files

    The template files in the `build-aux` directory used in enums sources
    and headers generation use the `{$name}-template.[ch]` pattern.
    However, the examples in the official guide[0] and usually GNOME and
    Freedesktop packages use the `{$name}.[ch].template` pattern.

    Due to this, the name of the template files and build commands have
    been changed.

    [0] https://developer.gnome.org/gobject/stable/glib-mkenums.html

 build-aux/Makefile.am                              | 10 ++++-----
 ...-enums-template.c => mm-enums-types.c.template} |  0
 ...-enums-template.h => mm-enums-types.h.template} |  0
 ...arks-template.c => mm-errors-quarks.c.template} |  0
 ...rrors-template.c => mm-errors-types.c.template} |  0
 ...rrors-template.h => mm-errors-types.h.template} |  0
 libmm-glib/generated/Makefile.am                   | 20
 +++++++++---------
 plugins/Makefile.am                                | 24
 +++++++++++-----------
 src/Makefile.am                                    | 24
 +++++++++++-----------
 9 files changed, 39 insertions(+), 39 deletions(-)

commit b935782010edabff0b37a4256235e63bc6f946ec
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 29 12:54:21 2021 +0200

    cinterion: increase ^SCFG? timeout to 120s

    The timeout in this command is extremely large, because there are some
    modules like the EGS5 that build the response based on the current
    network registration, and that implies the module needs to be
    registered. If for any reason there is no serving network where to
    register, the response comes after a very long time, up to 100s.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/408

 plugins/cinterion/mm-broadband-modem-cinterion.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 2590c4f0d71a1c4e68d550ef0f68091951af8606
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 28 15:04:41 2021 +0200

    ci: switch to build libmbim from git using meson

 .gitlab-ci.yml | 27 ++++++++++++---------------
 1 file changed, 12 insertions(+), 15 deletions(-)

commit 15f53851c82f05a1456fd5adba5aec765236d0bc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 15:51:10 2021 +0200

    port-mbim: increase timeout of first command after port open

    The port open operation may be happening very early after the device
    has booted, so let's give the module some more time to reply the very
    first MBIM query we do. The original 10s seems to be a bit tight in
    some cases.

    See
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/405#note_1006746

 src/mm-port-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bcf11c0e50e4d37334777a1d34b950dc10af5b76
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 16:43:39 2021 +0200

    port-qmi: open without data format explicitly if requested by user

    Regardless of whether WDA is supported or not.

 src/mm-port-qmi.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee0f473233f3836e2b8c28bc35b41c2ac0806722
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 16:29:35 2021 +0200

    port-qmi: early check if WDA is supported

    We should check if WDA is supported before running any other logic
    that may change the state of the kernel or the modem. E.g. if we don't
    do this as the first step, the loading of the supported kernel data
    modes may end up changing the expected kernel data mode to raw-ip.

 src/mm-port-qmi.c | 80
 ++++++++++++++++++++++++++-----------------------------
 1 file changed, 38 insertions(+), 42 deletions(-)

commit ae09baf61b208bb155ace947b128abefb00b8e4d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 16:06:01 2021 +0200

    port-qmi: cleanly close device if an open operation failed

       ModemManager[703345]: <debug> [1626962477.971869] [modem0] couldn't
       open QMI port with data format update: Unexpected kernel data mode:
       cannot setup using CTL
       ModemManager[703345]: <debug> [1626962477.972197] [cdc-wdm0/qmi]
       Opening QMI device...
       ModemManager[703345]: <debug> [1626962477.972310] [cdc-wdm0/qmi]
       Checking if QMI device already opening...
       ModemManager[703345]: <warn>  [1626962477.975182] [modem0] couldn't
       start initialization: QMI device open/close operation in progress

 src/mm-port-qmi.c | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 9be34affe25d317c4391be38d2a1887ac785d76a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 15:59:18 2021 +0200

    port-qmi: support devices that only run in 802.3 mode

    E.g. the ZTE MF190 has a very old QMI firmware that is not able to run
    CTL Set Data Format (raw-ip).

       ModemManager[666366]: [/dev/cdc-wdm0] QMI Device supports
       4 services:
       ModemManager[666366]: [/dev/cdc-wdm0]    ctl (1.2)
       ModemManager[666366]: [/dev/cdc-wdm0]    wds (1.3)
       ModemManager[666366]: [/dev/cdc-wdm0]    dms (1.2)
       ModemManager[666366]: [/dev/cdc-wdm0]    nas (1.0)
       ModemManager[666366]: [/dev/cdc-wdm0] Setting network port data
       format...
       ModemManager[666366]: [/dev/cdc-wdm0] Sent message...
       <<<<<< RAW:
       <<<<<<   length = 21
       <<<<<<   data   =
       01:14:00:00:00:00:00:03:26:00:09:00:10:02:00:02:00:01:01:00:00
       ModemManager[666366]: [/dev/cdc-wdm0] Sent generic request
       (translated)...
       <<<<<< QMUX:
       <<<<<<   length  = 20
       <<<<<<   flags   = 0x00
       <<<<<<   service = "ctl"
       <<<<<<   client  = 0
       <<<<<< QMI:
       <<<<<<   flags       = "none"
       <<<<<<   transaction = 3
       <<<<<<   tlv_length  = 9
       <<<<<<   message     = "Set Data Format" (0x0026)
       <<<<<< TLV:
       <<<<<<   type       = "Protocol" (0x10)
       <<<<<<   length     = 2
       <<<<<<   value      = 02:00
       <<<<<<   translated = raw-ip
       <<<<<< TLV:
       <<<<<<   type       = "Format" (0x01)
       <<<<<<   length     = 1
       <<<<<<   value      = 00
       <<<<<<   translated = absent
       ModemManager[666366]: [/dev/cdc-wdm0] Received message...
       <<<<<< RAW:
       <<<<<<   length = 19
       <<<<<<   data   =
       01:12:00:80:00:00:01:03:26:00:07:00:02:04:00:01:00:2D:00
       ModemManager[666366]: [/dev/cdc-wdm0] Received generic response
       (translated)...
       <<<<<< QMUX:
       <<<<<<   length  = 18
       <<<<<<   flags   = 0x80
       <<<<<<   service = "ctl"
       <<<<<<   client  = 0
       <<<<<< QMI:
       <<<<<<   flags       = "response"
       <<<<<<   transaction = 3
       <<<<<<   tlv_length  = 7
       <<<<<<   message     = "Set Data Format" (0x0026)
       <<<<<< TLV:
       <<<<<<   type       = "Result" (0x02)
       <<<<<<   length     = 4
       <<<<<<   value      = 01:00:2D:00
       <<<<<<   translated = FAILURE: InvalidDataFormat
       ModemManager[666366]: <debug> [1626961628.001354] [cdc-wdm0/qmi]
       QMI port open operation failed: QMI protocol error (45):
       'InvalidDataFormat'
       ModemManager[666366]: <warn>  [1626961628.002563] [modem0] couldn't
       start initialization: QMI protocol error (45): 'InvalidDataFormat'
       ModemManager[666366]: <warn>  [1626961628.004181] [modem0]
       couldn't initialize: 'Modem is unusable, cannot fully initialize'

 src/mm-port-qmi.c | 27 ++++++++++++++++++++++++---
 1 file changed, 24 insertions(+), 3 deletions(-)

commit 939cf166dd43a3cebd17b1a29b52cdc300f8f7e9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 00:37:33 2021 +0200

    broadband-modem-qmi: remove trailing whitespaces

 src/mm-broadband-modem-qmi.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c43ab6d3308c09b73243d837889bb0c3489bd3fb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 27 00:11:56 2021 +0200

    ci: remove autoconf-archive from template

 .gitlab-ci.yml | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e4d4bbbb722e9214b3ba896be6243a7228f7aba7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jul 26 23:53:11 2021 +0200

    huawei: plug memleak when processing GETPORTMODE hints

       ==99766== 96 (24 direct, 72 indirect) bytes in 1 blocks are
       definitely lost in loss record 3,791 of 4,243
       ==99766==    at 0x483E7C5: malloc (vg_replace_malloc.c:380)
       ==99766==    by 0x50DCAC9: g_malloc (gmem.c:106)
       ==99766==    by 0x50F46D6: g_slice_alloc (gslice.c:1069)
       ==99766==    by 0x50CE9F2: g_list_insert_sorted_real (glist.c:1109)
       ==99766==    by 0x753DE92: ???
       ==99766==    by 0x753E6D4: ???
       ==99766==    by 0x753E897: ???
       ==99766==    by 0x1F059D: mm_plugin_create_modem (mm-plugin.c:922)
       ==99766==    by 0x166693: mm_device_create_modem (mm-device.c:481)
       ==99766==    by 0x161547: device_support_check_ready
       (mm-base-manager.c:219)
       ==99766==    by 0x4F03533: g_task_return_now (gtask.c:1219)
       ==99766==    by 0x4F07078: UnknownInlinedFun (gtask.c:1289)
       ==99766==    by 0x4F07078: g_task_return (gtask.c:1245)

 plugins/huawei/mm-plugin-huawei.c | 2 ++
 1 file changed, 2 insertions(+)

commit 0d1952c489c93513836385ae9c72c5e272630990
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 23 01:01:53 2021 +0200

    option: disable preferred networks management in custom SIM object

    It's been observed that running CPOL? would completely break the AT
    port of the modules like the GIO225.

    Fully disable this feature in the whole option and option-hso plugins,
    by creating a new custom SIM object with the features disabled
    completely, and setup as a new shared interface object.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/404

 plugins/Makefile.am                        |  4 ++
 plugins/option/mm-broadband-modem-hso.c    | 10 ++++
 plugins/option/mm-broadband-modem-option.c | 10 ++++
 plugins/option/mm-shared-option.c          | 77
 +++++++++++++++++++++++++++
 plugins/option/mm-shared-option.h          | 49 +++++++++++++++++
 plugins/option/mm-sim-option.c             | 84
 ++++++++++++++++++++++++++++++
 plugins/option/mm-sim-option.h             | 51 ++++++++++++++++++
 7 files changed, 285 insertions(+)

commit af0fba05856f76e2bfd31b597f647f7955e2611a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 23 01:00:47 2021 +0200

    iridium: disable preferred networks management in SIM object

    It's not applicable to Iridium modems, which only work with one single
    operator.

 plugins/iridium/mm-sim-iridium.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 689769467a31ef5cbcc7b5abfc7a0a48eeaf41be
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 23:50:58 2021 +0200

    libqcdm: plug leak in qcdm_cdm_log_config_new()

       ==748616== 37 bytes in 1 blocks are definitely lost in loss record
       2,850 of 4,938
       ==748616==    at 0x48435FF: calloc (vg_replace_malloc.c:1117)
       ==748616==    by 0x249CCF: qcdm_cmd_log_config_new
       (commands.c:1742)
       ==748616==    by 0x24A321: qcdm_cmd_log_config_set_mask_new
       (commands.c:1901)
       ==748616==    by 0x1DAE12:
       modem_cdma_setup_cleanup_unsolicited_events
       (mm-broadband-modem.c:8643)
       ==748616==    by 0x1DAF21: modem_cdma_setup_unsolicited_events
       (mm-broadband-modem.c:8671)
       ==748616==    by 0x1AE49F: interface_enabling_step
       (mm-iface-modem-cdma.c:1627)
       ==748616==    by 0x1AE680: mm_iface_modem_cdma_enable
       (mm-iface-modem-cdma.c:1693)
       ==748616==    by 0x1E2DF6: enabling_step
       (mm-broadband-modem.c:11756)
       ==748616==    by 0x1E204E: iface_modem_3gpp_ussd_enable_ready
       (mm-broadband-modem.c:11606)
       ==748616==    by 0x4F03533: g_task_return_now (gtask.c:1219)
       ==748616==    by 0x4F07078: UnknownInlinedFun (gtask.c:1289)
       ==748616==    by 0x4F07078: g_task_return (gtask.c:1245)
       ==748616==    by 0x1AA323: interface_enabling_step
       (mm-iface-modem-3gpp-ussd.c:702)

 libqcdm/src/commands.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 4bd8845f50755faf3279954c716b0476fbd0dc86
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 14:44:02 2021 +0200

    build: import used AX_ macros from autoconf-archive

    This allows us to build from git without build-depending on
    autoconf-archive, which is not always available as a package.

 m4/ax_append_compile_flags.m4   |  46 ++++++++++++
 m4/ax_append_flag.m4            |  50 +++++++++++++
 m4/ax_append_link_flags.m4      |  44 +++++++++++
 m4/ax_check_compile_flag.m4     |  53 +++++++++++++
 m4/ax_check_link_flag.m4        |  53 +++++++++++++
 m4/ax_compiler_flags.m4         | 158
 +++++++++++++++++++++++++++++++++++++++
 m4/ax_compiler_flags_cflags.m4  | 161
 ++++++++++++++++++++++++++++++++++++++++
 m4/ax_compiler_flags_gir.m4     |  60 +++++++++++++++
 m4/ax_compiler_flags_ldflags.m4 | 111 +++++++++++++++++++++++++++
 m4/ax_is_release.m4             |  80 ++++++++++++++++++++
 m4/ax_require_defined.m4        |  37 +++++++++
 11 files changed, 853 insertions(+)

commit bdd340455a7c29f9d1280161919a6b15c645b6c9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 22 14:43:02 2021 +0200

    build: update introspection.m4

    In sync with gobject-introspection 1.68.0

 m4/introspection.m4 | 58
 +++++++++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 52 insertions(+), 6 deletions(-)

commit 064624c69dd25a888996dfc40f16f823daf5ba16
Author: Loic Poulain <loic.poulain@linaro.org>
Date:   Mon Jul 26 16:10:25 2021 +0200

    bearer-mbim: Disable multiplex support for wwan devices

    WWAN network devices expose link management over netlink (wwan type),
    but it is not yet supported by libmbim.

    Signed-off-by: Loic Poulain <loic.poulain@linaro.org>

 src/mm-bearer-mbim.c | 3 +++
 1 file changed, 3 insertions(+)

commit 2f38ea0155d7e9dde8b7ed7f04a89e5945c4fca6
Author: Loic Poulain <loic.poulain@linaro.org>
Date:   Mon Jul 26 16:08:40 2021 +0200

    kernel-device: Add get_wwandev_sysfs_path

    The wwan subsystem is a new bus agnostic framework exposing wwan
    device and its components (ports, netdev...). It can be useful to
    get the wwan device a device belongs to

    Signed-off-by: Loic Poulain <loic.poulain@linaro.org>

 src/kerneldevice/mm-kernel-device-generic.c | 34
 +++++++++++++++++++++++++++++
 src/kerneldevice/mm-kernel-device-udev.c    | 22 +++++++++++++++++++
 src/kerneldevice/mm-kernel-device.c         |  8 +++++++
 src/kerneldevice/mm-kernel-device.h         |  4 ++++
 4 files changed, 68 insertions(+)

commit 97ab5173482d0c6f37029191796c545c99d01fe5
Author: Pavan Holla <pholla@chromium.org>
Date:   Fri Jul 23 03:04:34 2021 +0000

    mm-sim-mbim: Remove trailing F in ICCID

    QMI modems remove trailing F in 19 digit ICCID. Do the same on
    MBIM modems for consistency.

 src/mm-sim-mbim.c | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

commit 0faf969e306b6e2f15f840692d30722c88560e13
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Jul 25 16:17:56 2021 +0200

    introspection: signal quality signature is (ub)

    Signal quality property signature of the Modem Simple interface
    is not an unsigned integer, but a struct containing
    an unsigned integer indicating the strength and
    a boolean to indicate if the value was recently taken.

 introspection/org.freedesktop.ModemManager1.Modem.Simple.xml | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 95f4a232cefe76b4bfc664f8dc37e68471c4a77a
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Wed Jul 21 12:55:48 2021 +0530

    port-qmi: open dpm port automatically in case of IPA net driver

    Requires IPA kernel driver to expose the TX and RX endpoint IDs
    through sysfs.
    Available from linux 5.14 onwards.

 src/mm-port-qmi.c | 142
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 142 insertions(+)

commit 3b79f7379fa71286ac77f7f0be1025129bb9e0dd
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Wed Jul 21 12:41:57 2021 +0530

    base-modem: set net sysfs path

    Required by MMPortQmi for fetching the TX and RX endpoint IDs
    through sysfs from linux 5.14 onwards

 src/mm-base-modem.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 43c9c47b04750c1d7c8d3b7c9d9d1d79490e2da4
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Wed Jul 21 12:40:31 2021 +0530

    port-qmi: allow MMPortQmi to get the net sysfs path

    Will be set by base modem when organizing ports, similar to
    net driver name. Required for fetching the TX and RX endpoint IDs
    through sysfs from linux 5.14 onwards.

 src/mm-port-qmi.c | 13 +++++++++++++
 src/mm-port-qmi.h |  3 +++
 2 files changed, 16 insertions(+)

commit 1d4caa929f8766cb926dc2578e29d389fe186d41
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 11:26:32 2021 +0200

    broadband-modem-mbim: fix passing new slots array in the set operation

 src/mm-broadband-modem-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1830801f0f3302ffa038c93fc0749911080693b9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 11:07:50 2021 +0200

    broadband-modem-mbim: slot index in MM starts at 1

    When querying the slots using "Slot info status", the modem expects
    the slot index passed in the [0,number_slots-1] range.

    But for the ModemManager API, the slot indices start at 1; i.e. they
    are in the [1,number_of_slots] range.

    Consider that wen reporting the current slot index using MBIM.

 src/mm-broadband-modem-mbim.c | 19 ++++++++++++-------
 1 file changed, 12 insertions(+), 7 deletions(-)

commit 48261375d3899938171d03f9ee164443644593ba
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Fri Jul 9 10:59:43 2021 +0800

    mm-broadband-modem-mbim: implement the set_primary_sim_slot() method
    for DSSA

 src/mm-broadband-modem-mbim.c | 184
 +++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 180 insertions(+), 4 deletions(-)

commit b151740d1598ab456d5bd2293babefe1cc2964f6
Author: ZhangMingjie <superzmj@fibocom.com>
Date:   Fri Jun 25 12:05:52 2021 +0800

    mm-broadband-modem-mbim: implement the load_sim_slots() method
    for DSSA

 src/mm-broadband-modem-mbim.c | 352
 +++++++++++++++++++++++++++++++++++++++++-
 src/mm-broadband-modem-mbim.h |   1 -
 src/mm-sim-mbim.c             |  28 ++++
 src/mm-sim-mbim.h             |  10 +-
 4 files changed, 387 insertions(+), 4 deletions(-)

commit 9d31113edb8125db0d01a36d024c089f0ce98aa1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 15:13:06 2021 +0200

    build: bump libmbim requirement to support DSSA operations

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c750339d5025b70e1f0750eb8504d6e2ee2d6ad8
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Wed Jul 14 03:41:42 2021 +0530

    modem-qmi: disable call list check in case of QMI

    Fixes AT load call list function messing up with the call list
    in case of both AT+QMI is available for a given modem.

 src/mm-broadband-modem-qmi.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 5db3e330b92b1854fc1156ff1fd2c0d03072da45
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 00:22:48 2021 +0200

    hso: query profile id from hso bearer during connecting phase

    As the profile id is not really set in the base bearer object until
    after connected.

 plugins/option/mm-broadband-bearer-hso.c | 19 +++++++++++++++++++
 plugins/option/mm-broadband-bearer-hso.h |  2 ++
 plugins/option/mm-broadband-modem-hso.c  | 14 +++++++++++++-
 3 files changed, 34 insertions(+), 1 deletion(-)

commit cadce188655c685614340073c469f4fb800f74f7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 00:10:38 2021 +0200

    icera: fix segfault during connection reset logic

        ==252789== Process terminating with default action of signal 11
        (SIGSEGV): dumping core
        ==252789==  Access not within mapped region at address 0x28
        ==252789==    at 0x7D17D22: connect_reset_ready
        (mm-broadband-bearer-icera.c:419)
        ==252789==    by 0x4EEC242: g_simple_async_result_complete
        (gsimpleasyncresult.c:802)
        ==252789==    by 0x17EFC6: at_command_ready
        (mm-base-modem-at.c:538)
        ==252789==    by 0x4EEC242: g_simple_async_result_complete
        (gsimpleasyncresult.c:802)
        ==252789==    by 0x259423: serial_command_ready
        (mm-port-serial-at.c:393)
        ==252789==    by 0x4EEC242: g_simple_async_result_complete
        (gsimpleasyncresult.c:802)
        ==252789==    by 0x252B9B: command_context_complete_and_free
        (mm-port-serial.c:141)
        ==252789==    by 0x254542: port_serial_got_response
        (mm-port-serial.c:755)
        ==252789==    by 0x254A78: parse_response_buffer
        (mm-port-serial.c:926)
        ==252789==    by 0x254FFE: common_input_available
        (mm-port-serial.c:1035)
        ==252789==    by 0x2550DE: iochannel_input_available
        (mm-port-serial.c:1058)
        ==252789==    by 0x50D3F84: UnknownInlinedFun (gmain.c:3344)
        ==252789==    by 0x50D3F84: g_main_context_dispatch (gmain.c:4062)

 plugins/icera/mm-broadband-bearer-icera.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f72fe9577c411bdd8e4ee2b316ed6c621722a259
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jul 14 00:08:48 2021 +0200

    icera: query profile id from icera bearer during connecting phase

    As the profile id is not really set in the base bearer object until
    after connected.

 plugins/icera/mm-broadband-bearer-icera.c | 19 +++++++++++++++++++
 plugins/icera/mm-broadband-bearer-icera.h |  2 ++
 plugins/icera/mm-broadband-modem-icera.c  | 13 +++++++++++--
 3 files changed, 32 insertions(+), 2 deletions(-)

commit fc512c711fbc6a1b66bc3f0b56ec650603bd9b7f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 23:30:23 2021 +0200

    simtech: disable CPOL? checks in SIM7070

    The whole device breaks when the CPOL? query is sent; happening
    consistently all the time:

        <debug> [1626211395.825257] [modem4/ttyUSB3/at] -->
        'AT+CPOL=,2<CR>'
        <debug> [1626211395.842156] [modem4/ttyUSB3/at] <--
        '<CR><LF>OK<CR><LF>'
        <debug> [1626211395.843227] [modem4/sim4] loading preferred
        networks...
        <debug> [1626211395.845289] [modem4/ttyUSB3/at] --> 'AT+CPOL?<CR>'
        <debug> [1626211401.110974] [modem4/ttyUSB3/at] unexpected
        port hangup!
        <debug> [1626211401.111586] [modem4/ttyUSB3/at] forced to
        close port
        <debug> [1626211401.112331] [modem4/ttyUSB3/at] closing serial
        port...
        <debug> [1626211401.112771] [modem4/ttyUSB3/at] serial port closed

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/401

 plugins/simtech/77-mm-simtech-port-types.rules | 5 +++++
 1 file changed, 5 insertions(+)

commit 06682e2806d2bceef8c8f63b49e84989465a2d33
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 16:45:16 2021 +0200

    bearer-mbim: never update bearer properties sent by the user

    We should never run any mm_bearer_properties_set_X() operations
    ourselves for the properties received by the user, or otherwise the
    logic comparing the bearers will fail and we may end up creating one
    bearer per connection attempt.

 src/mm-bearer-mbim.c | 28 ++++++++++++++++------------
 1 file changed, 16 insertions(+), 12 deletions(-)

commit daf72fe169f40bcb637a0a4db1a763bd54909d20
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 15:47:38 2021 +0200

    base-bearer: setup common default for unknown multiplex fallback

    If the user doesn't provide a specific multiplex setting, we'll
    fallback to a predefined default.

    For now, the default is REQUESTED.

 src/mm-base-bearer.h      | 5 +++++
 src/mm-bearer-mbim.c      | 8 +++++---
 src/mm-bearer-qmi.c       | 4 ++--
 src/mm-broadband-bearer.c | 6 +++++-
 4 files changed, 17 insertions(+), 6 deletions(-)

commit c4b5879e45cce3eed6136131cefcdfd3f9590916
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 15:46:28 2021 +0200

    broadband-bearer: multiplexing is not supported in generic AT
    based bearer

 src/mm-broadband-bearer.c | 20 +++++++++++++++-----
 1 file changed, 15 insertions(+), 5 deletions(-)

commit 3e037dc158c6beb8372dc0027943e5c391cf0196
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jul 13 10:52:00 2021 +0200

    plugins: AT/QCDM/GPS port type hints only applicable to TTY ports

    There are modems out there, that reuse the same vid:pid for multiple
    USB layouts, so there may be port type hints that are not really
    applicable in all layouts.

    E.g. the EM7565 in MBIM layout uses interface #0 for the MBIM port,
    while in QMI layout it uses interface #0 for the QCDM port (which is
    what the port type hint included in MM states). With these rules, if
    we don't bind the port type hint to TTY ports only, we would be
    wrongly flagging the MBIM port as possible QCDM port:

        <debug> [plugin/sierra] probes required for port cdc-wdm0: 'mbim'
        <debug> [cdc-wdm0/probe] no AT/QMI/MBIM probing in possible
        QCDM port
        <debug> [cdc-wdm0/probe] port is not AT-capable
        <debug> [cdc-wdm0/probe] port is not QMI-capable
        <debug> [cdc-wdm0/probe] port is not MBIM-capable
        <debug> [cdc-wdm0/probe] port probing finished: no more probings
        needed

    Avoid this, by making sure all port type hints are added exclusively
    to TTY ports. It's not a perfect solution, but it's enough for the
    known cases.

 plugins/broadmobi/77-mm-broadmobi-port-types.rules |   8 +-
 plugins/cinterion/77-mm-cinterion-port-types.rules |  32 +--
 plugins/dell/77-mm-dell-port-types.rules           |  16 +-
 plugins/dlink/77-mm-dlink-port-types.rules         |   4 +-
 plugins/fibocom/77-mm-fibocom-port-types.rules     |  10 +-
 plugins/foxconn/77-mm-foxconn-port-types.rules     |  16 +-
 plugins/gosuncn/77-mm-gosuncn-port-types.rules     |   4 +-
 plugins/haier/77-mm-haier-port-types.rules         |   2 +-
 plugins/huawei/77-mm-huawei-net-port-types.rules   |  14 +-
 plugins/longcheer/77-mm-longcheer-port-types.rules | 166 +++++++-------
 plugins/mbm/77-mm-ericsson-mbm.rules               |  38 ++--
 plugins/mtk/77-mm-mtk-port-types.rules             |  28 +--
 plugins/nokia/77-mm-nokia-port-types.rules         |  26 +--
 plugins/quectel/77-mm-quectel-port-types.rules     |  48 ++--
 plugins/sierra/77-mm-sierra.rules                  |  12 +-
 plugins/simtech/77-mm-simtech-port-types.rules     |  40 ++--
 plugins/telit/77-mm-telit-port-types.rules         |  58 ++---
 plugins/tplink/77-mm-tplink-port-types.rules       |   2 +-
 plugins/x22x/77-mm-x22x-port-types.rules           |  44 ++--
 plugins/zte/77-mm-zte-port-types.rules             | 248
 ++++++++++-----------
 20 files changed, 408 insertions(+), 408 deletions(-)

commit 3ffa6b8960ba2178390dbbfff795cbe1cd6b9d47
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jul 12 22:10:41 2021 +0200

    shared-qmi: fix use of uninitialized memory

        ==636642== Syscall param socketcall.sendto(msg) points to
        uninitialised byte(s)
        ==636642==    at 0x5282BAC: send (in /usr/lib/libpthread-2.33.so)
        ==636642==    by 0x4EF20AF: UnknownInlinedFun (gsocket.c:3426)
        ==636642==    by 0x4EF20AF: g_socket_send_with_blocking
        (gsocket.c:3529)
        ==636642==    by 0x4EDF176: g_output_stream_write
        (goutputstream.c:242)
        ==636642==    by 0x4EDF2D4: g_output_stream_write_all
        (goutputstream.c:301)
        ==636642==    by 0x4A5CDAC: endpoint_send
        (qmi-endpoint-qmux.c:409)
        ==636642==    by 0x4A5B963: qmi_endpoint_send (qmi-endpoint.c:225)
        ==636642==    by 0x4A55408: qmi_device_command_abortable
        (qmi-device.c:2897)
        ==636642==    by 0x4A554C3: qmi_device_command_full
        (qmi-device.c:2923)
        ==636642==    by 0x4B52664:
        qmi_client_nas_set_system_selection_preference (qmi-nas.c:61099)
        ==636642==    by 0x1F6FDC: register_in_network_sssp
        (mm-shared-qmi.c:455)
        ==636642==    by 0x1F71E6: mm_shared_qmi_3gpp_register_in_network
        (mm-shared-qmi.c:505)
        ==636642==    by 0x19FCF0: mm_iface_modem_3gpp_register_in_network
        (mm-iface-modem-3gpp.c:484)
        ==636642==  Address 0x880a3b3 is 19 bytes inside a block of size
        32 alloc'd
        ==636642==    at 0x484383F: realloc (vg_replace_malloc.c:1192)
        ==636642==    by 0x50DC130: g_realloc (gmem.c:171)
        ==636642==    by 0x50A067C: g_array_maybe_expand (garray.c:1009)
        ==636642==    by 0x50A0A0C: UnknownInlinedFun (garray.c:520)
        ==636642==    by 0x50A0A0C: g_array_append_vals (garray.c:509)
        ==636642==    by 0x50A0A9E: g_byte_array_append (garray.c:2430)
        ==636642==    by 0x4A4B70D: qmi_message_tlv_write_guint8
        (qmi-message.c:686)
        ==636642==    by 0x4B14CA8:
        __qmi_message_nas_set_system_selection_preference_request_create
        (qmi-nas.c:33477)
        ==636642==    by 0x4B525B6:
        qmi_client_nas_set_system_selection_preference (qmi-nas.c:61087)
        ==636642==    by 0x1F6FDC: register_in_network_sssp
        (mm-shared-qmi.c:455)
        ==636642==    by 0x1F71E6: mm_shared_qmi_3gpp_register_in_network
        (mm-shared-qmi.c:505)
        ==636642==    by 0x19FCF0: mm_iface_modem_3gpp_register_in_network
        (mm-iface-modem-3gpp.c:484)
        ==636642==    by 0x1B0BD4: check_next_registration
        (mm-iface-modem-simple.c:154)

 src/mm-shared-qmi.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a61422761f52cc359303ec92c2cae122bdf16b4b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jul 12 21:51:24 2021 +0200

    iface-modem: ignore warning when trying to disconnect signal handler

    The signal handler may have been already removed during dispose of the
    modem object, which is run manually through g_object_run_dispose().

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/399

 src/mm-iface-modem.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit b983deaa40b9b68c1a6684df416e38fff2328e28
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jul 12 15:41:21 2021 +0200

    iface-modem: refactor new SIM slots array creation

 src/mm-iface-modem.c | 64
 ++++++++++++++++++++++++----------------------------
 1 file changed, 29 insertions(+), 35 deletions(-)

commit 503e886c02e074b4cd334476569f42ee5c27e255
Author: Pavan Holla <pholla@chromium.org>
Date:   Sat May 22 19:33:19 2021 +0000

    shared-qmi,iface-modem : Do not reprobe on hotswap in inactive slot

    Prior to this change, a hotswap on the inactive slot would result
    in reprobe of the modem. With this change, the sim object would be
    updated, but no reprobe will be performed. The advantage is
    1) we do not drop connections on the active slot
    2) Slot status on the inactive slot is susceptible to firmware bugs.
       We have seen scenarios where the inactive slot is reported as
       absent/ iccid={0}, followed by a correction. We should not
       reprobe the modem if our active slot hasn't changed.

 src/mm-iface-modem.c |  72 +++++++++++++++++++++++
 src/mm-iface-modem.h |   4 ++
 src/mm-shared-qmi.c  | 160
 +++++++++++++++++++++++++++++++++++++++++++++++----
 3 files changed, 225 insertions(+), 11 deletions(-)

commit 4102cbc700a0489e5d398bb93f47c151783dbea9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jul 11 15:30:02 2021 +0200

    cinterion: ignore Intel Firmware Update service completely

 plugins/cinterion/mm-broadband-modem-mbim-cinterion.c | 1 +
 1 file changed, 1 insertion(+)

commit 5cc5bfbb97d0e8c4a70fe18ffbc68db9d5704ddb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jul 11 15:24:33 2021 +0200

    broadband-modem-mbim: allow disabling the use of the Intel Firmware
    Update service

    Not all manufacturers expect this service to be used for the simple
    purpose of reseting the modem.

    It works with Sierra Wireless devices (e.g. EM7345,
    XMM7160_V1.1_MODEM_01.1349.12), but it doesn't work with Cinterion
    devices (e.g. mPLS62-w, XMM7160_V1.1_MBIM_NAND_ADAPT_R).

    So allow plugins to disable its use entirely.

 src/mm-broadband-modem-mbim.c | 33 +++++++++++++++++++++++++++------
 src/mm-broadband-modem-mbim.h |  1 +
 2 files changed, 28 insertions(+), 6 deletions(-)

commit dc09d3350c5a21750c6609d14681d458098c737a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jul 11 15:16:25 2021 +0200

    cinterion,shared: add missing interface prerequisites

 plugins/cinterion/mm-shared-cinterion.c | 3 +++
 1 file changed, 3 insertions(+)

commit b126e84b56dfe52b91e882ef25ecdeb7341324b3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jul 10 17:18:25 2021 +0200

    cinterion: implement custom shared reset operation

    Implemented for all QMI, MBIM and AT based modems. The parent reset
    operation always takes priority if available.

 plugins/cinterion/mm-broadband-modem-cinterion.c   | 35 +++------
 .../cinterion/mm-broadband-modem-mbim-cinterion.c  | 20 +++++
 .../cinterion/mm-broadband-modem-qmi-cinterion.c   | 20 +++++
 plugins/cinterion/mm-shared-cinterion.c            | 87
 +++++++++++++++++++++-
 plugins/cinterion/mm-shared-cinterion.h            | 13 ++++
 5 files changed, 148 insertions(+), 27 deletions(-)

commit 3dd3d6faf6df1666d59b24c5329ed1da40d01112
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jul 10 16:59:20 2021 +0200

    cinterion: new custom MBIM modem object

 plugins/Makefile.am                                |   6 +
 .../cinterion/mm-broadband-modem-mbim-cinterion.c  | 147
 +++++++++++++++++++++
 .../cinterion/mm-broadband-modem-mbim-cinterion.h  |  47 +++++++
 plugins/cinterion/mm-plugin-cinterion.c            |  12 +-
 4 files changed, 206 insertions(+), 6 deletions(-)

commit 17876994c473ee244df17dec42c1a79e08407e2c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 9 12:05:38 2021 +0200

    utils: remove custom g_ptr_array_find_with_equal_func()

    This was required when building with GLib < 2.54, but we now require
    2.56 as minimum, so it is no longer needed.

 src/Makefile.am |  2 +-
 src/mm-utils.c  | 47 -----------------------------------------------
 src/mm-utils.h  | 12 ------------
 3 files changed, 1 insertion(+), 60 deletions(-)

commit dc66ee2aaadefd56f17681e95454748a958d96f3
Author: Benoît Monin <benoit.monin-ext@alstomgroup.com>
Date:   Fri Jul 9 11:37:20 2021 +0200

    libmm-glib,common-helpers: fix build with glib 2.56

    The support of autoptr for GEnumClass and GFlagsClass was introduced
    in
    glib 2.58. To keep compatibility with glib 2.56, declare the autoptr
    cleanup functions.

    Fixes #397

 libmm-glib/mm-common-helpers.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 63f3dcb2fe3dee42fe223751c5394a751e7ecc42
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jul 9 10:45:09 2021 +0200

    iface-modem: don't fail enabling if modem_power_up() isn't implemented

    There are modems (e.g. Nokia, Thuraya, Iridium) which don't require or
    don't support power management, and therefore there is no way to
    either load or update the power status.

    In those modems we just assume ON is the current and only value (set
    in the skeleton during initialization) and so when we attempt to
    update the power state to ON during enabling, the logic should not
    break.

    Fix the logic by making sure the requested_power_setup() function
    pointers are only checked for validity after ensuring we're not
    already in the desired power state.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/398

 src/mm-iface-modem.c | 17 +++++++++--------
 1 file changed, 9 insertions(+), 8 deletions(-)

commit 681d5d29d577ab4d2d822bb42ccbb74ac7d73b95
Author: Stephan Gerhold <stephan@gerhold.net>
Date:   Sat Jun 5 16:31:33 2021 +0200

    qcom-soc: Add support for WWAN subsystem instead of RPMSG

    Recent Linux kernel versions have introduced a generic WWAN subsystem
    that provides various char devices for QMI, AT etc, similar to the
    subsystem-specific char devices for USB or RPMSG.

    The RPMSG char device for Qualcomm SoCs (e.g. MSM8916/MSM8974)
    are particularly complicated to work with because they need to be
    explicitly created from userspace with rpmsgexport and don't show up
    automatically.

    However, it turns out it's fairly simple to wrap the RPMSG subsystem
    in a simple driver for the WWAN subsystem. This has several
    advantages:

      - We can drop support for the special RPMSG char devices entirely
        at some point.
      - The WWAN char devices show up automatically, without having
      to export
        them explicitly, making ModemManager work out of the box on
        these devices.

    For now, just support using the WWAN subsystem alternatively for the
    qcom-soc plugin. Later we can consider dropping the old RPMSG code.

 plugins/qcom-soc/77-mm-qcom-soc.rules              | 3 ++-
 plugins/qcom-soc/mm-broadband-modem-qmi-qcom-soc.c | 2 +-
 plugins/qcom-soc/mm-plugin-qcom-soc.c              | 2 +-
 3 files changed, 4 insertions(+), 3 deletions(-)

commit ea645522faf4a0c65ed16fdd91a81f4a99f6c8ad
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Mon Jul 5 14:33:30 2021 +0530

    modem-qmi: implement voice unsolicited events and process
    all_call_status indication

 src/mm-broadband-modem-qmi.c | 271
 ++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 267 insertions(+), 4 deletions(-)

commit a0ef2f403f4d53e12b4aae7e76f84fe53d941630
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Mon Jul 5 14:31:26 2021 +0530

    modem-qmi: implement voice check support and create call functionality

 src/mm-broadband-modem-qmi.c | 60
 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 60 insertions(+)

commit 630f96f4a47d943614a641f0aba741186dff213a
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Mon Jul 5 14:03:38 2021 +0530

    call-qmi: implement call start, hangup and accept

 src/mm-call-qmi.c | 305
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 305 insertions(+)

commit 788442c6d5c50dfd3e014bf91bf8906cd0469574
Author: Joel Selvaraj <jo@jsfamily.in>
Date:   Mon Jul 5 13:41:37 2021 +0530

    call-qmi: new `MMCallQmi' object

 src/Makefile.am   |  2 ++
 src/mm-call-qmi.c | 60
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-call-qmi.h | 52 +++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 114 insertions(+)

commit 266e98e0204bf170fb497d07323e377aeb005631
Author: Alexander Dahl <ada@thorsis.com>
Date:   Wed Jul 7 14:50:53 2021 +0200

    ublox: Mark ubandsel as unsupported on SARA-R4 and -N4

    See log from a SARA-R410M-02B-01 before the change:

        Feb 01 05:40:01 unit ModemManager[304]: <debug>
        [1612158001.012330] [modem0/ttymxc4/at] --> 'AT+UBANDSEL?<CR>'
        Feb 01 05:40:01 unit ModemManager[304]: <debug>
        [1612158001.026831] [modem0/ttymxc4/at] <--
        '<CR><LF>ERROR<CR><LF>'
        Feb 01 05:40:01 unit ModemManager[304]: <debug>
        [1612158001.027113] [modem0/ttymxc4/at] operation failure: 100
        (Unknown error)
        Feb 01 05:40:01 unit ModemManager[304]: <warn>
        [1612158001.027298] [modem0] couldn't load current bands:
        Unknown error

    Backed by SARA-R4 series AT commands manual, no reference to +UBANDSEL
    in the manual at all.

    Log after the change:

        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.500845] [modem0] (u-blox) support configuration
        found for 'SARA-R410M-02B'
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.500961] [modem0] (u-blox)   band update requires
        explicit unregistration
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.501052] [modem0] (u-blox)   UACT based band
        configuration unsupported
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.501141] [modem0] (u-blox)   UBANDSEL based band
        configuration unsupported

    Fixes: 437fb830c807 ("ublox,helpers: assume all SARA/LARA devices
    require COPS")
    Signed-off-by: Alexander Dahl <ada@thorsis.com>

 plugins/ublox/mm-modem-helpers-ublox.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 7c9d1e45be41cda914ac52e15de6755cc817008e
Author: Alexander Dahl <ada@thorsis.com>
Date:   Wed Jul 7 14:27:54 2021 +0200

    ublox: Add more values to URAT combinations

    The SARA-R410M-02B-01 only supports values 7 and 8, log excerpt:

        Feb 01 05:40:00 unit ModemManager[304]: <debug>
        [1612158000.826046] [modem0/ttymxc4/at] --> 'AT+URAT=?<CR>'
        Feb 01 05:40:00 unit ModemManager[304]: <debug>
        [1612158000.833596] [modem0/ttymxc4/at] <-- '<CR><LF>+URAT:
        (7-8),(7-8)(7-8)<CR><LF><CR><LF>OK<CR><LF>'
        Feb 01 05:40:00 unit ModemManager[304]: <warn>
        [1612158000.833992] [modem0] (u-blox) unexpected AcT value: 7
        Feb 01 05:40:00 unit ModemManager[304]: <warn>
        [1612158000.834096] [modem0] (u-blox) unexpected AcT value: 8
        Feb 01 05:40:00 unit ModemManager[304]: <warn>
        [1612158000.834193] [modem0] couldn't load supported modes:
        No combinations built from +URAT=? response

    The SARA-R4 series AT commands manual (and also the SARA-R5 AT
    commands
    manual) lists them like this:

    - 7: LTE Cat M1
    - 8: LTE Cat NB1

    After the change, log looks like this:

        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.490627] [modem0/ttymxc4/at] --> 'AT+URAT?<CR>'
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.499994] [modem0/ttymxc4/at] <-- '<CR><LF>+URAT:
        7,8<CR><LF><CR><LF>OK<CR><LF>'
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.500433] [modem0] (u-blox) current allowed modes
        retrieved: 4g
        Feb 01 06:58:25 unit ModemManager[329]: <debug>
        [1612162705.500561] [modem0] (u-blox) current preferred modes
        retrieved: 4g

    Signed-off-by: Alexander Dahl <ada@thorsis.com>

 plugins/ublox/mm-modem-helpers-ublox.c | 2 ++
 1 file changed, 2 insertions(+)

commit 052eb267c87e5fd8fb60f12922f9af31834ad49c
Author: Nicholas Smith <nicholas@nbembedded.com>
Date:   Sat Jul 3 16:20:39 2021 +1000

    docs: add --output-json documentation

    Signed-off-by: Nicholas Smith <nicholas@nbembedded.com>

 docs/man/mmcli.1 | 4 ++++
 1 file changed, 4 insertions(+)

commit 46c5cd8b7279e6139466664f87d744a0553fa1c3
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Jun 25 15:29:41 2021 +0200

    mm-sim-mbim: Remove update of remaining attempts

    Calling the mm_iface_modem_update_unlock_retries function directly
    from
    pin_set_enter_ready caused a notification to be send too early with
    invalid number of attempts to unlock on MBIM modems.
    The mm_iface_modem_update_unlock_retries is already called for all
    modems from send_pin_ready (mm-base-sim.c).

 src/mm-sim-mbim.c | 53
 -----------------------------------------------------
 1 file changed, 53 deletions(-)

commit bf9005df071841361041b271609f608b185bc3ce
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat Jul 3 22:48:08 2021 +0200

    api,location: update TAC documentation to allow 3-byte values in 5GNR

 introspection/org.freedesktop.ModemManager1.Modem.Location.xml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 132fc268b8a17bfdec787f131491ed7fb7862fe7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 22:42:45 2021 +0200

    libmm-glib,call: use helper macros to manage the monitored properties

 libmm-glib/mm-call.c | 91
 +++++-----------------------------------------------
 1 file changed, 8 insertions(+), 83 deletions(-)

commit 19b3a552308443e691f6120b07d4ba06086b887a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 22:31:12 2021 +0200

    libmm-glib,bearer: use helper macros to manage the monitored
    properties

 libmm-glib/mm-bearer.c | 452
 +++++--------------------------------------------
 1 file changed, 42 insertions(+), 410 deletions(-)

commit 5012c1a3f3cb6f7d5f78f83bfbf72796758a2492
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 23:37:45 2021 +0200

    libmm-glib,modem-signal: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-signal.c | 323
 ++++++++-----------------------------------
 1 file changed, 60 insertions(+), 263 deletions(-)

commit b8e939ceaca15d3f8bf1f153f93187f2e4f42ae4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 23:28:30 2021 +0200

    libmm-glib,modem-location: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-location.c | 188
 +++++++++--------------------------------
 1 file changed, 42 insertions(+), 146 deletions(-)

commit 6372d97e878f1d18cbbb62a809c78e44ee957814
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 22:47:43 2021 +0200

    libmm-glib,modem-firmware: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-firmware.c | 88
 ++++--------------------------------------
 1 file changed, 8 insertions(+), 80 deletions(-)

commit 1ecbc5e025e2af0b4986c90a7a463f9a82a5360e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 22:52:31 2021 +0200

    libmm-glib,modem-time: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-time.c | 77
 +++++-----------------------------------------
 1 file changed, 8 insertions(+), 69 deletions(-)

commit f72a6377f3994c398b39134b1a62ea2a6e0ce998
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 15:21:28 2021 +0200

    libmm-glib,modem-oma: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-oma.c | 104
 ++++------------------------------------------
 1 file changed, 8 insertions(+), 96 deletions(-)

commit 434d7be3f27d04437a357f0a79aeaddc4ad39f24
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 23:03:36 2021 +0200

    libmm-glib,modem-messaging: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-messaging.c | 105
 +++-------------------------------------
 1 file changed, 8 insertions(+), 97 deletions(-)

commit ccefbbc0c67bd3a2a1538ced6b2ce84a742b9877
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 23:00:06 2021 +0200

    libmm-glib,modem-3gpp: use helper macros to manage the monitored
    properties

 libmm-glib/mm-modem-3gpp.c | 94
 ++++++----------------------------------------
 1 file changed, 12 insertions(+), 82 deletions(-)

commit d7acc276e520add0c1a4751824b86f904a8a46ad
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 21:50:11 2021 +0200

    libmm-glib,modem: use helper macros to manage the monitored properties

 libmm-glib/mm-common-helpers.c |  27 ++
 libmm-glib/mm-common-helpers.h |   3 +
 libmm-glib/mm-modem.c          | 611
 +++--------------------------------------
 3 files changed, 74 insertions(+), 567 deletions(-)

commit 22396a7d1d7e845771cd1063c66dd0a7127d4eb1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 00:04:44 2021 +0200

    libmm-glib,helpers: new helper macros to define common property
    management

 libmm-glib/mm-helpers.h | 289
 +++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 288 insertions(+), 1 deletion(-)

commit afc7e5f9022ecec2e1ec388c9f8c48fb7c16a2b9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 15:01:11 2021 +0200

    libmm-glib: use single mutex in each type to sync access

    There is truly no need for a per-property mutex, using a global one
    for the whole object is equally fine.

 libmm-glib/mm-bearer.c          |  77 +++++++++++-------------------
 libmm-glib/mm-call.c            |  32 +++++--------
 libmm-glib/mm-modem-3gpp.c      |  28 ++++-------
 libmm-glib/mm-modem-firmware.c  |  28 ++++-------
 libmm-glib/mm-modem-location.c  |  28 ++++-------
 libmm-glib/mm-modem-messaging.c |  25 +++++-----
 libmm-glib/mm-modem-oma.c       |  25 +++++-----
 libmm-glib/mm-modem-signal.c    |  37 +++++----------
 libmm-glib/mm-modem-time.c      |  35 +++++---------
 libmm-glib/mm-modem.c           | 102
 ++++++++++++++--------------------------
 10 files changed, 149 insertions(+), 268 deletions(-)

commit 30c9fc65dacd2fb5df3913032a420e750a6ae054
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jul 1 14:47:53 2021 +0200

    libmm-glib,common-helpers: refactor helper methods

    Remove unused methods, like all the variant_to_array() ones, and
    reorder some others so that both header and source file have the same
    order always.

 libmm-glib/mm-common-helpers.c | 1483
 +++++++++++++++++++---------------------
 libmm-glib/mm-common-helpers.h |  266 +++----
 2 files changed, 845 insertions(+), 904 deletions(-)

commit c9ca1ab97b14ca988989976e97e1d302dd2c0f2e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 10:46:02 2021 +0200

    cli,location: new '--location-monitor' action

    This action allows us to monitor location updates as signaled via the
    'Location' property, only available if location signaling has been
    explicitly enabled (e.g. with --location-set-enable-signal)

 cli/mmcli-modem-location.c | 54
 +++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 53 insertions(+), 1 deletion(-)

commit 6364c9818c46d5455c4fd4edc747156e9f49a775
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 11:00:35 2021 +0200

    iface-modem-location: print 0-prefixed LAC/TAC/CID values in log

    Each with its expected corresponding length.

 src/mm-iface-modem-location.c | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit b385fc20b01ac971080a20b36d2e81f26f051370
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 10:31:53 2021 +0200

    cli,location: TAC is 3 bytes in 5GNR

    TAC is 3 bytes for NG-RAN as specified in 3GPP TS 38.413 clause
    9.3.3.10 and in 3GPP TS 24.501 clause 9.10.3.8.

    We'll always print it as 3 bytes in the cli output, as that's also
    backwards compatible with the original 2 byte TAC in LTE.

 cli/mmcli-modem-location.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f226b6330115c39c3b209f84452729a0e412da24
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 10:14:17 2021 +0200

    libmm-glib,location: new signaled location API support

    We allow clients to receive asynchronous updates of location
    information, e.g. if "location signaling" is explicitly enabled (with
    the setup() method).

    But if so, we should also allow clients to easily process those
    asynchronous updates in the libmm-glib library, instead of requiring
    them to run explicit DBus queries to refresh the location information.

    These new signaled location APIs allow clients to do so; they can
    enable location signaling, and then just wait for the updates to
    arrive.

 docs/reference/libmm-glib/libmm-glib-sections.txt |   9 +
 libmm-glib/mm-modem-location.c                    | 387
 ++++++++++++++++++++++
 libmm-glib/mm-modem-location.h                    |  14 +-
 3 files changed, 408 insertions(+), 2 deletions(-)

commit 4e4cb6d66acaec56960948ad3adfe7df359d2807
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 10:44:50 2021 +0200

    libmm-glib,location: build_locations() doesn't own the dictionary

    Rework the build_locations() method so that it doesn't take ownership
    of the input dictionary. This allows us reusing this method with
    dictionaries for which ownership cannot be transferred.

 libmm-glib/mm-modem-location.c | 31 +++++++++++++------------------
 1 file changed, 13 insertions(+), 18 deletions(-)

commit e1fbc1ccb74ba9c788d88c5f19fb89200a6478f6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 30 22:31:17 2021 +0200

    cinterion: fix double free when loading initial EPS context

    The properties object stored in the context is being returned as task
    result; so we should make sure that object is no longer left in the
    context so that it's not freed twice.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/395

 plugins/cinterion/mm-broadband-modem-cinterion.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 12613eac8791fb70b9fe45eb07440c559cc1e198
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 18:48:52 2021 +0200

    libmm-glib,modem: move deprecated methods to compat source

 libmm-glib/mm-compat.c | 10 ++++++++++
 libmm-glib/mm-compat.h | 29 +++++++++++++++++++++++++++++
 libmm-glib/mm-modem.c  | 37 -------------------------------------
 libmm-glib/mm-modem.h  |  5 -----
 4 files changed, 39 insertions(+), 42 deletions(-)

commit 4bf7657086e6ede28cfc2974c499cbe900a59152
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 18:43:06 2021 +0200

    libmm-glib,location-3gpp: move deprecated methods to compat source

 libmm-glib/mm-compat.c        | 15 +++++++++++++++
 libmm-glib/mm-compat.h        | 22 ++++++++++++++++++++++
 libmm-glib/mm-location-3gpp.c | 33 ---------------------------------
 libmm-glib/mm-location-3gpp.h |  5 -----
 4 files changed, 37 insertions(+), 38 deletions(-)

commit 219700ba6d9df49427320eb2cbfd8eae850b8921
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 18:37:28 2021 +0200

    libmm-glib,simple-status: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  3 ++-
 libmm-glib/mm-compat.c                            |  8 ++++++++
 libmm-glib/mm-compat.h                            | 18 ++++++++++++++++
 libmm-glib/mm-simple-status.c                     | 25
 -----------------------
 libmm-glib/mm-simple-status.h                     |  4 ----
 5 files changed, 28 insertions(+), 30 deletions(-)

commit a09b13de86fd62c9b5144ada2c23c6062e873ec1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:31:53 2021 +0200

    libmm-glib,pco: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  4 ++--
 libmm-glib/mm-compat.c                            |  8 ++++++++
 libmm-glib/mm-compat.h                            | 17 +++++++++++++++++
 libmm-glib/mm-pco.c                               | 21
 ---------------------
 libmm-glib/mm-pco.h                               |  7 -------
 5 files changed, 27 insertions(+), 30 deletions(-)

commit 27a192c1ef063f7c29668cf61739335dc02ecf87
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:28:55 2021 +0200

    libmm-glib,modem-3gpp: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  3 ++-
 libmm-glib/mm-compat.c                            |  8 ++++++
 libmm-glib/mm-compat.h                            | 25 ++++++++++++++++++
 libmm-glib/mm-modem-3gpp.c                        | 31
 -----------------------
 libmm-glib/mm-modem-3gpp.h                        |  7 -----
 5 files changed, 35 insertions(+), 39 deletions(-)

commit 6363add86a3a848be08def62f5c14f683fb0de34
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:24:20 2021 +0200

    libmm-glib,location-gps-nmea: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  3 +-
 libmm-glib/mm-compat.c                            | 11 ++++++
 libmm-glib/mm-compat.h                            | 20 +++++++++++
 libmm-glib/mm-location-gps-nmea.c                 | 43
 -----------------------
 libmm-glib/mm-location-gps-nmea.h                 |  5 ---
 5 files changed, 33 insertions(+), 49 deletions(-)

commit b38586a12cd1aca12ebdfa363f2c48773a7ca13b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:16:30 2021 +0200

    libmm-glib,simple-connect-properties: move deprecated methods to
    compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  5 ++-
 libmm-glib/mm-compat.c                            | 16 ++++++++
 libmm-glib/mm-compat.h                            | 34 ++++++++++++++++
 libmm-glib/mm-simple-connect-properties.c         | 48
 -----------------------
 libmm-glib/mm-simple-connect-properties.h         |  8 ----
 5 files changed, 53 insertions(+), 58 deletions(-)

commit febd5778e732d8f7fb5634c6557424578dfd75fa
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:10:21 2021 +0200

    libmm-glib,bearer-properties: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  5 ++-
 libmm-glib/mm-bearer-properties.c                 | 48
 -----------------------
 libmm-glib/mm-bearer-properties.h                 |  8 ----
 libmm-glib/mm-compat.c                            | 16 ++++++++
 libmm-glib/mm-compat.h                            | 34 ++++++++++++++++
 5 files changed, 53 insertions(+), 58 deletions(-)

commit c1fae670b77b0cac7f82ee540348f161f49d2fa3
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:05:33 2021 +0200

    libmm-glib,call-properties: move deprecated methods to compat source

 docs/reference/libmm-glib/libmm-glib-sections.txt |  14 ++-
 libmm-glib/mm-call-properties.c                   | 127
 ----------------------
 libmm-glib/mm-call-properties.h                   |  18 ---
 libmm-glib/mm-compat.c                            |  48 ++++++++
 libmm-glib/mm-compat.h                            | 101 +++++++++++++++++
 5 files changed, 157 insertions(+), 151 deletions(-)

commit 49f52d918240ef2e5d1c6b0af5d2013dab39f592
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 11:22:55 2021 +0200

    libmm-glib,location-gps-nmea: add missing type check in get_traces()

 libmm-glib/mm-location-gps-nmea.c | 2 ++
 1 file changed, 2 insertions(+)

commit c368a63e01dba01c966eac15c07486b82a15c14d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 10:56:38 2021 +0200

    libmm-glib,oma: deprecate method names without the mm_modem_oma prefix

 cli/mmcli-modem-oma.c                             |  2 +-
 docs/reference/libmm-glib/libmm-glib-docs.xml     |  5 ++
 docs/reference/libmm-glib/libmm-glib-sections.txt | 11 ++-
 libmm-glib/Makefile.am                            |  3 +
 libmm-glib/libmm-glib.h                           |  1 +
 libmm-glib/mm-compat.c                            | 45 ++++++++++++
 libmm-glib/mm-compat.h                            | 85
 +++++++++++++++++++++++
 libmm-glib/mm-modem-oma.c                         | 20 +++---
 libmm-glib/mm-modem-oma.h                         | 12 ++--
 9 files changed, 165 insertions(+), 19 deletions(-)

commit fefd59e3ce26f8248f94d40f2fb1f68085ca36ee
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Jun 25 10:36:25 2021 +0200

    libmm-glib,3gpp: fix initial-eps-bearer-settings property updates

 libmm-glib/mm-modem-3gpp.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce50d9c483639d7a7e62addab3eecba177c80a6a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 15:53:50 2021 +0200

    mmcli,messaging: fix leak when printing supported storages

 cli/mmcli-modem-messaging.c | 1 +
 1 file changed, 1 insertion(+)

commit dfeaec99ceb3ec5b6fd6ec7add1ce81978d68cfb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 15:40:21 2021 +0200

    libmm-glib,messaging: avoid array cleanup in get_supported_storages()

    If we return a reference to the internal array in
    ensure_internal_supported_storages() and then we free the array
    unconditionally in the caller, the next time we call it, the array
    would be valid, but it would be fully empty.

 libmm-glib/mm-modem-messaging.c | 44
 ++++++++++++++++++++++++-----------------
 1 file changed, 26 insertions(+), 18 deletions(-)

commit 059f13ffd33d6cf8c981119dd40e63e7abc2fe59
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 24 15:39:50 2021 +0200

    libmm-glib,modem: add missing input argument checks

 libmm-glib/mm-modem.c | 2 ++
 1 file changed, 2 insertions(+)

commit b0f40cf966e546a4173fdd4f8deb0f24eb7eb179
Author: Andrew Lassalle <andrewlassalle@chromium.org>
Date:   Tue Jun 22 14:43:59 2021 -0700

    port-qmi: Increase the reference counter of the QrtrNode

    Currently, we are not increasing the reference counter of the QrtrNode
    when creating a PortQmi for a QRTR port, and we are clearing the
    object
    when disposing the port.

 src/mm-port-qmi.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6175cf562f3225ef7eed4a4f5a314d1322fb571f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Jun 21 11:22:29 2021 +0200

    examples,modem-watcher-python: also monitor modem state updates

      $ sudo ./modem-watcher-python
      [ModemWatcher] ModemManager 1.16.6 service is available in bus
      [ModemWatcher] /org/freedesktop/ModemManager1/Modem/0: modem managed
      by ModemManager [015805000283080]: foxconn (MBIM [105B:E0AB])
      [ModemWatcher] /org/freedesktop/ModemManager1/Modem/0: modem state
      updated: disabled -> enabling (user-requested)
      [ModemWatcher] /org/freedesktop/ModemManager1/Modem/0: modem state
      updated: enabling -> enabled (user-requested)
      [ModemWatcher] /org/freedesktop/ModemManager1/Modem/0: modem state
      updated: enabled -> registered (unknown)

 examples/modem-watcher-python/ModemWatcher.py | 24
 ++++++++++++++++++------
 1 file changed, 18 insertions(+), 6 deletions(-)

commit a357777d39c87da89c285d496a48b53f294f1e4b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 12:27:47 2021 +0200

    port-qmi: apply master MTU handling to all multiplexing types
    in qmi_wwan

    If using rmnet and IP passthrough setting in qmi_wwan, also configure
    the master interface with an MTU equal to the maximum data aggregation
    size.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/367

 src/mm-port-qmi.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a8f086bfb3be65de133365b55595a9800ecaa681
Author: Alyssa Ross <hi@alyssa.is>
Date:   Thu Jun 17 15:06:41 2021 +0000

    tools: fix signal type in service test

    The signal definition is:

        <signal name="StateChanged">
          <arg name="old" type="i" />
          <arg name="new" type="i" />
          <arg name="reason" type="u" />
        </signal>

    So the first two arguments need to be adjusted.

    Without this change, the test was failing for me:

        (/build/source/tools/tests/.libs/lt-test-stub:77030):
        GLib-GObject-CRITICAL **: 15:05:35.276: ../gobject/gsignal.c:3167:
        value for 'gint' parameter 0 for signal "state-changed" is of type
        'guint'

 tools/test-modemmanager-service.py | 4 ++--
 tools/tests/test-stub.c            | 6 +++---
 2 files changed, 5 insertions(+), 5 deletions(-)

commit b100189f4991215594bfd2d136cff218d9baa22d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Jun 17 15:56:41 2021 +0200

    broadband-modem: plug memleak when listing profiles

      ==4263== 747 (72 direct, 675 indirect) bytes in 3 blocks are
      definitely lost in loss record 5,739 of 5,787
      ==4263==    at 0x4842839: malloc (in
      /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
      ==4263==    by 0x50C6DE8: g_malloc (in
      /usr/lib/x86_64-linux-gnu/libglib-2.0.so.0.6800.1)
      ==4263==    by 0x50DDFF1: g_slice_alloc (in
      /usr/lib/x86_64-linux-gnu/libglib-2.0.so.0.6800.1)
      ==4263==    by 0x50B8EB9: g_list_prepend (in
      /usr/lib/x86_64-linux-gnu/libglib-2.0.so.0.6800.1)
      ==4263==    by 0x27CE4C: mm_3gpp_parse_cgdcont_read_response
      (mm-modem-helpers.c:1845)
      ==4263==    by 0x1E5485: profile_manager_cgdcont_query_ready
      (mm-broadband-modem.c:10200)
      ==4263==    by 0x4ED54A1: g_simple_async_result_complete (in
      /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.6800.1)
      ==4263==    by 0x18605E: at_command_ready (mm-base-modem-at.c:538)
      ==4263==    by 0x4ED54A1: g_simple_async_result_complete (in
      /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.6800.1)
      ==4263==    by 0x25ADFA: serial_command_ready
      (mm-port-serial-at.c:393)
      ==4263==    by 0x4ED54A1: g_simple_async_result_complete (in
      /usr/lib/x86_64-linux-gnu/libgio-2.0.so.0.6800.1)
      ==4263==    by 0x254752: command_context_complete_and_free
      (mm-port-serial.c:141)

 src/mm-broadband-modem.c | 1 +
 1 file changed, 1 insertion(+)

commit 4c5733e49b0f57e97a7799e8e372003ebd461fef
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 21:23:27 2021 +0200

    build: version bump to flag existence of new API (firehose fw update)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f9231bad34c6d61928ccf08dae8e36eab7e26cc9
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 11:57:10 2021 +0200

    base-manager: skip using g_warning() in
    process_initial_kernel_events()

    Use mm_obj_warn() instead.

 src/mm-base-manager.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 4cf12bb8bc874d38d1ed5f67a77ad87c8cbb728d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 11:54:33 2021 +0200

    helpers: skip g_warning() in mm_3gpp_parse_ws46_test_response()

    Use mm_obj_warn() instead.

 plugins/telit/mm-broadband-modem-mbim-telit.c | 2 +-
 src/mm-broadband-modem.c                      | 4 ++--
 src/mm-modem-helpers.c                        | 3 ++-
 src/mm-modem-helpers.h                        | 1 +
 src/tests/test-modem-helpers.c                | 2 +-
 5 files changed, 7 insertions(+), 5 deletions(-)

commit 89bbc2ccb83c608dc95df7f073024f679b73786a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 11:52:18 2021 +0200

    core: dump fatal initialization errors to stderr

 src/main.c       | 2 +-
 src/mm-context.c | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 8905cf4670c260c332b1b8b84cc8cdb972937957
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 10:21:17 2021 +0200

    filter: trivial: reorder WWAN rule before the TTY ones

 docs/reference/api/ModemManager-overview.xml | 22 +++++++++++-----------
 src/mm-filter.h                              | 18 +++++++++---------
 2 files changed, 20 insertions(+), 20 deletions(-)

commit 9639e52726854782508e35a75c6abf874bd9e608
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 10:18:33 2021 +0200

    filter: remove support for TTY blacklist, TTY greylist and TTY
    default allowed

    These lists were used in the corresponding TTY_BLACKLIST and
    TTY_MANUAL_SCAN_ONLY filter rules, in the LEGACY and PARANOID filter
    types, which are no longer supported.

    The DEFAULT_ALLOWED filter rule made sense only in the LEGACY filter
    type, and therefore it is also now removed, leaving the
    DEFAULT_FORBIDDEN fallback rule exclusively. In other words, there is
    now no way to ask ModemManager to implicitly allow TTY ports; the only
    way to do that is by explicit making the TTY ports fall in one filter
    rule that would allow them.

 docs/reference/api/ModemManager-overview.xml |  52 +++----
 docs/reference/api/ModemManager-sections.txt |   5 +-
 src/77-mm-pcmcia-device-blacklist.rules      |   9 --
 src/77-mm-usb-device-blacklist.rules         | 213
 ---------------------------
 src/77-mm-usb-serial-adapters-greylist.rules |  50 -------
 src/Makefile.am                              |   3 -
 src/mm-filter.c                              |  36 +----
 src/mm-filter.h                              |  38 ++---
 8 files changed, 41 insertions(+), 365 deletions(-)

commit 00c1bbfd570492ff6661cfdda8d8a0dcb0e087a4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 10:06:43 2021 +0200

    filter: remove LEGACY and PARANOID filter types

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/390

 src/mm-context.c | 12 +-----------
 src/mm-filter.h  | 37 -------------------------------------
 2 files changed, 1 insertion(+), 48 deletions(-)

commit a02cd5ee934726d332fda39d76ba3dc4130a56b6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 10:01:56 2021 +0200

    docs: add missing references for several filter rules

 docs/reference/api/ModemManager-overview.xml | 44
 ++++++++++++++++++++++++++++
 1 file changed, 44 insertions(+)

commit 756f9c5e7572422148ebfa26a9cde0e507acc6ef
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 16 09:49:13 2021 +0200

    docs: remove LEGACY(DEFAULT) and PARANOID filter policy documentation

 docs/man/ModemManager.8                      |  8 +---
 docs/reference/api/ModemManager-overview.xml | 68
 ++--------------------------
 2 files changed, 6 insertions(+), 70 deletions(-)

commit 172b350871a93487fc80aafe0e5488c150dc806d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jun 15 21:56:32 2021 +0200

    api,tags: deprecate tags used in LEGACY and PARANOID filter types

 include/ModemManager-tags.h | 82
 ++++++++++++++++++++++++---------------------
 1 file changed, 43 insertions(+), 39 deletions(-)

commit 83ac82470589a3672092a0ba0be855093b1cf5e2
Author: Ivan Mikhanchuk <ivan.mikhanchuk@quectel.com>
Date:   Fri May 28 13:49:52 2021 -0700

    quectel: add support for EM120/160 PCIe modules

 plugins/Makefile.am                               |   6 +
 plugins/quectel/mm-broadband-modem-mbim-quectel.c | 132
 ++++++++++++++++++++++
 plugins/quectel/mm-broadband-modem-mbim-quectel.h |  48 ++++++++
 plugins/quectel/mm-plugin-quectel.c               |  29 +++--
 4 files changed, 207 insertions(+), 8 deletions(-)

commit 4165052e8ff8606e04b16ac3e81b93aca5de831d
Author: Ivan Mikhanchuk <ivan.mikhanchuk@quectel.com>
Date:   Fri May 28 14:37:42 2021 -0700

    api: add Firehose firmware update method

 include/ModemManager-enums.h | 2 ++
 1 file changed, 2 insertions(+)

commit 4b4ce6c44573ed72841d5f9c1c154e941bd900b6
Author: Ivan Mikhanchuk <ivanmikh@pm.me>
Date:   Tue Apr 27 21:33:12 2021 -0700

    port-serial: do not call config_fd on wwan qcdm port

    wwan qcdm port is not a serial port, calling config_fd on it
    will always fail, i.e.:
    ModemManager[124587]: <debug> [1619584182.125262] [wwan0p1QCDM/probe]
    probing QCDM...
    ModemManager[124587]: <debug> [1619584182.125398] [wwan0p1QCDM/qcdm]
    opening serial port...
    ModemManager[124587]: <debug> [1619584182.151759] [wwan0p1QCDM/qcdm]
    failed to configure serial device
    ModemManager[124587]: <warn>  [1619584182.151836] [wwan0p1QCDM/qcdm]
    failed to open serial device
    ModemManager[124587]: <warn>  [1619584182.170152] [plugin-manager]
    task 1,wwan0p1QCDM: error when checking support with plugin 'generic':
    (wwan/wwan0p1QCDM) Failed to open QCDM port: Failed to open QCDM
    port: -2

 src/mm-port-serial.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 611d59883606e30a226dd9066b503c3b857edd39
Author: Eric Caruso <ejcaruso@chromium.org>
Date:   Wed Jun 9 11:14:56 2021 -0700

    mm-sim-qmi: parse ICCID as hex instead of BCD

 src/mm-sim-qmi.c | 13 +++++++++----
 1 file changed, 9 insertions(+), 4 deletions(-)

commit 43d705ab933ee021ff1c4c0ea5075db205be7a40
Author: Stephan Gerhold <stephan@gerhold.net>
Date:   Wed Jun 9 14:51:18 2021 +0200

    udev: Ignore WWAN "FIREHOSE" ports

    FIREHOSE ports are used for firmware updates which are done
    independently from ModemManager, so we should ignore those ports.

    A similar change was originally made by Loic Poulain here:
    https://gitlab.freedesktop.org/loicpoulain/ModemManager/-/commit/32b0eb79cdbb37afe33abb72fd948be3cbaf6a2d

 src/80-mm-candidate.rules | 3 +++
 1 file changed, 3 insertions(+)

commit 4282c8d843a144f20f0e1bd9f632751af7a5ff70
Author: Stephan Gerhold <stephan@gerhold.net>
Date:   Wed Jun 9 13:49:08 2021 +0200

    udev: Match WWAN "type" attribute instead of device name

    Recent changes in the WWAN framework in the kernel changed the WWAN
    port names from e.g. "wwan0p1AT" and "wwan0p2QMI" to "wwan0at0" and
    "wwan0qmi0" [1, 2]. This means that the udev rules no longer match
    since AT/QMI are now lower-case and no longer at the end of the name.

    However, recently additionally a "type" sysfs attribute was added
    for all WWAN ports [3], which makes it much more reliable to match
    the WWAN port names without relying on their exact device name.

    Add some additional udev rules to apply the port hints based on the
    "type" sysfs attributes. This fixes the port enumeration on newer
    Linux kernels that include the aforementioned commits.

    Note that we still need to keep the old udev rules for now since
    Linux 5.13 does not have the "type" attribute yet.

    [1]:
    https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next.git/commit/?id=392c26f7f133b9f09e5f58db1ce6ef4b3b4df49f
    [2]:
    https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next.git/commit/?id=f458709ff40b0d992fec496952f79c7820dd3fde
    [3]:
    https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next.git/commit/?id=b3e22e10fdda8e7be3830289a4a63ae8b88d450c

 src/80-mm-candidate.rules | 6 ++++++
 1 file changed, 6 insertions(+)

commit ac18b5ac5bf841cd3a619a9e07137c332558d6c4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 6 14:45:27 2021 +0200

    udev: only flag as candidates the wwan ports, not the full device

    Explicitly ignore the "wwan_dev" device as it is not associated with
    separate ports (which is what MM needs), but with the whole device
    instead.

    See
    https://lists.freedesktop.org/archives/modemmanager-devel/2021-May/008629.html

 src/80-mm-candidate.rules | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 40c647ce3e88e646e00a0990340278b941aec242
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 6 12:15:56 2021 +0200

    Revert "api: QDU update method defined in MM 1.16.6 already"

    This reverts commit 6ffe84a122b9a79a8f0951af5ee5075f16726bdd.

 include/ModemManager-enums.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 464c0d464c758387ac3d35f4e148db2c4368edba
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Jun 6 12:11:08 2021 +0200

    core: skip suggesting FCC unlock may be needed

    This message is too specific, and there are a lot of cases where it
    wouldn't apply.

    E.g. when a MBIM module is stuck in low power mode due to some other
    reason (like hardware rfkill), this message would pop up to the users
    and completely confuse them.

 src/mm-broadband-modem-mbim.c | 3 +--
 src/mm-broadband-modem-qmi.c  | 2 +-
 2 files changed, 2 insertions(+), 3 deletions(-)

commit eefcf9204f2de801092b1d14d86c7012420e97af
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed Jun 2 09:56:00 2021 +0200

    shared-qmi: add missing g_autoptr() NULL initializer

 src/mm-shared-qmi.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c00eff43ac6eda070645d77edc8da71facd972a3
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Mon May 31 16:56:30 2021 +0200

    quectel: ignore QLWURC

    QLWURCs are not ignored and causes calls to be rejected in some cases

 plugins/quectel/mm-shared-quectel.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit e25a585c9fd8c3f58ec01723843fe3c08c30c1ad
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Jun 1 09:36:53 2021 +0200

    broadband-modem-mbim: skip switch() when selecting MBIM services

    Having a switch() for the MBIM services when processing indications
    forces us to update it on every new MBIM service added to libmbim,
    because we build with -Wswitch-enum by default.

    This warning type is extremely useful, and we should not stop using
    it, so let's simplify a bit the indication handling code and skip
    using a switch().

    There are right now only 4 different service indications expected, so
    it shouldn't be a big deal.

 src/mm-broadband-modem-mbim.c | 30 ++++--------------------------
 1 file changed, 4 insertions(+), 26 deletions(-)

commit 52bf2c641171ded9e617022f40497c8984520371
Author: Jarvis-Jiang-G <83380603+Jarvis-Jiang-G@users.noreply.github.com>
Date:   Mon May 31 17:19:50 2021 +0800

    mbim: Increase mbim_device_open_full timeout

    After fwupd upgrade with mbim-qdu method, MM sometimes generate
    plugin failed with the regenerated MHI driver.
    This patch increases the mbim_device_open_full timeout from 30
    seconds to 45 seconds to prevent such issue.
    Signed-off-by: Jarvis Jiang <jarvis.w.jiang@gmail.com>

 src/mm-port-mbim.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0b8607bc5dc4cce16ebb7c6a7bd71dfb3032d978
Author: Felipe Borges <felipeborges@gnome.org>
Date:   Thu May 27 15:05:55 2021 +0200

    cinterion: avoid maybe-uninitialized warning by GCC 10

    Reported at
    https://gitlab.gnome.org/GNOME/gnome-control-center/-/issues/1371

 plugins/cinterion/mm-modem-helpers-cinterion.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 695e9932db9cdf9351021ca4c6067de5712cdceb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 24 00:08:07 2021 +0200

    bearer-mbim: implement reload_connection_status()

    Implement connection status reloading for MBIM based bearers.

    Based on a patch by Dylan Van Assche <me@dylanvanassche.be>

 src/mm-bearer-mbim.c | 115
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 115 insertions(+)

commit a97bc9912fd20046da3987eec9a041985a8fc4f8
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 23:39:18 2021 +0200

    bearer-qmi: implement reload_connection_status() for the sync
    operation

    The original load_connection_status() method would return an
    UNSUPPORTED error if connection monitoring wasn't required (which is
    the default in most QMI modems).

    The new reload_connection_status() method requires the check to always
    be done unconditionally.

    We take most of the original logic in the load_connection_status() for
    the new reload_connection_status(), and we add the UNSUPPORTED error
    logic exclusively in the new load_connection_status().

 src/mm-bearer-qmi.c | 91
 +++++++++++++++++++++++++++++++++++++++++------------
 1 file changed, 71 insertions(+), 20 deletions(-)

commit 6fae479bd76db6c8cc69b3db2da3ef9707a3484c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 22:21:54 2021 +0200

    plugins: ignore reload_connection_status() where not supported

    Some of the AT-based connection methods don't have any way to query
    connection status, or we don't have a proper implementation for those
    yet. Ignore the reload operation in all those.

 plugins/altair/mm-broadband-bearer-altair-lte.c | 4 ++++
 plugins/huawei/mm-broadband-bearer-huawei.c     | 4 ++++
 plugins/icera/mm-broadband-bearer-icera.c       | 4 ++++
 plugins/iridium/mm-bearer-iridium.c             | 4 ++++
 plugins/mbm/mm-broadband-bearer-mbm.c           | 4 ++++
 plugins/option/mm-broadband-bearer-hso.c        | 4 ++++
 6 files changed, 24 insertions(+)

commit 4038c243f9c73292bc0807a17158409fd947da9d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 22:19:40 2021 +0200

    cinterion: reuse the same method for load and reload

    The load_() method is used for connection monitoring; while the
    reload_() method is used to sync connection status after a
    suspend/resume operation. The same method can be used for both things
    in the Cinterion plugin.

 plugins/cinterion/mm-broadband-bearer-cinterion.c | 4 ++++
 1 file changed, 4 insertions(+)

commit c188ba3c159309d4ab1b3715d83a1624426a2c5a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 22:17:25 2021 +0200

    sierra: reuse the same method for load and reload

    The load_() method is used for connection monitoring; while the
    reload_() method is used to sync connection status after a
    suspend/resume operation. The same method can be used for both things
    in the Sierra plugin.

 plugins/sierra/mm-broadband-bearer-sierra.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 205f46620e305d4ff1d2e52ca9ad0d76f27bc2bc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 22:14:49 2021 +0200

    novatel-lte: reuse the same method for load and reload

    The load_() method is used for connection monitoring; while the
    reload_() method is used to sync connection status after a
    suspend/resume operation. The same method can be used for both things
    in the Novatel LTE plugin.

 plugins/novatel/mm-broadband-bearer-novatel-lte.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 2466ddbdaf402be0f7fccca589d8df0931c56322
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 22:11:08 2021 +0200

    broadband-bearer: reuse the same method for load and reload

    The load_() method is used for connection monitoring; while the
    reload_() method is used to sync connection status after a
    suspend/resume operation. The same method can be used for both things
    in the case of AT+CGACT? based modems.

 src/mm-broadband-bearer.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 6c1d4808b1b331dd39039a12b157a3b544bcbec7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 21:46:34 2021 +0200

    base-bearer: ignore cancellation during sync()

    There is no input cancellable in the method, so the GTask will never
    get cancelled from the outside.

 src/mm-base-bearer.c | 6 ------
 1 file changed, 6 deletions(-)

commit e096b50208cfceb0c3e7156db344f6b19485f13a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 21:40:20 2021 +0200

    iface-modem,bearer-list: sync all bearers one after the other

    Do not launch N checks for N bearers and ignore their result. Instead,
    go one by one, and report errors one by one.

 src/mm-bearer-list.c | 86
 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-bearer-list.h | 11 +++++++
 src/mm-iface-modem.c | 49 ++++++++++++++++++++++++------
 3 files changed, 136 insertions(+), 10 deletions(-)

commit e4f7da5624dc1dfc20373bf77bfc4f3309bacb61
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 21:17:42 2021 +0200

    base-bearer: propagate the new connection status after reload

    Just triggering a connection status reload won't change the actual
    bearer object state.

    We change the signature of the reload_connection_status_finish()
    method so that it returns the actual reloaded bearer connection
    status, and so both the load_ and reload_ methods can be implemented
    with exactly the same method, something that was not possible before.

    Once we get the new connection status reloaded, we apply it in the
    bearer object only if it's DISCONNECTED (and it wasn't DISCONNECTED
    before). This should cover the true real case we're interested in, and
    nothing else (i.e. we won't overcomplicate the logic attempting to
    handle disconnected->connected transitions detected in the sync()
    operation).

 src/mm-base-bearer.c | 29 +++++++++++++++++++++++------
 src/mm-base-bearer.h |  6 +++---
 2 files changed, 26 insertions(+), 9 deletions(-)

commit 8cfc2a237af78734b4e4f1d7d89f4782dacf9bcd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 15:51:51 2021 +0200

    base-bearer: fix connection reload completion

    If we called the class reload_connection_status() method, we should
    call the class reload_connection_status_finish() as well.

 src/mm-base-bearer.c | 10 +---------
 1 file changed, 1 insertion(+), 9 deletions(-)

commit 29a1c24538444eba275ac53ff7b84c71c443fb43
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 20:58:40 2021 +0200

    base-bearer: improve comments of the load/reload_connection_status()
    methods

 src/mm-base-bearer.h | 22 +++++++++++++++++++---
 1 file changed, 19 insertions(+), 3 deletions(-)

commit 8913bab1c5f085e3fcb5d7838617b7386ac35681
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sat Mar 20 16:23:14 2021 +0100

    base-bearer: synchronize state when resuming

    Refresh connection status on resume to confirm
    that the connection bearers are still valid.

 src/mm-base-bearer.c | 124
 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-base-bearer.h |  24 ++++++++++
 src/mm-iface-modem.c |  25 +++++++++++
 3 files changed, 173 insertions(+)

commit 0a99cca2777d858250c9edeb6931a9edb1b75676
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 15:43:52 2021 +0200

    iface-modem: ignore cancellation during sync()

    There is no input cancellable in the method, so the GTask will never
    get cancelled from the outside.

 src/mm-iface-modem.c | 6 ------
 1 file changed, 6 deletions(-)

commit 8a70dbe34b9c16844f465427cb6a19665aab3364
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 15:40:36 2021 +0200

    iface-modem: remove the signal quality enforced refresh during sync()

    when mm_iface_modem_refresh_signal() is called, we'll restart the
    signal quality refresh logic already, there is no need to request
    an enforced start.

    The enforced start was also modifying ctx->enabled unconditionally,
    which is really not ok. This logic would be enabled only when we're
    registered, and that logic is fine, no need to change that.

 src/mm-iface-modem-3gpp.c |  2 +-
 src/mm-iface-modem.c      | 29 +++++++----------------------
 src/mm-iface-modem.h      |  2 +-
 3 files changed, 9 insertions(+), 24 deletions(-)

commit 7156d5ee50edbb3a14ed93865294637aae4c1f9b
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:44:44 2021 +0200

    broadband-modem: abort sync if locked SIM card found

    We made sure that the after resume synchronization was only started on
    modems that had been enabled (and so unlocked). If we detect a locked
    SIM card during the sync operation, it's either because the SIM card
    was swapped, or because the modem was fully shutdown during the
    suspension (and so the SIM requires SIM-PIN again).

    Either way, we cannot sync the state cleanly at this point, we must
    trigger a full modem reprobe in order to move back the modem state to
    Locked.

 src/mm-broadband-modem.c | 26 +++++++++++++++-----------
 1 file changed, 15 insertions(+), 11 deletions(-)

commit 8a6b18198dd4f42b30233ae25017b57e63ab7e47
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:44:09 2021 +0200

    broadband-modem: fix state machine logic when synchronizing modem
    interface

 src/mm-broadband-modem.c | 1 +
 1 file changed, 1 insertion(+)

commit 14325d85a83f3a299d13c1eae00da9c01178cc85
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:34:35 2021 +0200

    broadband-modem: fail synchronization if no modem exported in DBus

 src/mm-broadband-modem.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 0e47ba404174fcebedf4a349971d1eb07f2d714b
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sun Mar 14 09:53:49 2021 +0100

    iface-modem: synchronize state when resuming

    Refresh signal strength and access technologies,
    check for SIM swaps, and check if the SIM is locked.
    The modem may have switched to a different
    access technologies or have a different signal strength
    when resuming. Moreover, the user may swap or remove
    the SIM when suspended.

 src/mm-broadband-modem.c  |  44 ++++++++++++
 src/mm-iface-modem-3gpp.c |   2 +-
 src/mm-iface-modem.c      | 177
 ++++++++++++++++++++++++++++++++++++++++++++--
 src/mm-iface-modem.h      |  13 +++-
 4 files changed, 228 insertions(+), 8 deletions(-)

commit 3afa8e6f3b241bb6858d8062d643761542a87976
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:32:20 2021 +0200

    broadband-modem: skip 3GPP interface sync if no 3GPP support

 src/mm-broadband-modem.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 890694e0c38b9f36985f1bc4b54916078f0bb82f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:26:12 2021 +0200

    broadband-modem: fix type in the ready() for iface_modem_3gpp_sync()

    When calling an async method ona given type, the convention is to use
    the same type in the corresponding ready() method, so that we can use
    it without additional casts on the finish().

 src/mm-broadband-modem.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e716a306b1a6cc654523f6b911f15213d85acc85
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 15:44:22 2021 +0200

    iface-modem-3gpp: ignore cancellation during sync()

    There is no input cancellable in the method, so the GTask will never
    get cancelled from the outside.

 src/mm-iface-modem-3gpp.c | 6 ------
 1 file changed, 6 deletions(-)

commit e46e36b36ef798d4fa2669f211ab6213bf35c672
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:17:57 2021 +0200

    iface-modem-3gpp: remove redundant log message

    It doesn't give us any valuable information, so just remove it.

 src/mm-iface-modem-3gpp.c | 1 -
 1 file changed, 1 deletion(-)

commit 7c5e27caf96b777c8fd5f8bfdd612346ef1957b4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:15:30 2021 +0200

    iface-modem-3gpp: fix double GError free on registration sync failure

 src/mm-iface-modem-3gpp.c | 7 ++-----
 1 file changed, 2 insertions(+), 5 deletions(-)

commit 5b3709e61ed12cef6763b87f1eed4936dee89931
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:14:27 2021 +0200

    iface-modem-3gpp: use g_autoptr() for the MMBearerProperties
    during sync

 src/mm-iface-modem-3gpp.c | 14 ++++++--------
 1 file changed, 6 insertions(+), 8 deletions(-)

commit 84aa134ad9c94ed42cdc1f8387e8fbf227ee4103
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sat Mar 13 19:28:19 2021 +0100

    iface-modem-3gpp: synchronize state when resuming

    On resume, refresh the EPS bearers and 3GPP registration
    as the registration and bearers may expired during suspend.

 src/mm-broadband-modem.c  |  31 ++++++++
 src/mm-iface-modem-3gpp.c | 177
 ++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-iface-modem-3gpp.h |  12 ++++
 3 files changed, 220 insertions(+)

commit a9868638a7fe7eca953902743fc569ec12e1483d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 15:44:45 2021 +0200

    iface-modem-time: ignore cancellation during sync()

    There is no input cancellable in the method, so the GTask will never
    get cancelled from the outside.

 src/mm-iface-modem-time.c | 6 ------
 1 file changed, 6 deletions(-)

commit ac1ff45f44615d7f9bd5f8cbd758be32fb96f705
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 14:31:13 2021 +0200

    broadband-modem: skip time interface sync if no time support

 src/mm-broadband-modem.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 41db2e5e820f222ce36b6fd228054642edfb4746
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sat May 1 15:53:55 2021 +0200

    iface-modem-time: synchronize state when resuming

    On resume, fetch the current network time as
    the network time may be changed when suspended.

 src/mm-broadband-modem.c  | 30 +++++++++++++++++
 src/mm-iface-modem-time.c | 84
 +++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-iface-modem-time.h | 12 +++++++
 3 files changed, 126 insertions(+)

commit e58d525826c7693a6c2cf3a31485b62d870e59d2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:35:07 2021 +0200

    broadband-modem: skip synchronization after resume if not needed

    The synchronization after resume should only be needed on enabled
    modems, as otherwise there is really no chance that the state of the
    modem may have changed during suspend.

    E.g. if a modem is failed because it doesn't have a SIM card, or if
    the SIM-PIN is locked, or if the modem has never been enabled, there
    is no point in attempting to synchronize the runtime state of the
    modem.

 src/mm-broadband-modem.c | 17 ++++++++++++++---
 1 file changed, 14 insertions(+), 3 deletions(-)

commit 42bc953749fc4f38aeb6430704a7f6571fbf1b23
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:28:02 2021 +0200

    broadband-modem: ignore cancellation during sync()

    There is no input cancellable in the method, so the GTask will never
    get cancelled from the outside.

 src/mm-broadband-modem.c | 6 ------
 1 file changed, 6 deletions(-)

commit eaf14b8d79a61937a3b2fdac3e862629a737f1a7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 26 10:36:47 2021 +0200

    base-modem: make sync() available only if suspend-resume enabled

 src/mm-base-modem.c | 4 ++++
 src/mm-base-modem.h | 6 ++++++
 2 files changed, 10 insertions(+)

commit eb5ae16ac4f3f65d698bdc378ce903ed60952689
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:23:59 2021 +0200

    base-modem: don't fail if sync() isn't implemented

 src/mm-base-modem.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 728e6cd39810a75af4907e19fb2bd5ca6b211b00
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:19:06 2021 +0200

    base-modem: fix modem_sync() operation handling

    The mm_base_modem_sync() method is an asynchronous method that
    receives a callback and user data, and therefore we MUST always
    complete the async method calling that callback. Set that up with a
    GTask as usual.

    Also, the mm_base_modem_sync_finish() method should be implemented
    along with mm_base_modem_sync(), not in the source file of the
    caller of the async method. The finish() always depends on how the
    async method was implemented, in our case using a GTask.

 src/mm-base-manager.c |  7 -------
 src/mm-base-modem.c   | 34 +++++++++++++++++++++++++---------
 2 files changed, 25 insertions(+), 16 deletions(-)

commit 6397aacfdbd8cd69524f3fc8adb722509a0cc05a
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:18:42 2021 +0200

    base-manager: avoid using the `mm_` prefix for static private methods

 src/mm-base-manager.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 8f48ba21af64a20fa7ae42169fb794e30f91e8fc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:17:40 2021 +0200

    base-manager: don't assume a MMDevice always holds a MMModem

    There are cases, e.g. during modem object disposal, where this is not
    true.

 src/mm-base-manager.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 01223b2d4dd61d3a3801543981791927b0746a66
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 12:16:55 2021 +0200

    base-manager: make sure g_autoptr() variables are initialized to NULL

    Otherwise, we may have memory issues if the variable isn't initialized
    and the method exits.

 src/mm-base-manager.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 38740e9d11a52f91e41349a62caf35f8e1a67f48
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Sat May 1 15:50:47 2021 +0200

    base-manager: add quick suspend/resume base

    Quick suspend/resume infrastructure for
    synchronizing the interfaces when resuming.

 src/main.c               | 14 ++++++++-
 src/mm-base-manager.c    | 48 ++++++++++++++++++++++++++++
 src/mm-base-manager.h    |  4 +++
 src/mm-base-modem.c      | 25 +++++++++++++++
 src/mm-base-modem.h      | 17 ++++++++++
 src/mm-broadband-modem.c | 81
 ++++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-context.c         | 11 +++++++
 src/mm-context.h         |  1 +
 8 files changed, 200 insertions(+), 1 deletion(-)

commit 940063419a1c2eb9f6e197d60b4c7cb42702de8d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 25 15:42:11 2021 +0200

    base-manager: ensure all GUdevDevices have subsystem and name set

    Under certain rare conditions (e.g. race between querying devices of a
    given subsystem and the kernel tearing those devices down), the
    subsystem reported for a GUdevDevice seems to be NULL.

    So, ensure both subsystem and name are set on the GUdevDevice
    before we
    process them.

    The issue has been observed on GUdevDevices listed by
    g_udev_client_query_by_subsystem(), not on the ones asynchronously
    reported via uevents, but we add the validity check on both places for
    consistency.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/343

 src/mm-base-manager.c | 30 +++++++++++++++++++++++++-----
 1 file changed, 25 insertions(+), 5 deletions(-)

commit 10651ba93f89ed1320b5a88ae11679230bcac4fc
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Mar 25 00:26:25 2021 +0100

    quectel: the generic AT based modem supports SIM hot swap

 plugins/quectel/mm-broadband-modem-quectel.c | 2 ++
 1 file changed, 2 insertions(+)

commit e4f106f311c106fb375dbfda7690ae5d67e68193
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Mar 25 00:25:44 2021 +0100

    broadband-modem-qmi: assume all QMI based modems support SIM hot swap

    As we have a generic SIM hot swap implementation in the QMI broadband
    modem object.

 plugins/cinterion/mm-broadband-modem-qmi-cinterion.c | 2 ++
 plugins/qcom-soc/mm-broadband-modem-qmi-qcom-soc.c   | 3 +++
 plugins/quectel/mm-broadband-modem-qmi-quectel.c     | 2 ++
 plugins/simtech/mm-broadband-modem-qmi-simtech.c     | 2 ++
 src/mm-broadband-modem-qmi.c                         | 2 ++
 5 files changed, 11 insertions(+)

commit 58f28c2a45f1e2c290a6c2d9fd78fc742c702486
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 26 12:28:50 2021 +0200

    ci: build with artifacts only in master and tags

 .gitlab-ci.yml | 13 +++++++++++--
 1 file changed, 11 insertions(+), 2 deletions(-)

commit 342b0ba6488f053ea62f57243373756ad6c1c117
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 26 12:27:04 2021 +0200

    ci: don't trigger build on branches or pushes

    We rely on merge requests to merge new changes, so let's free a bit
    the number of pipelines we launch, and avoid doing it on every branch
    update.

 .gitlab-ci.yml | 2 --
 1 file changed, 2 deletions(-)

commit 3da3623e11f90e45951118119da6f842053fd133
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 00:38:09 2021 +0200

    broadband-modem: check if skeleton exists when creating device id

    The logic that creates the device identifier uses some fields that are
    exposed in DBus (e.g. model, manufacturer...).

    We should not attempt to load any of that info if the DBus skeleton
    for the Modem interface is no longer available, as e.g. the device may
    have gone away already.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/374

 src/mm-broadband-modem-mbim.c | 16 ++++++++++------
 src/mm-broadband-modem-qmi.c  | 16 ++++++++++------
 src/mm-broadband-modem.c      | 36 +++++++++++++++++++++++++-----------
 src/mm-broadband-modem.h      |  7 ++++---
 4 files changed, 49 insertions(+), 26 deletions(-)

commit 1f10b3ff7f2e9cf8a72859fc7340bc60bb189c2e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 00:31:04 2021 +0200

    broadband-modem: trivial coding style fix

 src/mm-broadband-modem.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 4d095ae05bc41a4a03d66749507b20e9934700ca
Author: Dylan Van Assche <me@dylanvanassche.be>
Date:   Fri Mar 12 20:31:53 2021 +0100

    mm-iface-modem: fix typo in step function

 src/mm-iface-modem.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 9695f23faf1a85b9dd7e40700cd22aa6de0b146d
Author: Michal Mazur <mkm@semihalf.com>
Date:   Wed May 5 18:51:33 2021 +0200

    iface-modem-3gpp: skip initialization in LOCKED state

 src/mm-iface-modem-3gpp.c | 51
 ++++++++++++++++++++++++++++++++++-------------
 1 file changed, 37 insertions(+), 14 deletions(-)

commit 83e7600a67d1c5952d0fada07ebe70dfef3492f6
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Apr 20 11:31:23 2021 +0200

    broadband-modem: allow 3GPP initialization before fallback

    To enable call to disable-facility-lock in LOCKED state,
    3gpp interface needs to be initialized before going to fallback step.

 src/mm-broadband-modem.c | 23 ++++++++++++-----------
 1 file changed, 12 insertions(+), 11 deletions(-)

commit d76c5c9bcd7b94b89f26a434235dd25297f5159b
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Apr 20 11:33:57 2021 +0200

    modem-qmi: detect personalization locks in LOCKED state

 src/mm-broadband-modem-qmi.c | 80
 ++++++++++++++++++++++++++++++++++++++++++--
 src/mm-modem-helpers-qmi.c   | 54 ++++++++++++++++++++++++++++++
 2 files changed, 132 insertions(+), 2 deletions(-)

commit c6b5045105a12098ddd8177f8a3c43d73e3f6680
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Apr 20 11:31:39 2021 +0200

    base-sim: ignore personalization locks after SIM unlock

 src/mm-base-sim.c | 9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit db5837d9b47f4de09f79f71bd5778874be81f58c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 01:18:30 2021 +0200

    docs,libmm-glib: add missing reference for DisableFacilityLock()
    support

 docs/reference/libmm-glib/libmm-glib-sections.txt | 7 +++++++
 1 file changed, 7 insertions(+)

commit 6c66152d1af648714e7859a4883537404f729cbe
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 23 01:16:53 2021 +0200

    docs,libmm-glib: add missing non-API methods to Private sections

 docs/reference/libmm-glib/libmm-glib-sections.txt | 4 ++++
 1 file changed, 4 insertions(+)

commit 6a56c5678c863a689468ae074527a3f411fee9ae
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 21:56:33 2021 +0200

    bearer-mbim: network error 0 is actually a valid error (unknown)

 src/mm-bearer-mbim.c | 12 +++---------
 1 file changed, 3 insertions(+), 9 deletions(-)

commit e233d033fc09e2a84f0fb47eb64d0fda6de4151e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 20:33:42 2021 +0200

    broadband-modem-mbim: detailed connection error on disconnection
    reports

    When we receive an indication reporting a network-initiated
    disconnection, convert the MBIM network error into a
    MMMobileEquipmentError, and publish it in the new 'ConnectionError'
    property.

 src/mm-broadband-modem-mbim.c | 37 +++++++++++++++++++++----------------
 1 file changed, 21 insertions(+), 16 deletions(-)

commit 59ffa01bb05dab5ef3678377e8480fd8e500e61d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 20:45:34 2021 +0200

    bearer-qmi: detailed connection error on disconnection reports

    When we receive an indication reporting a network-initiated
    disconnection, convert the QMI call end reason into a
    MMMobileEquipmentError, and publish it in the new 'ConnectionError'
    property.

 src/mm-bearer-qmi.c | 82
 +++++++++++++++++++++++++++++++++--------------------
 1 file changed, 52 insertions(+), 30 deletions(-)

commit 32995c8392f151157a0ce1b3c7f90fdb88222f60
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 23:13:24 2021 +0200

    base-bearer: never overwrite a connection error that is already set

 src/mm-base-bearer.c | 5 +++++
 1 file changed, 5 insertions(+)

commit ba53b6a64fe08401f0d2da3bd73c2fa34cbdc6f5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 21:30:38 2021 +0200

    base-bearer: limit the type of errors we can set as 'ConnectionError'

 src/mm-base-bearer.c | 43 +++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 41 insertions(+), 2 deletions(-)

commit a837ef4d81bb2eb359b47235625508a67cb8ca25
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 22:48:50 2021 +0200

    base-bearer: clear connection error on every new attempt

 src/mm-base-bearer.c | 3 +++
 1 file changed, 3 insertions(+)

commit 43db860c444da19d1a40df7d32903751e1d12638
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 18:29:21 2021 +0200

    base-bearer: report connection error on network initiated
    disconnections

    By default, fallback to "unknown" mobile equipment error when the
    modem gets disconnected by the network and we don't have any way to
    know a more detailed reason.

 plugins/huawei/mm-broadband-bearer-huawei.c |  8 ++++---
 plugins/icera/mm-broadband-bearer-icera.c   |  6 +++--
 plugins/mbm/mm-broadband-bearer-mbm.c       |  6 +++--
 plugins/option/mm-broadband-bearer-hso.c    |  7 +++---
 src/mm-base-bearer.c                        | 37
 +++++++++++++++++++++--------
 src/mm-base-bearer.h                        | 13 ++++++----
 src/mm-bearer-mbim.c                        |  7 +++---
 src/mm-bearer-qmi.c                         |  5 ++--
 src/mm-broadband-bearer.c                   |  8 ++++---
 9 files changed, 64 insertions(+), 33 deletions(-)

commit 7e8885d569d20259d1ae9f3c8c890ae9d4a2cd4d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 16:00:35 2021 +0200

    base-bearer: report connection error on failed connection attempts

    When a user-requested connection attempt fails, we not only return the
    connection error to the user that requested it, we also publish the
    specific connection error in DBus for others to check why the failure
    happened.

 src/mm-base-bearer.c | 20 +++++++++++++++++++-
 1 file changed, 19 insertions(+), 1 deletion(-)

commit de6b1324cb80413e552806f75c70be72cc41e933
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 17 21:33:32 2021 +0200

    api,bearer: new 'ConnectionError' property

    This new property will provide detailed information about the failed
    connection attempt, or about the network initiated disconnection. The
    property will be cleared only if a new connection attempt is
    triggered, and so it can be used to investigate why a given attempt
    failed without needing to be the one who triggered the attempt (e.g.
    so that failures in NetworkManager-triggered connection attempts can
    be investigated looking at the DBus API).

    The property is built as a (ss) tuple, but the libmm-glib interface
    provides methods to read this property as a GError.

 cli/mmcli-bearer.c                                 |  45 ++-
 cli/mmcli-output.c                                 | 380
 +++++++++++----------
 cli/mmcli-output.h                                 |   2 +
 docs/reference/libmm-glib/libmm-glib-sections.txt  |   5 +
 .../org.freedesktop.ModemManager1.Bearer.xml       |  14 +
 libmm-glib/mm-bearer.c                             | 119 +++++++
 libmm-glib/mm-bearer.h                             |   3 +
 libmm-glib/mm-common-helpers.c                     |  50 +++
 libmm-glib/mm-common-helpers.h                     |   5 +-
 9 files changed, 410 insertions(+), 213 deletions(-)

commit ff45d292ee75b0e49c3de3677211218445659884
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 10:41:55 2021 +0200

    libmm-glib: setup common helper to register DBus errors

 libmm-glib/mm-common-helpers.c | 22 ++++++++++++++++++++++
 libmm-glib/mm-common-helpers.h |  3 +++
 libmm-glib/mm-manager.c        | 20 ++------------------
 src/main.c                     | 25 ++++++++-----------------
 4 files changed, 35 insertions(+), 35 deletions(-)

commit 34a50edde100436a1bbb5249b8bbb812c4fde7c2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 17 22:46:15 2021 +0200

    api,errors: document all DBus error name prefixes

    Since ModemManager 1.0 we were publishing symbols to identify all the
    possible DBus error name prefixes, but these were never documented,
    they were explicitly ignored in gtk-doc.

    Let's provide proper documentation for them and make them first-class
    API symbols.

 docs/reference/api/ModemManager-sections.txt | 17 ++++-----
 include/ModemManager-errors.h                | 57
 +++++++++++++++++++++++++---
 2 files changed, 60 insertions(+), 14 deletions(-)

commit 6c56ea3b97a8e4afc568316753c0c48b3aeeacb6
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 17 23:09:04 2021 +0200

    docs,api: add index for 1.14

    Some of the newly deprecated enum values were introduced in 1.14.

 docs/reference/api/ModemManager-docs.xml | 4 ++++
 1 file changed, 4 insertions(+)

commit b9c66e92ea71f6f46519975bda5a01ebf58fb80d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 17 00:04:45 2021 +0200

    bearer-qmi: rework connection failure error reporting

    On a failed QMI modem connection, we won't return the generic
    "CallFailed" error, we'll try to convert the 3GPP verbose call end
    reason to a MMMobileEquipmentError.

    And if we cannot find a mapping, or if the reported error is not a
    3GPP verbose call end reason, we'll return a Unknown
    MMMobileEquipmentError with a string message providing detailed error
    information.

 src/mm-bearer-qmi.c        | 86
 +++++++++++++++++++++++++++++-----------------
 src/mm-modem-helpers-qmi.c | 73 +++++++++++++++++++++++++++++++++++++++
 src/mm-modem-helpers-qmi.h |  3 ++
 3 files changed, 131 insertions(+), 31 deletions(-)

commit a878cfa0036f6c0608c3e17697edff08ccd9fab1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 16 23:23:30 2021 +0200

    modem-helpers-mbim: rework nw error code mapping

    Instead of having a switch with a lot of cases, provide a one to one
    mapping for the MbimNwError and MMMobileEquipmentError codes in an
    array, and make use of the mm_mobile_equipment_error_for_code() helper
    to build the actual GError.

 src/mm-bearer-mbim.c          |   6 +-
 src/mm-broadband-modem-mbim.c |   9 +-
 src/mm-modem-helpers-mbim.c   | 255
 +++++++++++-------------------------------
 src/mm-modem-helpers-mbim.h   |   3 +-
 4 files changed, 79 insertions(+), 194 deletions(-)

commit 8da8fd0248fa619709aa2a17b1717e7981b641d0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 11 23:12:57 2021 +0200

    api: update MMMobileEquipmentError enum values

    Update the list of mobile equipment error codes according to v17.1.0
    of 3GPP TS 27.007 (March 2021).

    A lot of the enum values that were prefixed with the 'GPRS_' keyword
    have now been flagged as deprecated, and a new enum name given to the
    corresponding value.

    The deprecated symbol names are kept in the compat support to avoid
    breaking API/ABI.

 docs/reference/api/ModemManager-sections.txt |  43 +++
 include/ModemManager-compat.h                | 340 ++++++++++++++++++++++
 include/ModemManager-errors.h                | 417
 ++++++++++++++++++---------
 plugins/icera/mm-broadband-bearer-icera.c    |   2 +-
 plugins/ublox/mm-broadband-bearer-ublox.c    |   4 +-
 src/mm-error-helpers.c                       | 246 ++++++++++------
 src/mm-modem-helpers-mbim.c                  | 124 +++++---
 src/tests/test-error-helpers.c               |   4 +-
 8 files changed, 925 insertions(+), 255 deletions(-)

commit d1bd0a297103b426e3ec3afe310f1471c6c6dbae
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun May 16 22:03:10 2021 +0200

    core: improve error helpers

    First, simplify the logic that attempts to find the correct error code
    associated to an error text string. This logic is very flaky, as it
    relies on knowing what the modems report as text string for the
    different error codes, and obviously that is not always the same.
    Instead of supporting all error codes in this logic, we now limit them
    to a small subset with common error codes and hopefully common error
    strings.

    Second, in order to quickly get the error description string for a
    given error code, we rework the array of supported errors so that
    the index of the array is the error code itself. For mobile equipment
    errors the logic is straightforward, as they're always in the [0,255]
    range, but for the message errors we create an array where the index
    of the array is equal to the code plus 300 as they're always in the
    [300,500] range. By doing this, we avoid having an array with 300 NULL
    items before the actual values we want to support.

 src/mm-error-helpers.c         | 500
 ++++++++++++++++++++++-------------------
 src/tests/test-error-helpers.c |  85 +++++++
 2 files changed, 356 insertions(+), 229 deletions(-)

commit 9fdbbc6929cb61d4168e1696a94e5b2f07bc578e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 19 15:37:47 2021 +0200

    foxconn: setup FCC unlock step

    Use the new "DMS Foxconn Set FCC authentication" command to request
    the modem unlock during a power up operation.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/373

 configure.ac                                      |  2 +-
 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c | 67
 ++++++++++++++++++++++-
 2 files changed, 66 insertions(+), 3 deletions(-)

commit 76f24256174039a75926cdc0ce3a6b1f03ea10ee
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri May 21 15:48:31 2021 +0200

    broadband-modem-mbim: setup FCC unlock step

    Use the new generic FCC unlock step instead of implementing it within
    the power up setup logic.

 src/mm-broadband-modem-mbim.c | 219
 ++++++------------------------------------
 1 file changed, 30 insertions(+), 189 deletions(-)

commit b9596c81879b8eeae3f2e1bab5c31007e5824c1f
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 19 15:12:17 2021 +0200

    broadband-modem-qmi: setup FCC unlock step

    Use the new generic FCC unlock step instead of implementing it within
    the operating mode setup logic.

    The operation is implemented in the MMSharedQmi interface as it will
    also be used by the MBIM modem object.

 src/mm-broadband-modem-qmi.c | 240
 ++++++++++---------------------------------
 src/mm-shared-qmi.c          |  50 +++++++++
 src/mm-shared-qmi.h          |   6 ++
 3 files changed, 112 insertions(+), 184 deletions(-)

commit 6ca75c76db277b89325e1888ac445cbfebe33039
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 19 13:02:42 2021 +0200

    iface-modem: new optional FCC unlock step in the power state update

    There are devices that come locked before they can be put online.
    Until now we had a specific implementation for this in the generic QMI
    modem, but we should have it in a more generic way for any kind of
    modem.

 src/mm-iface-modem.c | 352
 +++++++++++++++++++++++++--------------------------
 src/mm-iface-modem.h |   8 ++
 2 files changed, 180 insertions(+), 180 deletions(-)

commit ec8bf7f0e39435f98d322d09a36b0d3e171a9ae7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 22 00:46:55 2021 +0200

    shared-qmi: trivial coding style update

 src/mm-shared-qmi.h | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 6ffe84a122b9a79a8f0951af5ee5075f16726bdd
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri May 21 23:46:28 2021 +0200

    api: QDU update method defined in MM 1.16.6 already

    (cherry picked from commit 2cb38c568ff1fb26b23bad5e8a2851547448c30e)

 include/ModemManager-enums.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d5c16382c5fac93464f8a68e5f65b255933c4c72
Author: Arnaud Ferraris <arnaud.ferraris@collabora.com>
Date:   Fri May 21 14:50:07 2021 +0200

    service: add QIPCRTR address family

    With the recently added support for modems using QRTR, ModemManager
    needs to have access to the corresponding address family so it can
    interact with the modem.

    Signed-off-by: Arnaud Ferraris <arnaud.ferraris@collabora.com>

 data/ModemManager.service.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a38162230407cb4a8ae28a062cb3c0438b12977c
Author: Undef <gitlab@undef.tools>
Date:   Thu May 20 10:12:47 2021 +0000

    service: Fix Mobile Data on EG25

    This allows mobile data to work on the EG25 (and probably other
    modems).

 data/ModemManager.service.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 18fe7856afd40640628f73491d2cb2d0faf2d844
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 21:59:16 2021 +0200

    base-bearer: trivial fix printing stats reports

 src/mm-base-bearer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d661d822f7fc2b31884eb10a586501765250ec2e
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 14:29:41 2021 +0200

    libmm-glib,common-helpers: avoid signed vs unsigned comparisons

      mm-common-helpers.c: In function 'mm_get_int_from_str':
      mm-common-helpers.c:1349:13: warning: comparison between signed
      and unsigned integer expressions [-Wsign-compare]
           if (eol == num)
                   ^~
      mm-common-helpers.c: In function 'mm_utils_hexstr2bin':
      mm-common-helpers.c:1718:19: warning: comparison between signed
      and unsigned integer expressions [-Wsign-compare]
           for (i = 0; i < len; i += 2) {
                         ^

 libmm-glib/mm-common-helpers.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 21ff48ed7d56837567aff3e396acf3bfd24cbc02
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 12:24:39 2021 +0200

    libmm-glib: drop default timeout checks in Command()

    The g_dbus_proxy_get_default_timeout() is by default -1 unless
    explicitly updated, so the check doesn't make any sense really. We
    didn't see any warning produced because mmcli provides an explicit
    timeout of 30s, so it was never the default -1.

 libmm-glib/mm-modem.c | 5 -----
 1 file changed, 5 deletions(-)

commit a325acd6b1ae3376bb0f9f3eb83ce44617115a55
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 12:07:45 2021 +0200

    libmm-glib: remove unused cmp_allow_roaming() method

      mm-bearer-properties.c:725:1: warning: 'cmp_allow_roaming' defined
      but not used [-Wunused-function]
       cmp_allow_roaming (gboolean                   a,
       ^~~~~~~~~~~~~~~~~

 libmm-glib/mm-bearer-properties.c | 19 -------------------
 1 file changed, 19 deletions(-)

commit 268cab885b62526bb97794cb6b9e8b0f97084841
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 18 11:28:18 2021 +0200

    core: drop "volatile" for g_once_init_enter locations

    This fixes a few (fatal in gcc 11) warnings.

    See https://gitlab.gnome.org/GNOME/glib/-/issues/600

 build-aux/mm-enums-template.c  |  8 +++----
 build-aux/mm-errors-template.c |  8 +++----
 src/mm-log.c                   |  2 +-
 src/mm-private-boxed-types.c   | 48
 +++++++++++++++++++++---------------------
 4 files changed, 33 insertions(+), 33 deletions(-)

commit 0ea6e01c9b26f89d7f1ffecfd2ad2e9b30a0824d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 17 14:29:35 2021 +0200

    libmm-glib,location-3gpp: fix string overflow

      mm-location-3gpp.c: In function
      ‘mm_location_3gpp_get_mobile_country_code’:
      mm-location-3gpp.c:139:12: warning: writing 1 byte into a region
      of size 0 [-Wstringop-overflow=]
        139 |     mcc[4] = '\0';
            |     ~~~~~~~^~~~~~
      mm-location-3gpp.c:132:11: note: at offset 4 to object ‘mcc’
      with size 4 declared here
        132 |     gchar mcc[4];
            |           ^~~

 libmm-glib/mm-location-3gpp.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5e629b8ea77d3af1aaedeaca7d1489cb68f6da27
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 15:13:46 2021 +0300

    broadband-modem-qmi: set MNC PCS digit in
    modem_3gpp_load_operator_name()

    If the network has three digit MNC and MNC < 100, set the PCS
    digit status
    field in the QMI request.

 src/mm-broadband-modem-qmi.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 1147d376cd4d575eb7178f7b47a3fc10efe0f72b
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 15:11:37 2021 +0300

    shared-qmi: set MNC PCS digit for manual network registration

    Set the MNC PCS digit status when attempting to register to a network
    with 3 digit MNC and MNC < 100.

 configure.ac        |  2 +-
 src/mm-shared-qmi.c | 26 +++++++++++++++++++++-----
 2 files changed, 22 insertions(+), 6 deletions(-)

commit 2471b950b0771d680020ef8debf108d7fbd6e3f2
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 15:09:23 2021 +0300

    sim-qmi: use mm_3gpp_parse_operator_id() for preferred PLMN MNC digits

    MNC PCS digit status is now available from
    mm_3gpp_parse_operator_id(),
    so use it.

 src/mm-sim-qmi.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 44671ced03c422347d2cc6912b7b3a7136eb5d40
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 14:42:47 2021 +0300

    cli,location: use mm_location_3gpp_get_operator_code() in location
    output

 cli/mmcli-modem-location.c | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

commit 879ec1a5d4418ae1dfc137844fd2c06a35ffeabf
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 14:35:41 2021 +0300

    libmm-glib,iface-modem-location: add MMLocation3gpp 3 digit MNC
    support

    MMLocation3gpp provides MCC/MNC information as integers, so it can not
    make distinction between operator codes such as XXX01 and XXX001.

    This commit deprecates mm_location_3gpp_get_mobile_network_code() and
    implements a new function mm_location_3gpp_get_operator_code() which
    provides the MCC+MNC in string format.

    The mm_location_3gpp_get_mobile_country_code() is still available as
    returning the MCC as an integer does not have ambiguity issues.

 docs/reference/libmm-glib/libmm-glib-sections.txt |   4 +-
 libmm-glib/mm-location-3gpp.c                     | 284
 +++++++++++++---------
 libmm-glib/mm-location-3gpp.h                     |  35 +--
 src/mm-iface-modem-3gpp.c                         |  12 +-
 src/mm-iface-modem-location.c                     |  19 +-
 src/mm-iface-modem-location.h                     |   5 +-
 6 files changed, 204 insertions(+), 155 deletions(-)

commit 14c4f27ae4a0ccdfec29090b9abd77112fec1516
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Thu May 6 14:48:18 2021 +0300

    modem-helpers: add 3 digit MNC output to mm_3gpp_parse_operator_id()

    MNC digit count information is lost on conversion to integers. Make it
    possible for the caller to get this information through a separate
    boolean.

 src/mm-broadband-modem-qmi.c   |  2 +-
 src/mm-iface-modem-3gpp.c      |  4 ++--
 src/mm-modem-helpers.c         |  4 ++++
 src/mm-modem-helpers.h         |  1 +
 src/mm-shared-qmi.c            |  2 +-
 src/mm-sim-qmi.c               |  2 +-
 src/tests/test-modem-helpers.c | 37 ++++++++++++++++++++-----------------
 7 files changed, 30 insertions(+), 22 deletions(-)

commit 98fbd5a156a09d3dc46dbc52946a80450df13abb
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 23:40:20 2021 +0200

    iface-modem-3gpp: don't assume operator code implies we're registered

    The modem may be camping in a forbidden network just for emergency
    services, and we'll be able to have a MCCMNC reported in that case,
    but this does not mean the modem is registered.

    So, don't consider that a valid registration flag during the new
    network registration request.

 src/mm-iface-modem-3gpp.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit af756a1bf7d8005f7bb4d7bfcccf5133ce57b54d
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sat May 15 22:56:12 2021 +0200

    port-qmi: avoid running install_properties() without properties
    defined

    We'll setup the properties only if QRTR support is being built,
    otherwise we fully skip all property related setup.

      (ModemManager:480463): GLib-GObject-CRITICAL **: 22:48:14.264:
      g_object_class_install_properties: assertion 'n_pspecs > 1' failed

      Thread 1 "ModemManager" received signal SIGTRAP, Trace/breakpoint
      trap.
      0x00007ffff76e3295 in ?? () from
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      (gdb) bt
      #0  0x00007ffff76e3295 in  () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #1  0x00007ffff76e4579 in g_logv () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #2  0x00007ffff76e4743 in g_log () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #3  0x00005555556af70c in mm_port_qmi_class_init
      (klass=0x5555557fae20) at mm-port-qmi.c:2619
      #4  0x00005555556a94c3 in mm_port_qmi_class_intern_init
      (klass=0x5555557fae20) at mm-port-qmi.c:34
      #5  0x00007ffff77ed1d1 in g_type_class_ref () at
      /lib/x86_64-linux-gnu/libgobject-2.0.so.0
      #6  0x00007ffff77d05e1 in g_object_new_valist () at
      /lib/x86_64-linux-gnu/libgobject-2.0.so.0
      #7  0x00007ffff77d06cd in g_object_new () at
      /lib/x86_64-linux-gnu/libgobject-2.0.so.0
      #8  0x00005555556af25a in mm_port_qmi_new (name=0x5555557e54e0
      "cdc-wdm0", subsys=MM_PORT_SUBSYS_USBMISC) at mm-port-qmi.c:2481
      #9  0x000055555563c8d7 in wdm_probe_qmi (self=0x5555557de1b0)
      at mm-port-probe.c:517
      #10 0x000055555563cc70 in wdm_probe (self=0x5555557de1b0) at
      mm-port-probe.c:623
      #11 0x00007ffff76dd04e in g_main_context_dispatch () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #12 0x00007ffff76dd400 in  () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #13 0x00007ffff76dd6f3 in g_main_loop_run () at
      /lib/x86_64-linux-gnu/libglib-2.0.so.0
      #14 0x00005555555b1ae4 in main (argc=1, argv=0x7fffffffe558)
      at main.c:213

 src/mm-port-qmi.c | 33 ++++++++++++++++-----------------
 1 file changed, 16 insertions(+), 17 deletions(-)

commit 7711e84af9354d1dfee64674a3e928d13586d5b1
Author: Andrew Lassalle <andrewlassalle@chromium.org>
Date:   Sat May 15 05:47:22 2021 -0700

    iface-modem-3gpp: Add verbose logging for initial eps bearer

    Print a debug message when the user provides initial eps bearer
    settings
    that match the ones being used. This will save time to whomever is
    experimenting with initial eps bearer settings.

 src/mm-iface-modem-3gpp.c | 1 +
 1 file changed, 1 insertion(+)

commit c39d1d2fbc62dca759efcf8dc5b80c69a45269de
Author: Loic Poulain <loic.poulain@linaro.org>
Date:   Wed May 12 13:18:00 2021 +0200

    udev: Do not consider USB WWAN ports as valid candidates

    For now WWAN subsystem support has only been validated for PCI/MHI
    based devices and extra patches for USB based devices (qmi_wwan,
    cdc-mbim...) may be required, so do not consider WWAN ports being
    on USB bus.

    Signed-off-by: Loic Poulain <loic.poulain@linaro.org>

 src/80-mm-candidate.rules | 4 ++++
 1 file changed, 4 insertions(+)

commit 76e700f4fd703f952208993330ab098305c13d6b
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Tue May 4 14:49:25 2021 +0800

    broadband-modem-mbim: get model through QMI-over-MBIM

    move the modem_load_model() async method from mm-broadband-modem-qmi.c
    to mm-shared-qmi.c, and then make use of the method from both the QMI
    and MBIM implementations.

 src/mm-broadband-modem-mbim.c | 45 +++++++++++++++++++++++++++---
 src/mm-broadband-modem-qmi.c  | 64
 ++-----------------------------------------
 src/mm-shared-qmi.c           | 60
 ++++++++++++++++++++++++++++++++++++++++
 src/mm-shared-qmi.h           |  6 ++++
 4 files changed, 109 insertions(+), 66 deletions(-)

commit bb928dbf7409b445e6aaab994c571fb7d504a8d7
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Wed May 12 22:11:50 2021 +0200

    iface-modem: fix segfault if attempting to switch slot and slots
    unsupported

    Reported and fix suggested by Maxim Anisimov

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/368

 src/mm-iface-modem.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f916d075a78ddacd25e2db9c4eebb99b490482ff
Author: goapunk <goapunk@riseup.net>
Date:   Sat May 8 13:23:56 2021 +0200

    modem-helpers-qmi: fix auth validation always returning error

 src/mm-modem-helpers-qmi.c | 15 +++++++++------
 1 file changed, 9 insertions(+), 6 deletions(-)

commit ba0701b67d3fc2e6936477bd08440ff36a3878aa
Author: Eric Caruso <ejcaruso@chromium.org>
Date:   Tue May 4 13:38:57 2021 -0700

    mm-shared-qmi: parse ICCID as hex instead of BCD

    Fixes issue 364.

 src/mm-shared-qmi.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 27c43075f9ee30ac2cdbeb4e166e8dcf02b09e79
Author: Andrew Lassalle <andrewlassalle@chromium.org>
Date:   Tue May 4 13:45:10 2021 -0700

    bearer-mbim: Fix double free in ip_configuration_query_ready

 src/mm-bearer-mbim.c | 1 -
 1 file changed, 1 deletion(-)

commit d77d8dff420dc70d6191b67e172e1df5c4e009bf
Author: Teijo Kinnunen <teijo.kinnunen@uros.com>
Date:   Tue May 4 14:14:15 2021 +0300

    libmm-glib,simple: fix docs: g_object_ref -> g_object_unref

 libmm-glib/mm-modem-simple.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 973b1bdec876180792d50cb9704eae23c11a6221
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue May 4 00:22:42 2021 +0200

    broadband-modem-mbim: use the new 'LTE attach info' message name

    The older 'LTE attach status' message name is deprecated.

 configure.ac                  |   2 +-
 src/mm-broadband-modem-mbim.c | 180
 +++++++++++++++++++++++++-----------------
 2 files changed, 109 insertions(+), 73 deletions(-)

commit e1567c30df5a0bf320b654cd85942bdff5db6144
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon May 3 00:10:00 2021 +0200

    foxconn: don't assume parent location is available

    If ModemManager is not built with QMI support, the generic MBIM modem
    object will not have any location support, so we cannot assume that
    iface_modem_location_parent will be valid and that it will have all
    load_location_capabilities(), enable_location_gathering() and
    disable_location_gathering() implemented.

    Fixes
    https://gitlab.freedesktop.org/mobile-broadband/ModemManager/-/issues/362

 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c | 113
 +++++++++++++++-------
 1 file changed, 79 insertions(+), 34 deletions(-)

commit 9e2c9cce975907c9da5c092645adbe60f4ce28a1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 11:53:27 2021 +0200

    iface-modem-3gpp: delete unused
    mm_iface_modem_3gpp_disable_facility_lock()

    The action of disabling facility locks is user-triggered, so there is
    no need to have an internal method to run the logic without user
    interaction.

 src/mm-iface-modem-3gpp.c | 50
 -----------------------------------------------
 src/mm-iface-modem-3gpp.h | 11 -----------
 2 files changed, 61 deletions(-)

commit d47babd5b7e792f60a63ec50f1154cc6b1658cb1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 11:46:42 2021 +0200

    api,introspection: fix DisableFacilityLock() documentation

      make[4]: Entering directory
      '/home/aleksander/Development/foss/ModemManager/docs/reference/api'
        DOC   Preparing build
        DOC   Building XML
        DOC   Scanning header files
        DOC   Introspecting gobjects
        DOC   Building XML
        DOC   Building HTML
      ../../../../libmm-glib/generated/mm-gdbus-doc-org.freedesktop.ModemManager1.Modem.Modem3gpp.xml:181:
      parser error : Opening and ending tag mismatch: variablelist line
      165 and para
      </para>
             ^

 introspection/org.freedesktop.ModemManager1.Modem.Modem3gpp.xml | 1 +
 1 file changed, 1 insertion(+)

commit 77fd343bb620765b541776652b239027b7f041f0
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 11:44:06 2021 +0200

    mmcli,3gpp: common method to parse --disable-facility-lock input
    string

 cli/mmcli-modem-3gpp.c | 58
 +++++++++++++++++++++++++++++++-------------------
 1 file changed, 36 insertions(+), 22 deletions(-)

commit c070ca82f8d29f0fc5cbb1048d238e312b242827
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 11:22:02 2021 +0200

    modem-helpers: improve logging on unhandled features when parsing
    UIM Get Configuration

 src/mm-modem-helpers-qmi.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 7f425d9b150f584de1e7d06a5f52a554caf78c6a
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Feb 26 22:58:26 2021 +0100

    broadband-modem: support disabling facility lock on MBIM and QMI
    modems

 src/mm-broadband-modem-mbim.c | 95
 +++++++++++++++++++++++++++++++++++++++++++
 src/mm-broadband-modem-qmi.c  | 85 ++++++++++++++++++++++++++++++++++++++
 2 files changed, 180 insertions(+)

commit e8edcedc9e80332a8dc862113acb05f8ed57b987
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Feb 26 22:57:04 2021 +0100

    modem-helpers: introduce functions to convert MMModem3gppFacility

 src/mm-modem-helpers-mbim.c | 28 ++++++++++++++++++++++++++++
 src/mm-modem-helpers-mbim.h |  2 ++
 src/mm-modem-helpers-qmi.c  | 25 +++++++++++++++++++++++++
 src/mm-modem-helpers-qmi.h  |  2 ++
 4 files changed, 57 insertions(+)

commit dfc04cbc2ede5e8c5a007fb79d0a2428c5648be4
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Jan 26 18:08:12 2021 +0100

    iface-modem-3gpp: define new API to disable facility locks

 data/org.freedesktop.ModemManager1.conf.polkit |   4 +
 src/mm-iface-modem-3gpp.c                      | 209
 +++++++++++++++++++++++++
 src/mm-iface-modem-3gpp.h                      |  22 +++
 3 files changed, 235 insertions(+)

commit 25ffe4211afa37a68274535d64a12670fd5ceebc
Author: Michal Mazur <mkm@semihalf.com>
Date:   Fri Dec 11 14:15:11 2020 +0100

    api,libmm-glib,cli: add command to disable facility lock

 cli/mmcli-completion                               |   4 +
 cli/mmcli-modem-3gpp.c                             | 100
 ++++++++++++++++++++-
 docs/man/mmcli.1                                   |  17 ++++
 ...g.freedesktop.ModemManager1.Modem.Modem3gpp.xml |  27 ++++++
 libmm-glib/mm-modem-3gpp.c                         |  50 +++++++++++
 libmm-glib/mm-modem-3gpp.h                         |  15 ++++
 6 files changed, 211 insertions(+), 2 deletions(-)

commit b1dde0aec39089161268452b54ea92737ae00aa5
Author: Michal Mazur <mkm@semihalf.com>
Date:   Thu Mar 4 15:03:50 2021 +0100

    libmm-glib: add helper to get 3gpp facility from string

 libmm-glib/mm-common-helpers.c | 10 ++++++++++
 libmm-glib/mm-common-helpers.h |  3 +++
 2 files changed, 13 insertions(+)

commit 2a2ae2819ceeb866eab587673f55cdae79b9f9d3
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Feb 16 21:31:02 2021 +0100

    broadband-modem-qmi: use UIM Get Configuration to probe all facility
    locks

 src/mm-broadband-modem-qmi.c | 66
 ++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 61 insertions(+), 5 deletions(-)

commit ab60f884038d0ecf43696bd39f4567d83c6652e5
Author: Michal Mazur <mkm@semihalf.com>
Date:   Tue Feb 16 21:19:43 2021 +0100

    modem-helpers-qmi: introduce parser for Get Configuration message

 src/mm-modem-helpers-qmi.c | 53
 ++++++++++++++++++++++++++++++++++++++++++++++
 src/mm-modem-helpers-qmi.h |  8 +++++++
 2 files changed, 61 insertions(+)

commit 0a7bfcfb423f4202b910af7f67563552160edcb4
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 29 20:54:13 2021 +0200

    build: require glib 2.56

    When using glib < 2.55.1 there was a bug in GLib triggering a huge
    amount of memory leaks in the normal ModemManager runtime. This has
    caused multiple issues in multiple setups, and so the best way to make
    sure it no longer happens is to require 2.56.

    The 2.56.0 glib version is also the one provided by Ubuntu 18.04 LTS,
    and so we can now say that this LTS release is the last one we support
    in newer MM releases. The previous Ubuntu 16.04 LTS is already out of
    the standard 5-year support.

 configure.ac | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 25a1b28fbfb398c3981cd1bb7305907119ff351c
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 12:26:25 2021 +0200

    core: strict return type in g_object_ref()

    This is now a requirement when using glib 2.56.

 plugins/cinterion/mm-broadband-bearer-cinterion.c |  6 ++---
 plugins/huawei/mm-broadband-bearer-huawei.c       |  2 +-
 plugins/mbm/mm-broadband-bearer-mbm.c             |  2 +-
 plugins/option/mm-broadband-bearer-hso.c          |  2 +-
 src/mm-base-manager.c                             |  8 +++----
 src/mm-bearer-mbim.c                              |  2 +-
 src/mm-broadband-modem-qmi.c                      | 26
 ++++++++++-----------
 src/mm-broadband-modem.c                          | 18 +++++++--------
 src/mm-device.c                                   |  4 ++--
 src/mm-shared-qmi.c                               | 28
 +++++++++++------------
 src/mm-sms-qmi.c                                  |  6 ++---
 11 files changed, 52 insertions(+), 52 deletions(-)

commit edee1e3f84b34b6a4bd6f230371a36ea03539af7
Author: Vincent Palatin <vpalatin@chromium.org>
Date:   Thu Apr 29 17:34:54 2021 +0200

    broadband-modem-qmi: ensure we do not re-use old EPS registration
    state

    When updating the registration state, in the case where LTE is
    not ready,
    ensure we reset the EPS registration state rather than leaving its old
    value.
    Else when the consolidated registration is built, it can wrongly think
    we are registered, e.g. the following case was happening:
    [modem0] consolidated registration state: cs 'home', ps 'home', eps
    'home', 5gs 'unknown' --> 'home'
    a bit later
    [modem0] consolidated registration state: cs 'unknown', ps 'unknown',
    eps 'home', 5gs 'unknown' --> 'home'
    then it wrongly tries immediatly to connect
    and fails due to 'no-service'

    On Qualcomm SC7180, running the following sequence would often
    reproduce
    it:
    <stop higher level network manager>
    mmcli -m 0 -d
    mmcli -m 0 --set-power-state-low
    sleep 10
    mmcli -m 0 -e
    mmcli -m 0 --simple-connect="apn=broadband"

 src/mm-broadband-modem-qmi.c | 2 ++
 1 file changed, 2 insertions(+)

commit c330d44343e9a34816732341642088b70d49ba78
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Fri Apr 30 10:45:14 2021 +0200

    build: version bump to flag existence of new API (QDU fw update)

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 35b1672b85d23e0961c33fc7aebc17d0e2d26c81
Author: Freedom Liu <tianyu28658@gmail.com>
Date:   Fri Apr 30 01:52:12 2021 +0000

    foxconn: add new MBIM QDU firmware update method support

    Based on the QDU service newly added in libmbim,
    T99W175 module (vid: 0x105b) supports MBIM QDU based update.

 include/ModemManager-enums.h                      |  2 ++
 plugins/foxconn/mm-broadband-modem-mbim-foxconn.c | 17 +++++++++++++----
 2 files changed, 15 insertions(+), 4 deletions(-)

commit d5041cc814934595c7ec3f30e9f0168b191dcea2
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 8 22:47:17 2021 +0200

    iface-modem-3gpp: ignore 'profile-id' and 'apn-type' matching initial
    EPS settings

    We should not try to match the 'profile-id', as that setting is not
    available in the input bearer settings provided by the user.

    And we should not try to match the 'apn-type', as not all
    implementations support it and it's not really necessary for this
    purpose anyway.

 src/mm-iface-modem-3gpp.c | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

commit 55f8e3b9a715f8122eb51ca8cb8a772552c604ef
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 8 12:41:58 2021 +0200

    broadband-modem-qmi: switch initial EPS bearer settings to use
    profile management

    The operation required to load/update the initial EPS bearer settings
    are completely the same as for profile management, because at the end
    the settings are bound to a specific profile id.

 src/mm-broadband-modem-qmi.c | 205
 +++++++++++--------------------------------
 1 file changed, 52 insertions(+), 153 deletions(-)

commit 0d60b9497bffa72bff9d4dba56574adf48113e71
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 8 11:58:52 2021 +0200

    bearer-qmi: implement connection logic using existing profiles

 src/mm-bearer-qmi.c | 166
 ++++++++++++++++++++++++++++++++++++++--------------
 1 file changed, 123 insertions(+), 43 deletions(-)

commit ce383abfe1997d74df25a7dfded4cc8875e79223
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 8 11:28:02 2021 +0200

    bearer-qmi: refactor connection context setup logic

    Place all the logic in a separate load_settings_from_bearer() method
    that takes care of propagating all bearer settings to the connect
    context.

 src/mm-bearer-qmi.c | 322
 +++++++++++++++++++++++-----------------------------
 1 file changed, 145 insertions(+), 177 deletions(-)

commit fffe49d03e650239390e0f65cc969b9713183488
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Thu Apr 8 11:15:21 2021 +0200

    modem-helpers-qmi: perform validation in
    allowed_auth_to_qmi_authentication()

    If we find that none of the requested auth settings are supported, we
    should fail and return an error.

    Also, make sure we set the CHAP fallback default only if either user
    or password are given.

 src/mm-bearer-qmi.c          | 29 +++++++++--------------------
 src/mm-broadband-modem-qmi.c | 14 +++++++++++---
 src/mm-modem-helpers-qmi.c   | 21 +++++++++++++++++++--
 src/mm-modem-helpers-qmi.h   |  4 +++-
 4 files changed, 42 insertions(+), 26 deletions(-)

commit 865014510a976fdccb1c59d5bcf41bd8cbfc46d1
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Apr 6 23:39:38 2021 +0200

    broadband-modem-qmi: implement profile management support

 configure.ac                 |   2 +-
 src/mm-broadband-modem-qmi.c | 640
 +++++++++++++++++++++++++++++++++++++++++++
 src/mm-modem-helpers-qmi.c   |  46 ++++
 src/mm-modem-helpers-qmi.h   |   3 +
 4 files changed, 690 insertions(+), 1 deletion(-)

commit 5d2db5de9823301ad49abe2406351889bef3bf92
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Tue Apr 6 16:07:09 2021 +0200

    bearer-mbim: implement connection logic using existing profiles

    Unlike other implementations, with MBIM we cannot tell the modem to
    connect a given profile by its profile number, which is a bit strange,
    but it looks like there is no way to do that. So, if the user requests
    to connect a given profile, what we do is load the profile settings by
    querying the modem, and use those settings in the connect request.

 src/mm-bearer-mbim.c | 372
 +++++++++++++++++++++++++++++----------------------
 1 file changed, 215 insertions(+), 157 deletions(-)

commit 72879e4095bde2ee354a61f475ebc8bc847541c5
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Mon Apr 5 00:07:01 2021 +0200

    broadband-modem-mbim: implement profile management support

    We use the "Provisioned Contexts" message support to add and edit
    profiles.

    We also use the same message, with context-type set to "none" to
    attempt deleting it, although that doesn't seem to be fully supported
    by all modems. E.g. the EM7345 (FIH7160_V1.1_MODEM_01.1349.12) will
    still report contexts 'deleted' in this way, with the context-type set
    to "none".º

 src/mm-broadband-modem-mbim.c | 535
 +++++++++++++++++++++++++++++++++++++++++-
 src/mm-modem-helpers-mbim.c   |  64 +++++
 src/mm-modem-helpers-mbim.h   |   4 +
 3 files changed, 590 insertions(+), 13 deletions(-)

commit 49b63cc62b46777c419b6a8e63629d228953fe95
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Apr 4 23:27:50 2021 +0200

    icera: implement profile management support

    Using AT%IPDPCFG for authentication related profile settings
    management (querying, updating), and relying on the parent
    implementation for the remaining ones.

    And using AT%IPDPACT for activation status management (deactivate),
    while relying on the parent implementation for the activated check.

 plugins/icera/mm-broadband-bearer-icera.c      | 202 ++---------
 plugins/icera/mm-broadband-modem-icera.c       | 450
 ++++++++++++++++++++++++-
 plugins/icera/mm-modem-helpers-icera.c         | 103 ++++++
 plugins/icera/mm-modem-helpers-icera.h         |   6 +
 plugins/icera/tests/test-modem-helpers-icera.c |  75 +++++
 5 files changed, 649 insertions(+), 187 deletions(-)

commit 887358663de820078f5632180cba53975809ebcf
Author: Aleksander Morgado <aleksander@aleksander.es>
Date:   Sun Apr 4 23:57:41 2021 +0200

    broadband-bearer: rely on profile management for the cid selection

